
#include "Common.h"
#define MessageMatches() (ThreadData.ReceivedMsg.Subchannel == Subchannel || Subchannel == -1)

#define LoopNameMatches(cond) \
	if (!LoopName || LoopName[0] == '\0') \
	{ \
		CreateError("Cannot detect condition "#cond": invalid loop name supplied."); \
		return false; \
	} \
	return !strcmp(ThreadData.Loop.Name, LoopName)

bool Extension::OnSentTextMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentTextMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentNumberMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentNumberMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedTextMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedNumberMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedTextMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedNumberMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentBinaryMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentBinaryMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedBinaryMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedBinaryMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentTextMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentNumberMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentBinaryMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedTextMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedNumberMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedBinaryMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::IsConnected()
{
	return Client.Connected();
}

bool Extension::OnAnySentMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnySentMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnySentMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnyBlastedMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnyBlastedMessageFromChannel(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnyBlastedMessageFromPeer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::ClientHasAName()
{
	return (Client.Name() && Client.Name()[0] == '\0');
}

bool Extension::SelectedPeerIsChannelMaster()
{
	return ThreadData.Peer->IsChannelMaster();
}

bool Extension::YouAreChannelMaster()
{
	return ThreadData.Channel->IsChannelMaster();
}

bool Extension::OnChannelListLoopWithName(char * LoopName)
{
	LoopNameMatches("Channel List Loop With Name");
}

bool Extension::OnChannelListLoopWithNameFinished(char * LoopName)
{
	LoopNameMatches("Channel List Loop With Name Finished");
}

bool Extension::OnPeerLoopWithName(char * LoopName)
{
	LoopNameMatches("Peer Loop With Name");
}

bool Extension::OnPeerLoopWithNameFinished(char * LoopName)
{
	LoopNameMatches("Peer Loop With Name Finished");
}

bool Extension::OnClientChannelLoopWithName(char * LoopName)
{
	LoopNameMatches("Client Channel Loop With Name");
}

bool Extension::OnClientChannelLoopWithNameFinished(char * LoopName)
{
	LoopNameMatches("Client Channel Loop With Name Finished");
}

bool Extension::OnSentTextChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentNumberChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnSentBinaryChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedTextChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedNumberChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnBlastedBinaryChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}

bool Extension::OnAnyBlastedChannelMessageFromServer(int Subchannel)
{
	return MessageMatches();
}



