
#include "Common.h"


///
/// EXTENSION CONSTRUCTOR/DESTRUCTOR
///

Extension::Extension(RUNDATA * _rdPtr, EDITDATA * edPtr, createObjectInfo * cobPtr) :
	rdPtr(_rdPtr), rhPtr(_rdPtr->rHo.AdRunHeader), Runtime(_rdPtr),
	Client(ObjEventPump), SendMsg(NULL), SendMsgSize(0), DenyReasonBuffer(NULL),
	PreviousName(NULL), Thread(NULL)
{
	// Nullify the thread-specific data
	memset(&ThreadData, 0, sizeof(SaveExtInfo));

	/*
        Link all your action/condition/expression functions to their IDs to match the
        IDs in the JSON here
    */
	{
		LinkAction(0, Replaced_Connect);
		LinkAction(1, Disconnect);
		LinkAction(2, SetName);
		LinkAction(3, Replaced_JoinChannel);
		LinkAction(4, LeaveChannel);
		LinkAction(5, SendTextToServer);
		LinkAction(6, SendTextToChannel);
		LinkAction(7, SendTextToPeer);
		LinkAction(8, SendNumberToServer);
		LinkAction(9, SendNumberToChannel);
		LinkAction(10, SendNumberToPeer);
		LinkAction(11, BlastTextToServer);
		LinkAction(12, BlastTextToChannel);
		LinkAction(13, BlastTextToPeer);
		LinkAction(14, BlastNumberToServer);
		LinkAction(15, BlastNumberToChannel);
		LinkAction(16, BlastNumberToPeer);
		LinkAction(17, SelectChannelWithName);
		LinkAction(18, ReplacedNoParams);
		LinkAction(19, LoopClientChannels);
		LinkAction(20, SelectPeerOnChannelByName);
		LinkAction(21, SelectPeerOnChannelByID);
		LinkAction(22, LoopPeersOnChannel);
		LinkAction(23, ReplacedNoParams);
		LinkAction(24, ReplacedNoParams);
		LinkAction(25, ReplacedNoParams);
		LinkAction(26, ReplacedNoParams);
		LinkAction(27, ReplacedNoParams);
		LinkAction(28, ReplacedNoParams);
		LinkAction(29, ReplacedNoParams);
		LinkAction(30, RequestChannelList);
		LinkAction(31, LoopListedChannels);
		LinkAction(32, ReplacedNoParams);
		LinkAction(33, ReplacedNoParams);
		LinkAction(34, ReplacedNoParams);
		LinkAction(35, SendBinaryToServer);
		LinkAction(36, SendBinaryToChannel);
		LinkAction(37, SendBinaryToPeer);
		LinkAction(38, BlastBinaryToServer);
		LinkAction(39, BlastBinaryToChannel);
		LinkAction(40, BlastBinaryToPeer);
		LinkAction(41, AddByteText);
		LinkAction(42, AddByteInt);
		LinkAction(43, AddShort);
		LinkAction(44, AddInt);
		LinkAction(45, AddFloat);
		LinkAction(46, AddStringWithoutNull);
		LinkAction(47, AddString);
		LinkAction(48, AddBinary);
		LinkAction(49, ClearBinaryToSend);
		LinkAction(50, SaveReceivedBinaryToFile);
		LinkAction(51, AppendReceivedBinaryToFile);
		LinkAction(52, AddFileToBinary);
		LinkAction(53, ReplacedNoParams);
		LinkAction(54, ReplacedNoParams);
		LinkAction(55, ReplacedNoParams);
		LinkAction(56, ReplacedNoParams);
		LinkAction(57, ReplacedNoParams);
		LinkAction(58, ReplacedNoParams);
		LinkAction(59, ReplacedNoParams);
		LinkAction(60, ReplacedNoParams);
		LinkAction(61, ReplacedNoParams);
		LinkAction(62, ReplacedNoParams);
		LinkAction(63, ReplacedNoParams);
		LinkAction(64, SelectChannelMaster);
		LinkAction(65, JoinChannel);
		LinkAction(66, CompressSendBinary);
		LinkAction(67, DecompressReceivedBinary);
		LinkAction(68, MoveReceivedBinaryCursor);
		LinkAction(69, LoopListedChannelsWithLoopName);
		LinkAction(70, LoopClientChannelsWithLoopName);
		LinkAction(71, LoopPeersOnChannelWithLoopName);
		LinkAction(72, ReplacedNoParams);
		LinkAction(73, Connect);
		LinkAction(74, ResizeBinaryToSend);
	}
	{
		LinkCondition(0, AlwaysTrue /* OnError */);
		LinkCondition(1, AlwaysTrue /* OnConnect */);
		LinkCondition(2, AlwaysTrue /* OnConnectDenied */);
		LinkCondition(3, AlwaysTrue /* OnDisconnect */);
		LinkCondition(4, AlwaysTrue /* OnChannelJoin */);
		LinkCondition(5, AlwaysTrue /* OnChannelJoinDenied */);
		LinkCondition(6, AlwaysTrue /* OnNameSet */);
		LinkCondition(7, AlwaysTrue /* OnNameDenied */);
		LinkCondition(8, OnSentTextMessageFromServer);
		LinkCondition(9, OnSentTextMessageFromChannel);
		LinkCondition(10, AlwaysTrue /* OnPeerConnect */);
		LinkCondition(11, AlwaysTrue /* OnPeerDisonnect */);
		LinkCondition(12, AlwaysFalse /* Replaced_OnChannelJoin */);
		LinkCondition(13, AlwaysTrue /* OnChannelPeerLoop */);
		LinkCondition(14, AlwaysTrue /* OnClientChannelLoop */);
		LinkCondition(15, OnSentNumberMessageFromServer);
		LinkCondition(16, OnSentNumberMessageFromChannel);
		LinkCondition(17, AlwaysTrue /* OnChannelPeerLoopFinished */);
		LinkCondition(18, AlwaysTrue /* OnClientChannelLoopFinished */);
		LinkCondition(19, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(20, OnBlastedTextMessageFromServer);
		LinkCondition(21, OnBlastedNumberMessageFromServer);
		LinkCondition(22, OnBlastedTextMessageFromChannel);
		LinkCondition(23, OnBlastedNumberMessageFromChannel);
		LinkCondition(24, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(25, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(26, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(27, AlwaysTrue /* OnChannelListReceived */);
		LinkCondition(28, AlwaysTrue /* OnChannelListLoop */);
		LinkCondition(29, AlwaysTrue /* OnChannelListLoopFinished */);
		LinkCondition(30, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(31, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(32, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(33, OnSentBinaryMessageFromServer);
		LinkCondition(34, OnSentBinaryMessageFromChannel);
		LinkCondition(35, OnBlastedBinaryMessageFromServer);
		LinkCondition(36, OnBlastedBinaryMessageFromChannel);
		LinkCondition(37, OnSentTextMessageFromPeer);
		LinkCondition(38, OnSentNumberMessageFromPeer);
		LinkCondition(39, OnSentBinaryMessageFromPeer);
		LinkCondition(40, OnBlastedTextMessageFromPeer);
		LinkCondition(41, OnBlastedNumberMessageFromPeer);
		LinkCondition(42, OnBlastedBinaryMessageFromPeer);
		LinkCondition(43, IsConnected);
		LinkCondition(44, AlwaysTrue /* OnChannelLeave */);
		LinkCondition(45, AlwaysTrue /* OnChannelLeaveDenied */);
		LinkCondition(46, AlwaysTrue /* OnPeerChangedName */);
		LinkCondition(47, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(48, OnAnySentMessageFromServer);
		LinkCondition(49, OnAnySentMessageFromChannel);
		LinkCondition(50, OnAnySentMessageFromPeer);
		LinkCondition(51, OnAnyBlastedMessageFromServer);
		LinkCondition(52, OnAnyBlastedMessageFromChannel);
		LinkCondition(53, OnAnyBlastedMessageFromPeer);
		LinkCondition(54, AlwaysTrue /* OnNameChanged */);
		LinkCondition(55, ClientHasAName);
		LinkCondition(56, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(57, AlwaysFalse /* ReplacedCondNoParams */);
		LinkCondition(58, SelectedPeerIsChannelMaster);
		LinkCondition(59, YouAreChannelMaster);
		LinkCondition(60, OnChannelListLoopWithName);
		LinkCondition(61, OnChannelListLoopWithNameFinished);
		LinkCondition(62, OnPeerLoopWithName);
		LinkCondition(63, OnPeerLoopWithNameFinished);
		LinkCondition(64, OnClientChannelLoopWithName);
		LinkCondition(65, OnClientChannelLoopWithNameFinished);
		LinkCondition(66, OnSentTextChannelMessageFromServer);
		LinkCondition(67, OnSentNumberChannelMessageFromServer);
		LinkCondition(68, OnSentBinaryChannelMessageFromServer);
		LinkCondition(69, OnBlastedTextChannelMessageFromServer);
		LinkCondition(70, OnBlastedNumberChannelMessageFromServer);
		LinkCondition(71, OnBlastedBinaryChannelMessageFromServer);
		LinkCondition(72, OnAnyBlastedChannelMessageFromServer);
	}
	{
		LinkExpression(0, Error);
		LinkExpression(1, ReplacedExprNoParams);
		LinkExpression(2, Self_Name);
		LinkExpression(3, Self_ChannelCount);
		LinkExpression(4, Peer_Name);
		LinkExpression(5, ReceivedStr);
		LinkExpression(6, ReceivedInt);
		LinkExpression(7, Subchannel);
		LinkExpression(8, Peer_ID);
		LinkExpression(9, Channel_Name);
		LinkExpression(10, Channel_PeerCount);
		LinkExpression(11, ReplacedExprNoParams);
		LinkExpression(12, ChannelListing_Name);
		LinkExpression(13, ChannelListing_PeerCount);
		LinkExpression(14, Self_ID);
		LinkExpression(15, ReplacedExprNoParams);
		LinkExpression(16, ReplacedExprNoParams);
		LinkExpression(17, ReplacedExprNoParams);
		LinkExpression(18, ReplacedExprNoParams);
		LinkExpression(19, ReplacedExprNoParams);
		LinkExpression(20, StrByte);
		LinkExpression(21, UnsignedByte);
		LinkExpression(22, SignedByte);
		LinkExpression(23, UnsignedShort);
		LinkExpression(24, SignedShort);
		LinkExpression(25, UnsignedInteger);
		LinkExpression(26, SignedInteger);
		LinkExpression(27, Float);
		LinkExpression(28, StringWithSize);
		LinkExpression(29, String);
		LinkExpression(30, ReceivedBinarySize);
		LinkExpression(31, Lacewing_Version);
		LinkExpression(32, SendBinarySize);
		LinkExpression(33, Self_PreviousName);
		LinkExpression(34, Peer_PreviousName);
		LinkExpression(35, ReplacedExprNoParams);
		LinkExpression(36, ReplacedExprNoParams);
		LinkExpression(37, DenyReason);
		LinkExpression(38, HostIP);
		LinkExpression(39, HostPort);
		LinkExpression(40, ReplacedExprNoParams);
		LinkExpression(41, WelcomeMessage);
		LinkExpression(42, ReceivedBinaryAddress);
		LinkExpression(43, CursorStrByte);
		LinkExpression(44, CursorUnsignedByte);
		LinkExpression(45, CursorSignedByte);
		LinkExpression(46, CursorUnsignedShort);
		LinkExpression(47, CursorSignedShort);
		LinkExpression(48, CursorUnsignedInteger);
		LinkExpression(49, CursorSignedInteger);
		LinkExpression(50, CursorFloat);
		LinkExpression(51, CursorStringWithSize);
		LinkExpression(52, CursorString);
		LinkExpression(53, ReplacedExprNoParams);
		LinkExpression(54, SendBinaryAddress);
	}
    
	/*
        This is where you'd do anything you'd do in CreateRunObject in the original SDK

        It's the only place you'll get access to edPtr at runtime, so you should transfer
        anything from edPtr to the extension class here.
    */
	/*
	std::vector<Prop *> Prop;
	std::vector<char> PropChkbox;
	char * Current =  &edPtr->DarkEDIF_Props[0];
	for(unsigned int i = 0; i < ::SDK->json[CurLang]["Properties"].u.object.length; ++i)
	{
		Prop.push_back(GetProperty(edPtr, i));
		PropChkbox.push_back(*GetPropertyChbx(edPtr, i));
	}
	*/
	AutomaticallyClearBinary = edPtr->AutomaticClear;
	GlobalID = _strdup(edPtr->Global ? edPtr->GlobalID : "");
	
	if (Edif::IsEdittime == false)
	{
		// Try 10 times to boot the lacewing thread
		char c = 0;
		while (c++ < 10)
		{
			if (Thread = CreateThread(NULL, NULL, (LPTHREAD_START_ROUTINE)&LacewingLoopThread, this, NULL, NULL))
				break;
		}

		// Failed 10 times, it's safe to say this ain't happening
		if (!Thread)
			MessageBoxA(NULL, "Error: failed to boot thread (attempted 10 times).", "DarkEDIF - runtime error", MB_OK);
	}

	// Link all callbacks
	{
		Client.onChannelListReceived(::OnChannelListReceived);
		Client.onChannelMessage(::OnChannelMessage);
		Client.onConnect(::OnConnect);
		Client.onConnectionDenied(::OnConnectDenied);
		Client.onDisconnect(::OnDisconnect);
		Client.onError(::OnError);
		Client.onJoin(::OnJoinChannel);
		Client.onJoinDenied(::OnJoinChannelDenied);
		Client.onLeave(::OnLeaveChannel);
		Client.onLeaveDenied(::OnLeaveChannelDenied);
		Client.onNameChanged(::OnNameChanged);
		Client.onNameDenied(::OnNameDenied);
		Client.onNameSet(::OnNameSet);
		Client.onPeerChangeName(::OnPeerNameChanged);
		Client.onPeerConnect(::OnPeerConnect);
		Client.onPeerDisconnect(::OnPeerDisconnect);
		Client.onPeerMessage(::OnPeerMessage);
		Client.onServerChannelMessage(::OnServerChannelMessage);
		Client.onServerMessage(::OnServerMessage);
	}
	
	Client.Tag = this;
}

void WINAPI LacewingLoopThread(Extension * ThisExt)
{
	// If terminated, only 4 bytes of memory will be leaked.
	// However, it is better to use PostEventLoopExit().
	Lacewing::Error * Error = ThisExt->ObjEventPump.StartEventLoop();
	if (Error)
	{
		std::string Text = "Error returned by StartEventLoop(): ";
					Text += Error->ToString();
		ThisExt->CreateError(Text.c_str());
	}
	#ifdef _DEBUG
		MessageBoxA(NULL, "Lacewing thread exiting.", "DarkEDIF - Thread exit", MB_OK);
	#endif
	ThisExt->Thread = NULL;
}


#ifdef MULTI_THREADING
SaveExtInfo &Extension::AddEvent(int Event, bool UseLastData /* = false */)
{
	/*
		Saves all variables returned by expressions in order to ensure two conditions, triggering simultaneously,
		do not cause reading of only the last condition's output. Useful for multi-threading.
		
		For example, if an error event changes an output variable, and immediately afterward a 
		success event changes the same variable, only the success event's output can be read.
	*/

	// Cause a new event
	if (UseLastData == false)
	{
		SaveExtInfo * NewEvent = new SaveExtInfo;
		
		// Initialise with one condition to be triggered
		NewEvent->NumEvents = 1;
		NewEvent->CondTrig = (unsigned short *)malloc(sizeof(unsigned short));
		if(!NewEvent->CondTrig)
			// Failed to allocate memory
			return ThreadData;
		NewEvent->CondTrig[0] = (unsigned short)Event;
		
		// Copy Extension's data to vector
		if (memcpy_s(((char *)NewEvent)+5, sizeof(SaveExtInfo)-5, ((char *)&ThreadData)+5, sizeof(SaveExtInfo)-5))
		{
			// Failed to copy memory
			return ThreadData;
		}
		Saved.push_back(NewEvent);
	}
	else // New event is part of the last saved data (good for optimisation)
	{
		// Add current condition to saved expressions
		++Saved.back()->NumEvents;
		unsigned short * CurrentCond = (unsigned short *)realloc(&Saved.back()->CondTrig[0], Saved.back()->NumEvents * sizeof(short));
		
		if (!CurrentCond)
			return ThreadData;

		CurrentCond[Saved.back()->NumEvents-1] = (unsigned short)Event;
		
		Saved.back()->CondTrig = CurrentCond;
	}

	// Cause Handle() to be triggered, allowing Saved to be parsed
	Runtime.Rehandle();
	return *Saved.back();
}
#endif // MULTI_THREADING

Extension::~Extension()
{
	ObjEventPump.PostEventLoopExit();
	if (Thread)
	{
		Sleep(100);
		if (Thread)
			TerminateThread(Thread, 0);
	}
}

short Extension::Handle()
{
	#ifdef MULTI_THREADING
		// AddEvent() was called and not yet handled
		while (Saved.size() > 0)
		{
			// Copy from saved list of events to current extension
			if (memcpy_s(&ThreadData, sizeof(SaveExtInfo), Saved.front(), sizeof(SaveExtInfo)))
				break; // Failed; leave until next Extension::Handle()

			// Trigger all stored events (more than one may be stored by calling AddEvent(***, true) )
			for (unsigned char u = 0; u < ThreadData.NumEvents; ++u)
				Runtime.GenerateEvent((int) ThreadData.CondTrig[u]);

			Saved.erase(Saved.begin());
		}
	#endif // MULTI_THREADING
	

    /*
       If your extension will draw to the MMF window you should first 
       check if anything about its display has changed :

           if (rdPtr->roc.rcChanged)
              return REFLAG_DISPLAY;
           else
              return 0;

       You will also need to make sure you change this flag yourself 
       to 1 whenever you want to redraw your object
     
       If your extension won't draw to the window, but it still needs 
       to do something every MMF loop use :

            return 0;

       If you don't need to do something every loop, use :

            return REFLAG::ONE_SHOT;

       This doesn't mean this function can never run again. If you want MMF
       to handle your object again (causing this code to run) use this function:

            Runtime.Rehandle();

       At the end of the loop this code will run

    */

	// If thread is not working, use Tick functionality.
	if (!Thread)
	{
		ObjEventPump.Tick();
		return 0;
	}

	// Will not be called next loop	
	return REFLAG::ONE_SHOT;
}


short Extension::Display()
{
    /*
       If you return REFLAG::DISPLAY in Handle() this routine will run.
    */

    // Ok
    return 0;
}

short Extension::Pause()
{

    // Ok
    return 0;
}

short Extension::Continue()
{

    // Ok
    return 0;
}

bool Extension::Save(HANDLE File)
{
	bool OK = false;

    #ifndef VITALIZE

	    // Save the object's data here

	    OK = true;

    #endif

	return OK;
}

bool Extension::Load(HANDLE File)
{
	bool OK = false;

    #ifndef VITALIZE

	    // Load the object's data here

	    OK = true;

    #endif

	return OK;
}


// These are called if there's no function linked to an ID

void Extension::Action(int ID, RUNDATA * rdPtr, long param1, long param2)
{

}

long Extension::Condition(int ID, RUNDATA * rdPtr, long param1, long param2)
{
    return false;
}

long Extension::Expression(int ID, RUNDATA * rdPtr, long param)
{

    return 0;
}


