
#include <tchar.h>
#pragma once
#ifndef _cncinc_h
#define _cncinc_h


class cSurface;
class CTransition;
class CDebugger;
class CRunApp;
#ifdef HWABETA
	class CEffectEx;
	class CPList;
#endif

// PictEdDefs.h
#define PICTEDOPT_FIXEDIMGSIZE			0x0001		// User cannot change the image size
#define PICTEDOPT_HOTSPOT				0x0002		// Image has a hot spot
#define PICTEDOPT_ACTIONPOINT			0x0004		// Image has an action point
#define PICTEDOPT_16COLORS				0x0008		// 16 colors image
#define PICTEDOPT_FIXEDNFRAMES			0x0010		// User cannot add / remove frames (animation editor)
#define	PICTEDOPT_NUMBERS				0x0020		// Numbers (internal)
#define PICTEDOPT_NOTRANSPARENCY		0x0040		// The image has no transparent color
#define PICTEDOPT_NOALPHACHANNEL		0x0080		// The image cannot have an alpha channel
#define PICTEDOPT_APPICON				0x0100		// Internal
#define PICTEDOPT_ICONPALETTE			0x0200		// Internal
#define PICTEDOPT_CANBETRANSPARENT		0x0400		// The image can be empty (if this option is not specified, MMF refuses to close the picture editor if the image is empty)
#define PICTEDOPT_CANNOTMOVEFRAMES		0x0800		// Frames cannot be moved

// Marquage des OI qualifiers
#define	OIFLAG_QUALIFIER			0x8000
#define	NDEF_QUALIFIERS				100
#define MAX_EVENTPROGRAMS			256

#define	GAMEON_EMPTY		0
#define	GAMEON_UNLOADED		1
#define	GAMEON_TIME0		2
#define	GAMEON_PAUSED		3
#define	GAMEON_RUNNING		4
#define	GAMEON_STEPPING		5

class CImageFilterMgr;
class CSoundFilterMgr;
class CSoundManager;
class CRunApp;
class CRunFrame;
class CEditApp;
class CEditFrame;
class CMvt;
class EditProp;
class OI;
class dllTrans;
class CValue;
struct PropData;
struct RunHeader;
struct EDITDATA;
class headerObject;
class kpj;
class objInfoList;
class drawRoutine;
class LO;
class pev;
class qualToOi;
class CRunApp;
class CRunFrame;
class CRunMvt;
class CMvt;
class CDemoRecord;
class CIPhoneJoystick;
class CIPhoneAd;
struct eventGroup;
struct RunHeader;
class mv;

// Force structure alignement
#ifndef      _H2INC
	#pragma pack( push, _pack_cncy_ )
	#pragma pack(2)
#endif
// CNCF.H


// Definitions for extensions
#define TYPE_LONG	0x0000
#define TYPE_INT	TYPE_LONG
#define TYPE_STRING	0x0001
#define TYPE_FLOAT	0x0002				// Pour les extensions
#define TYPE_DOUBLE 0x0002

class CValue {
public:
	unsigned int m_type,
				 m_paddle;
	union
	{
		long m_long;
		double m_double;
		TCHAR * m_pString;
	};
};

// Changes the structure alignment
#ifndef	_H2INC  
#pragma pack( push, _pack_cncf_ )
#pragma pack(2) 
#endif
typedef short *				LPSHORT;

//class CValue;

// Number of values
#define VALUES_NUMBEROF_ALTERABLE	26
#define VALUES_NUMBEROF_MAX			26
#define STRINGS_NUMBEROF_ALTERABLE	10
#define STRINGS_NUMBEROF_MAX		10

typedef short ITEMTYPE;
typedef short OINUM;
typedef short HFII;

// LOGFONT 16 structure for compatibility with old extensions
/////////////////////////////////////////////////////////////
typedef struct tagLOGFONTV1A {
	short	lfHeight;
	short	lfWidth;
	short	lfEscapement;
	short	lfOrientation;
	short	lfWeight;
	BYTE	lfItalic;
	BYTE	lfUnderline;
	BYTE	lfStrikeOut;
	BYTE	lfCharSet;
	BYTE	lfOutPrecision;
	BYTE	lfClipPrecision;
	BYTE	lfQuality;
	BYTE	lfPitchAndFamily;
	char	lfFaceName[LF_FACESIZE];
} LOGFONTV1A;
typedef struct tagLOGFONTV1W {
	short	lfHeight;
	short	lfWidth;
	short	lfEscapement;
	short	lfOrientation;
	short	lfWeight;
	BYTE	lfItalic;
	BYTE	lfUnderline;
	BYTE	lfStrikeOut;
	BYTE	lfCharSet;
	BYTE	lfOutPrecision;
	BYTE	lfClipPrecision;
	BYTE	lfQuality;
	BYTE	lfPitchAndFamily;
	WCHAR	lfFaceName[LF_FACESIZE];
} LOGFONTV1W;
#ifdef _UNICODE
#define LOGFONTV1 LOGFONTV1W
#else
#define LOGFONTV1 LOGFONTV1A
#endif

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//
// ObjectsCommon - Dynamic items
//
#define	OC_MAX_QUALIFIERS	8

class OC {
public:

	unsigned long	ocDWSize;				// Total size of the structures

	unsigned short	ocMovements,			// Offset of the movements
					ocAnimations, 			// Offset of the animations
					ocVersion,				// For version versions > MOULI 
					ocCounter,				// Pointer to COUNTER structure
					ocData,					// Pointer to DATA structure
					ocFree;
	unsigned long	ocOEFlags;			// New flags

	unsigned short	ocQualifiers[OC_MAX_QUALIFIERS],	// Qualifier list
					ocExtension,						// Extension structure 
					ocValues,							// Values structure
					ocStrings,							// String structure

					ocFlags2,				// New news flags, before it was ocEvents
					ocOEPrefs;				// Automatically modifiable flags
	unsigned long	ocIdentifier;			// Identifier d'objet

	COLORREF		ocBackColor;			// Background color
	unsigned long	ocFadeIn,				// Offset fade in 
					ocFadeOut,				// Offset fade out 
					ocValueNames,			// For the debugger
					ocStringNames;

};
typedef OC * LPOC;
typedef OC * fpoc;

typedef struct
{
	WORD	number;
	long	values[1];
} OCValues;
typedef	OCValues*			LPOCVALUES;

#ifdef _UNICODE
typedef struct
{
	WORD	number;
	TCHAR	str[1];
} OCStringsW;
typedef	OCStringsW*			LPOCSTRINGS;
#else
typedef struct
{
	WORD	number;
	char	str[2];
} OCStringsA;
typedef	OCStringsA*			LPOCSTRINGS;
#endif



typedef struct
{
	WORD	number;
	char	str[2];

} OCValueNames;
typedef	OCValueNames*		LPOCVALUENAMES;

#define	OCFLAGS2_DONTSAVEBKD		0x0001
#define	OCFLAGS2_SOLIDBKD			0x0002
#define	OCFLAGS2_COLBOX				0x0004
#define	OCFLAGS2_VISIBLEATSTART		0x0008
#define	OCFLAGS2_OBSTACLESHIFT		4
#define	OCFLAGS2_OBSTACLEMASK		0x0030
#define	OCFLAGS2_OBSTACLE_SOLID		0x0010
#define	OCFLAGS2_OBSTACLE_PLATFORM	0x0020
#define	OCFLAGS2_OBSTACLE_LADDER	0x0030
#define	OCFLAGS2_AUTOMATICROTATION	0x0040

//////////////////////////////////////////////////////////////////////////////
//
// Counter
//
struct counter {
	unsigned short	ctSize;
	long			ctInit,				// Initial value
					ctMini,				// Minimal value
					ctMaxi;				// Maximal value
};
typedef counter tagCT;
typedef counter	* fpct;
typedef counter	* fpCounter;

//////////////////////////////////////////////////////////////////////////////
//
// Animations
//
#define	ANIMID_MIN	16

// Anim header
class AnimHeader {
public:
	WORD		ahSize;
	WORD		ahAnimMax;					// New V2, number of entries in offset table
	short		ahOffsetToAnim[ANIMID_MIN];	// Minimum 16 animations, can be larger!
};
typedef AnimHeader * fpAnimHeader;
typedef AnimHeader * fpah;
typedef AnimHeader * LPAH;

#ifndef DIRID_MAX
	#define DIRID_MAX	32
#endif

// Anim structure
typedef	struct	Anim {
	short	 		anOffsetToDir[DIRID_MAX];	// Offset to animations with a direction
} Anim;
typedef Anim *	fpAnim;
typedef Anim *	fpan;
typedef Anim *	LPAN;

// AnimDirection structure
typedef	struct	AnimDirection {
	BYTE		adMinSpeed;					// Minimum speed
	BYTE		adMaxSpeed;					// Maximum speed
	short		adRepeat;					// Number of loops
	short		adRepeatFrame;				// Where to loop
	short		adNumberOfFrame;			// Number of frames
	short		adFrame[1];					// Frames
} AnimDirection;
#define sizeof_AnimDirection	(sizeof(AnimDirection)-2)
typedef AnimDirection *	fpAnimDir;
typedef AnimDirection *	fpad;
typedef AnimDirection *	LPAD;

// Chunks de sauvegarde
#define EVTFILECHUNK_HEAD			B2L('E','R','>','>')
#define EVTFILECHUNK_EVTHEAD		B2L('E','R','e','s')
#define EVTFILECHUNK_EVENTS			B2L('E','R','e','v')
#define EVTFILECHUNK_NEWITEMS		B2L('>','N','I','<')
#define EVTFILECHUNK_END			B2L('<','<','E','R')

// Marquage des OI qualifiers
#define	OIFLAG_QUALIFIER			0x8000
#define	NDEF_QUALIFIERS				100
#define MAX_EVENTPROGRAMS			256

#define	GAMEON_EMPTY		0
#define	GAMEON_UNLOADED		1
#define	GAMEON_TIME0		2
#define	GAMEON_PAUSED		3
#define	GAMEON_RUNNING		4
#define	GAMEON_STEPPING		5

// COMMUNICATION STRUCTURE BETWEEN RUNTIME AND EDITOR
typedef struct
{
	unsigned int		command;

	WORD		runMode;
	unsigned int		timer;

	WORD		code;
	OINUM		oi;
	unsigned int		param[2];
	char		path[_MAX_PATH];

} ComStructure;
enum
{
	RUNCOMMAND_INITCOM=1,
	RUNCOMMAND_NEWEVENT,
	RUNCOMMAND_NEWSOUND,
	RUNCOMMAND_NEWOBJECT,
	RUNCOMMAND_NEWEVENTS,
	RUNCOMMAND_SETRUNMODE,
	RUNCOMMAND_CONTINUE,
	RUNCOMMAND_RESTART,
	RUNCOMMAND_QUIT,
	HANDLEMESSAGE_WAITFORCONFIRM,
	HANDLEMESSAGE_WAITFORCOMMAND,
	HANDLEMESSAGE_OK,
	HANDLEMESSAGE_QUIT,
	HANDLEMESSAGE_TIMEOUT
};
// DIFFERENTS MODES OF RUN
enum
{
	RUNMODE_NONE,
	RUNMODE_STOPPED,
	RUNMODE_RUNNING,
	RUNMODE_PLAYING,
	RUNMODE_STEPPING,
	RUNMODE_PAUSED,
	RUNMODE_WAITING,
	RUNMODE_WAITINGQUIT,
};


// -------------------------------------------------------------------------
// MOVEMENT DEFINITIONS
// -------------------------------------------------------------------------

// Definition of animation codes
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define  	ANIMID_STOP				0
#define  	ANIMID_WALK				1
#define  	ANIMID_RUN				2
#define  	ANIMID_APPEAR			3
#define  	ANIMID_DISAPPEAR		4
#define  	ANIMID_BOUNCE			5
#define  	ANIMID_SHOOT			6
#define  	ANIMID_JUMP				7
#define  	ANIMID_FALL				8
#define  	ANIMID_CLIMB			9
#define  	ANIMID_CROUCH			10
#define  	ANIMID_UNCROUCH			11
#define  	ANIMID_USER1			12
//#define  	ANIMID_MAX				16
#define		ANIMNAME_MAXCHAR		64

// Definition of direction codes
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define		DIRF_ALL				0xFFFFFFFF
#define		DIRID_STATIC			32
#define		DIRID_MAX				32
#define		DIRID_SEE				30
#define		DIRID_SE				28
#define		DIRID_SSE				26
#define		DIRID_S					24
#define		DIRID_SSW				22
#define		DIRID_SW				20
#define		DIRID_SWW				18
#define		DIRID_W					16
#define		DIRID_NWW				14
#define		DIRID_NW				12
#define		DIRID_NNW				10
#define		DIRID_N					8
#define		DIRID_NNE				6
#define		DIRID_NE				4
#define		DIRID_NEE				2
#define		DIRID_E					0

// Definition of control types
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define		MVCONT_COMPUTER			0
#define		MVCONT_PLAYER1			1
#define		MVCONT_PLAYER2			2
#define		MVCONT_PLAYER3			3
#define		MVCONT_PLAYER4			4
#define		NB_MVCONT				5
#define		MAX_PLAYERS				4

// Definition of joystick controls
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define		JOYSTICK_UP				0b00000001
#define		JOYSTICK_DOWN			0b00000010
#define		JOYSTICK_LEFT			0b00000100
#define		JOYSTICK_RIGHT			0b00001000
#define		JOYSTICK_FIRE1			0b00010000
#define		JOYSTICK_FIRE2			0b00100000
#define		JOYSTICK_FIRE3			0b01000000
#define		JOYSTICK_FIRE4			0b10000000

// Definition of movement types
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define		MVTYPE_STATIC			0
#define		MVTYPE_MOUSE			1
#define		MVTYPE_RACE				2
#define		MVTYPE_GENERIC			3
#define		MVTYPE_BALL				4
#define		MVTYPE_TAPED			5
#define		MVTYPE_INTELLIGENT		6
#define		MVTYPE_PINBALL			7
#define		MVTYPE_LIST				8
#define		MVTYPE_PLATFORM			9
#define		MVTYPE_GOMOVEMENT		10
#define		MVTYPE_DISAPPEAR		11
#define		MVTYPE_APPEAR			12
#define		MVTYPE_BULLET			13
#define		MVTYPE_EXT				14
#define		MVTYPE_MAX				15

#define		MVTACTION_SAVEPOSITION	0x1010
#define		MVTACTION_LOADPOSITION	0x1011

////////////////////////////////////////////////////////////////////////////////
// EVENTS
////////////////////////////////////////////////////////////////////////////////

// Eventgroup structure, before conditions and actions
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
struct eventGroup {
	short	evgSize;				// 0 Size of the group (<=0)
	BYTE	evgNCond;				// 2 Number of conditions
	BYTE	evgNAct;				// 3 Number of actions
	WORD	evgFlags;				// 4 Flags 
	short	evgInhibit;				// 6 If the group is inhibited
	WORD	evgInhibitCpt;			// 8 Counter
	WORD	evgIdentifier;			// 10 Unique identifier
	short 	evgUndo;				// 12 Identifier for UNDO
};
typedef		eventGroup	*		PEVG;
typedef		eventGroup	*		LPEVG;
#define		EVG_SIZE				14

// MACRO: next group
#define		EVGNEXT(evgPtr)		   	((LPEVG)((char *)evgPtr-evgPtr->evgSize))
// MACRO: first event
#define		EVGFIRSTEVT(p)	   		((LPEVT)((char *)p+sizeof(eventGroup)))
// MACRO: number of events in the group
#define		EVGNEVENTS(p)	 		(p->evgNCond+p->evgNAct)

// Internal flags of eventgroups
#define		EVGFLAGS_ONCE			0x0001
#define		EVGFLAGS_NOTALWAYS		0x0002
#define		EVGFLAGS_REPEAT			0x0004
#define		EVGFLAGS_NOMORE			0x0008
#define		EVGFLAGS_SHUFFLE		0x0010
#define		EVGFLAGS_EDITORMARK		0x0020
#define		EVGFLAGS_UNDOMARK		0x0040
#define		EVGFLAGS_COMPLEXGROUP	0x0080
#define		EVGFLAGS_BREAKPOINT		0x0100
#define		EVGFLAGS_ALWAYSCLEAN	0x0200
#define		EVGFLAGS_ORINGROUP		0x0400
//#define		EVGFLAGS_2MANYACTIONS	0x0400
#define		EVGFLAGS_STOPINGROUP	0x0800
//#define		EVGFLAGS_NOTASSEMBLED	0x1000
#define		EVGFLAGS_ORLOGICAL		0x1000
#define		EVGFLAGS_GROUPED		0x2000
#define		EVGFLAGS_INACTIVE		0x4000
#define		EVGFLAGS_NOGOOD			0x8000
#define		EVGFLAGS_LIMITED		(EVGFLAGS_SHUFFLE+EVGFLAGS_NOTALWAYS+EVGFLAGS_REPEAT+EVGFLAGS_NOMORE)
#define		EVGFLAGS_DEFAULTMASK	(EVGFLAGS_BREAKPOINT+EVGFLAGS_GROUPED)
//#define		EVGFLAGS_FADE			(EVGFLAGS_FADEIN|EVGFLAGS_FADEOUT)
	

// Condition ou action structure
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct tagEVTV1 {
	short	evtSize;				
	union
	{
		struct
		{
			short	evtCode;		
		};
		struct
		{
			char	evtType;		
			char	evtNum;			
		};
	};
	OINUM	evtOi;					
	short	evtOiList;				
	char	evtFlags;				
	char	evtFlags2;				
	char	evtNParams;				
	char   	evtDefType;				
// For the conditions
	short	evtIdentifier;	  		
	} eventV1;
typedef	eventV1	*	LPEVTV1;

#define	CND_SIZEV1					14
#define	ACT_SIZEV1					12
#define	EVGFIRSTEVTV1(p)	   		((LPEVTV1)((char *)p+sizeof(eventGroup)))
#define	EVTPARAMSV1(p) 				((LPEVP)( p->evtCode<0 ? (LPBYTE)p+CND_SIZEV1 : (LPBYTE)p+ACT_SIZEV1) )
#define	EVTNEXTV1(p)		 		((LPEVTV1)((LPBYTE)p+p->evtSize))



typedef struct tagEVT {
	short	evtSize;				// 0 Size of the event
	union
	{
		struct
		{
			long	evtCode;		// 2 Code (hi:NUM lo:TYPE)
		};
		struct
		{
			short	evtType;		// 2 Type of object
			short	evtNum;			// 4 Number of action/condition
		};
	};
	OINUM	evtOi;					// 6 OI if normal object
	short	evtOiList;				// 8 Pointer
	char	evtFlags;				// 10 Flags
	char	evtFlags2;				// 11 Flags II
	char	evtNParams;				// 12 Number of parameters
	char   	evtDefType;				// 13 If default, type
// Pour les conditions
	short	evtIdentifier;	  		// 14 Event identifier
	} event;						// 16
typedef	event	*	PEVT;
typedef	event	*	LPEVT;

#define	CND_SIZE					16
#define	ACT_SIZE					14

// Definition of conditions / actions flags
#define		EVFLAGS_REPEAT			0x01
#define		EVFLAGS_DONE			0x02
#define		EVFLAGS_DEFAULT			0x04
#define		EVFLAGS_DONEBEFOREFADEIN 0x08
#define		EVFLAGS_NOTDONEINSTART	0x10
#define		EVFLAGS_ALWAYS			0x20
#define		EVFLAGS_BAD				0x40
#define		EVFLAGS_BADOBJECT		0x80
#define		EVFLAGS_DEFAULTMASK		(EVFLAGS_ALWAYS+EVFLAGS_REPEAT+EVFLAGS_DEFAULT+EVFLAGS_DONEBEFOREFADEIN+EVFLAGS_NOTDONEINSTART)
#define		ACTFLAGS_REPEAT			0x0001


// For flags II
// -------------                    
#define		EVFLAG2_NOT			0x0001
#define		EVFLAG2_NOTABLE		0x0002
#define		EVFLAGS_NOTABLE		(EVFLAG2_NOTABLE<<8)
#define		EVFLAGS_MONITORABLE	0x0004
#define		EVFLAGS_TODELETE	0x0008
#define		EVFLAGS_NEWSOUND	0x0010
#define		EVFLAG2_MASK		(EVFLAG2_NOT|EVFLAG2_NOTABLE|EVFLAGS_MONITORABLE)

// MACRO: Returns the code for an extension
#define		EXTCONDITIONNUM(i)		(-((short)(i>>16))-1)           
#define		EXTACTIONNUM(i)			((short)(i>>16))

// PARAM Structure
// ~~~~~~~~~~~~~~~
class eventParam { 
public:
	short		evpSize;
	short		evpCode;
	union	{
		struct	{
		short		evpW0;
		short		evpW1;
		short		evpW2;
		short		evpW3;
		short		evpW4;
		short		evpW5;
		short		evpW6;
		short		evpW7;
		} evpW;
		struct	{
		long	evpL0;
		long	evpL1;
		long	evpL2;
		long	evpL3;
		} evpL;
	} evp;
};
typedef	eventParam	*			PEVP;
typedef	eventParam	*			LPEVP;
typedef	eventParam	*			fpevp;

// MACRO: next parameter
#define		EVPNEXT(p)		   		((LPEVP)((char *)p+p->evpSize))


// Operators / expressions parameters
// --------------------------------------------------
#define		MIN_LONG				(-10000000L)
#define		MAX_LONG				(10000000L)
#define		EXPPARAM_LONG			1
#define		EXPPARAM_VARGLO			2
#define		EXPPARAM_STRING			3
#define		EXPPARAM_ALTVALUE		4
#define		EXPPARAM_FLAG			5
#define		EXP_STOP				-1
#define		OPERATOR_START			0x00000000
#define		EXPL_END				0x00000000	
#define		EXPL_PLUS				0x00020000
#define		EXPL_MOINS				0x00040000
#define		EXPL_MULT				0x00060000
#define		EXPL_DIV				0x00080000                                         
#define		EXPL_MOD				0x000A0000
#define		EXPL_POW				0x000C0000
#define		EXPL_AND				0x000E0000
#define		EXPL_OR					0x00100000
#define		EXPL_XOR				0x00120000
#define		OPERATOR_END			0x00140000
typedef struct tagEXP {
	union
	{
		struct
		{
			long	expCode;		// 2 Code (hi:NUM lo:TYPE)
		};
		struct
		{
			short	expType;		// 2 Type of object
			short	expNum;			// 3 Expression number
		};
	};
	short	expSize;
	union	
	{
		struct {
			short	expOi;
			short	expOiList;
		} expo;
		struct {
			long	expLParam;
		} expl;
		struct {
			double	expDouble;
			float	expFloat;
		} expd;
		struct {
			short	expWParam0;
			short	expWParam1;
		} expw;
		struct {
			short	expOi;
			short	expOiList;
			short	expNum;
		} expv;
		struct {
			long	expExtCode;
			short	expExtNumber;
		} expc;
	} expu;
	} expression;
typedef	expression *	LPEXP;
typedef	expression *	PEXP;

#define		CMPOPE_EQU				0x0000
#define		CMPOPE_DIF				0x0001
#define		CMPOPE_LOWEQU			0x0002
#define		CMPOPE_LOW				0x0003
#define		CMPOPE_GREEQU			0x0004
#define		CMPOPE_GRE				0x0005
#define		MAX_CMPOPE				6
#define		EXPNEXT(expPtr)			((LPEXP)((char *)expPtr+expPtr->expSize))
#define		EXPFLAG_STRING			0x0001
#define		EXPFLAG_DOUBLE			0x0002

typedef struct tagEXPV1 {
	union
	{
		struct
		{
			short	expCode;
		};
		struct
		{
			char	expType;
			char	expNum;	
		};
	};
	short	expSize;
	union	
	{
		struct {
			short	expOi;
			short	expOiList;
		} expo;
		struct {
			long	expLParam;
		} expl;
		struct {
			double	expDouble;
			float	expFloat;
		} expd;
		struct {
			short	expWParam0;
			short	expWParam1;
		} expw;
		struct {
			short	expOi;
			short	expOiList;
			short	expNum;
		} expv;
		struct {
			long	expExtCode;
			short	expExtNumber;
		} expc;
	} expu;
	}expressionV1;
typedef	expressionV1 *			LPEXPV1;

#define		EXPNEXTV1(expPtr)		((LPEXPV1)((char *)expPtr+expPtr->expSize))

/*
#define		Q_SPR	0x0100
#define		Q_TXT	0x0200
#define		Q_QST	0x0400
#define		Q_ARE	0x0800
#define		Q_CNT	0x1000
#define		Q_PLA	0x2000
#define		Q_GAM	0x4000
#define		Q_TIM	0x8000
#define		Q_COL	0x0001
#define		Q_ZNE	0x0002
#define		Q_MVT	0x0004
#define		Q_ANI	0x0008
#define		Q_OBJ	0x0010
#define		Q_KEY	0x0020
#define		Q_SYS	0x0040
*/

// Information structure
// ----------------------------------------------
typedef struct tagEVO {                                  
	short		evoConditions;	  	// Conditions
	short		evoActions;			// Actions
	short		evoExpressions;		// Expressions
	short		evoMsgMenus;		// Menu strings for actions/conditions
	short		evoMsgDisplay;		// Display strings for actions/conditions
	short		evoMsgExpressions; 	// Menu/display strings for expressions
	short		evoMsgExpParams;	// Parameter string
	short		evoNConditions;		// Number of conditions
	} eventInfosOffsets;
typedef	eventInfosOffsets *		PEVO;
typedef	eventInfosOffsets *		LPEVO;

// Definition of the different system objects (TYPE<0)
// ----------------------------------------------------------
#define		TYPE_DIRECTION			-127
#define		TYPE_QUALIFIER			-126
#define		NUMBEROF_SYSTEMTYPES    7
#define		OBJ_PLAYER				-7
#define		OBJ_KEYBOARD			-6
#define		OBJ_CREATE				-5
#define		OBJ_TIMER		  		-4
#define		OBJ_GAME		  		-3
#define		OBJ_SPEAKER	  			-2
#define		OBJ_SYSTEM				-1
#define		OBJ_FIRST_C_OBJECT		8
#define		OBJ_LAST				NB_SYSOBJ








// ------------------------------------------------------------
// EXTENSION OBJECT DATA ZONE
// ------------------------------------------------------------

// Flags 
#define		OEFLAG_DISPLAYINFRONT		0x0001
#define		OEFLAG_BACKGROUND			0x0002
#define		OEFLAG_BACKSAVE				0x0004
#define		OEFLAG_RUNBEFOREFADEIN		0x0008
#define		OEFLAG_MOVEMENTS			0x0010
#define		OEFLAG_ANIMATIONS			0x0020
#define		OEFLAG_TABSTOP				0x0040
#define		OEFLAG_WINDOWPROC			0x0080
#define		OEFLAG_VALUES				0x0100
#define		OEFLAG_SPRITES				0x0200
#define		OEFLAG_INTERNALBACKSAVE		0x0400
#define		OEFLAG_SCROLLINGINDEPENDANT	0x0800
#define		OEFLAG_QUICKDISPLAY			0x1000
#define		OEFLAG_NEVERKILL			0x2000
#define		OEFLAG_NEVERSLEEP			0x4000
#define		OEFLAG_MANUALSLEEP			0x8000
#define		OEFLAG_TEXT					0x10000
#define		OEFLAG_DONTCREATEATSTART	0x20000

// Flags modifiable by the program
#define		OEPREFS_BACKSAVE				0x0001
#define		OEPREFS_SCROLLINGINDEPENDANT	0x0002
#define		OEPREFS_QUICKDISPLAY			0x0004
#define		OEPREFS_SLEEP					0x0008
#define		OEPREFS_LOADONCALL				0x0010
#define		OEPREFS_GLOBAL					0x0020
#define		OEPREFS_BACKEFFECTS				0x0040
#define		OEPREFS_KILL					0x0080
#define		OEPREFS_INKEFFECTS				0x0100
#define		OEPREFS_TRANSITIONS				0x0200
#define		OEPREFS_FINECOLLISIONS			0x0400
#define		OEPREFS_APPLETPROBLEMS			0x0800

// Running flags
#define		REFLAG_ONESHOT				0x0001
#define		REFLAG_DISPLAY				0x0002
#define		REFLAG_MSGHANDLED			0x0004
#define		REFLAG_MSGCATCHED			0x0008
#define		REFLAG_MSGDEFPROC			0x0010

#define		REFLAG_MSGRETURNVALUE		0x0040

#define		OEFLAGS_DEFAULTSETUPS		(OEFLAG_MOVEMENTS|OEFLAG_ANIMATIONS|OEFLAG_SPRITES|OEFLAG_VALUES)



#ifndef			IN_KPX
#error IN_KPX is defined! Keep this blox!
///////////////////////////////////////////////////////////////////////
//
// DEFINITION OF EVENTS AND ACTIONS CODES
//
///////////////////////////////////////////////////////////////////////

// SYSTEM Conditions / Actions
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//#define		OBJ_SYSTEM				-1
//-1&255=255
#define CND_CHANCE			((-26<<8)|255)
#define CND_ORLOGICAL		((-25<<8)|255)
#define CNDL_ORLOGICAL		((-25<<16)|65535)
#define CND_OR				((-24<<8)|255)
#define CNDL_OR				((-24<<16)|65535)
#define CND_GROUPSTART		((-23<<8)|255)
#define CNDL_GROUPSTART		((-23<<16)|65535)
#define CND_CLIPBOARD		((-22<<8)|255)
#define CND_ONCLOSE			((-21<<8)|255)
#define CNDL_ONCLOSE		((-21<<16)|65535)
#define	CND_COMPAREGSTRING	((-20<<8)|255)
#define	CNDL_COMPAREGSTRING	((-20<<16)|65535)
#define CND_MENUVISIBLE		((-19<<8)|255)
#define CND_MENUENABLED		((-18<<8)|255)
#define CND_MENUCHECKED		((-17<<8)|255)
#define	CND_ONLOOP			((-16<<8)|255)
#define	CNDL_ONLOOP			((-16<<16)|65535)
#define CND_DROPFILES		((-15<<8)|255)
#define CNDL_DROPFILES		((-15<<16)|65535)
#define	CND_MENUSELECTED	((-14<<8)|255)
#define CNDL_MENUSELECTED	((-14<<16)|65535)
#define	CND_RECORDKEY		((-13<<8)|255)
#define CNDL_RECORDKEY		((-13<<16)|65535)
#define	CND_GROUPACTIVATED	((-12<<8)|255)
#define	CNDL_GROUPACTIVATED	((-12<<16)|65535)
#define	CND_ENDGROUP		((-11<<8)|255)
#define CNDL_ENDGROUP		((-11<<16)|65535)
#define	CND_GROUP			((-10<<8)|255)
#define CNDL_GROUP			((-10<<16)|65535)
#define	CND_REMARK			((-9<<8)|255)
#define CNDL_REMARK			((-9<<16)|65535)
#define	CND_COMPAREG		((-8<<8)|255)
#define	CNDL_COMPAREG		((-8<<16)|65535)
#define	CND_NOTALWAYS		((-7<<8)|255)
#define	CNDL_NOTALWAYS		((-7<<16)|65535)
#define	CND_ONCE			((-6<<8)|255)
#define CNDL_ONCE			((-6<<16)|65535)
#define	CND_REPEAT			((-5<<8)|255)
#define CNDL_REPEAT			((-5<<16)|65535)
#define	CND_NOMORE			((-4<<8)|255)
#define CNDL_NOMORE			((-4<<16)|65535)
#define	CND_COMPARE			((-3<<8)|255)
#define	CND_NEVER			((-2<<8)|255)
#define CNDL_NEVER			((-2<<16)|65535)
#define	CND_ALWAYS			((-1<<8)|255)
#define CNDL_ALWAYS			((-1<<16)|65535)

#define	ACT_SKIP			((0<<8)|255)
#define	ACTL_SKIP			((0<<16)|65535)
#define	ACT_SKIPMONITOR		((1<<8)|255)
#define	ACTL_SKIPMONITOR	((1<<16)|65535)
#define	ACT_EXECPROG		((2<<8)|255)
#define	ACT_SETVARG			((3<<8)|255)
#define	ACTL_SETVARG		((3<<16)|65535)
#define	ACT_SUBVARG			((4<<8)|255)
#define	ACTL_SUBVARG		((4<<16)|65535)
#define	ACT_ADDVARG			((5<<8)|255)
#define	ACTL_ADDVARG		((5<<16)|65535)
#define	ACT_GRPACTIVATE		((6<<8)|255)
#define	ACTL_GRPACTIVATE	((6<<16)|65535)
#define	ACT_GRPDEACTIVATE	((7<<8)|255)
#define	ACTL_GRPDEACTIVATE	((7<<16)|65535)
#define	ACT_MENUACTIVATE	((8<<8)|255)
#define	ACT_MENUDEACTIVATE	((9<<8)|255)
#define	ACT_MENUCHECK		((10<<8)|255)
#define	ACT_MENUNCHECK		((11<<8)|255)
#define	ACT_MENUSHOW		((12<<8)|255)
#define	ACTL_MENUSHOW		((12<<16)|65535)
#define	ACT_MENUHIDE		((13<<8)|255)
#define	ACTL_MENUHIDE		((13<<16)|65535)
#define	ACT_STARTLOOP		((14<<8)|255)
#define	ACT_STOPLOOP		((15<<8)|255)
#define	ACT_SETLOOPINDEX	((16<<8)|255)
#define	ACT_RANDOMIZE		((17<<8)|255)
#define ACT_SENDMENUCMD		((18<<8)|255)
#define ACT_SETGLOBALSTRING	((19<<8)|255)
#define	ACTL_SETGLOBALSTRING ((19<<16)|65535)
#define ACT_SENDCLIPBOARD	((20<<8)|255)
#define ACT_CLEARCLIPBOARD	((21<<8)|255)
#define ACT_EXECPROG2		((22<<8)|255)
#define ACT_OPENDEBUGGER	((23<<8)|255)
#define ACT_PAUSEDEBUGGER	((24<<8)|255)
#define ACT_EXTRACTBINFILE	((25<<8)|255)
#define ACT_RELEASEBINFILE	((26<<8)|255)

#define	EXP_LONG			((0<<8)|255)
#define	EXPL_LONG			((0<<16)|65535)
#define	EXP_RANDOM			((1<<8)|255)
#define	EXPL_RANDOM			((1<<16)|65535)
#define	EXP_VARGLO			((2<<8)|255)
#define	EXPL_VARGLO			((2<<16)|65535)
#define	EXP_STRING			((3<<8)|255)
#define	EXPL_STRING			((3<<16)|65535)
#define	EXP_STR				((4<<8)|255)
#define	EXPL_STR			((4<<16)|65535)
#define	EXP_VAL				((5<<8)|255)
#define	EXPL_VAL			((5<<16)|65535)
#define	EXP_DRIVE			((6<<8)|255)
#define	EXPL_DRIVE			((6<<16)|65535)
#define	EXP_DIRECTORY		((7<<8)|255)
#define	EXPL_DIRECTORY		((7<<16)|65535)
#define	EXP_PATH			((8<<8)|255)
#define	EXPL_PATH			((8<<16)|65535)
#define	EXP_APPNAME			((9<<8)|255)
#define	EXPL_APPNAME		((9<<16)|65535)
#define EXP_SIN				((10<<8)|255)
#define EXPL_SIN			((10<<16)|65535)
#define EXP_COS				((11<<8)|255)
#define EXPL_COS			((11<<16)|65535)
#define EXP_TAN				((12<<8)|255)
#define EXPL_TAN			((12<<16)|65535)
#define EXP_SQR				((13<<8)|255)
#define EXPL_SQR			((13<<16)|65535)
#define EXP_LOG				((14<<8)|255)
#define EXPL_LOG			((14<<16)|65535)
#define EXP_LN				((15<<8)|255)
#define EXPL_LN				((15<<16)|65535)
#define EXP_HEX				((16<<8)|255)
#define EXPL_HEX			((16<<16)|65535)
#define EXP_BIN				((17<<8)|255)
#define EXPL_BIN			((17<<16)|65535)
#define EXP_EXP				((18<<8)|255)
#define EXPL_EXP			((18<<16)|65535)
#define EXP_LEFT			((19<<8)|255)
#define EXPL_LEFT			((19<<16)|65535)
#define EXP_RIGHT			((20<<8)|255)
#define EXPL_RIGHT			((20<<16)|65535)
#define EXP_MID				((21<<8)|255)
#define EXPL_MID			((21<<16)|65535)
#define EXP_LEN				((22<<8)|255)
#define EXPL_LEN			((22<<16)|65535)
#define	EXP_DOUBLE			((23<<8)|255)
#define	EXPL_DOUBLE			((23<<16)|65535)
#define	EXP_VARGLONAMED		((24<<8)|255)
#define	EXPL_VARGLONAMED	((24<<16)|65535)
#define EXP_ENTERSTRINGHERE	((25<<8)|255)
#define EXPL_ENTERSTRINGHERE ((25<<16)|65535)
#define EXP_ENTERVALUEHERE	((26<<8)|255)
#define EXPL_ENTERVALUEHERE	((26<<16)|65535)
#define	EXP_FLOAT			((27<<8)|255)
#define	EXPL_FLOAT			((27<<16)|65535)
#define	EXP_INT				((28<<8)|255)
#define	EXPL_INT			((28<<16)|65535)
#define EXP_ABS				((29<<8)|255)
#define EXPL_ABS			((29<<16)|65535)
#define EXP_CEIL			((30<<8)|255)
#define EXPL_CEIL			((30<<16)|65535)
#define	EXP_FLOOR			((31<<8)|255)
#define	EXPL_FLOOR			((31<<16)|65535)
#define	EXP_ACOS			((32<<8)|255)
#define	EXPL_ACOS			((32<<16)|65535)
#define	EXP_ASIN			((33<<8)|255)
#define	EXPL_ASIN			((33<<16)|65535)
#define	EXP_ATAN			((34<<8)|255)
#define	EXPL_ATAN			((34<<16)|65535)
#define	EXP_NOT				((35<<8)|255)
#define	EXPL_NOT			((35<<16)|65535)
#define	EXP_NDROPFILES		((36<<8)|255)
#define	EXPL_NDROPFILES		((36<<16)|65535)
#define	EXP_DROPFILE		((37<<8)|255)
#define	EXPL_DROPFILE		((37<<16)|65535)
#define	EXP_GETCOMMANDLINE	((38<<8)|255)
#define	EXPL_GETCOMMANDLINE	((38<<16)|65535)
#define	EXP_GETCOMMANDITEM	((39<<8)|255)
#define	EXPL_GETCOMMANDITEM	((39<<16)|65535)
#define	EXP_MIN				((40<<8)|255)
#define	EXPL_MIN			((40<<16)|65535)
#define	EXP_MAX				((41<<8)|255)
#define	EXPL_MAX			((41<<16)|65535)
#define	EXP_GETRGB			((42<<8)|255)
#define	EXPL_GETRGB			((42<<16)|65535)
#define	EXP_GETRED			((43<<8)|255)
#define	EXPL_GETRED			((43<<16)|65535)
#define	EXP_GETGREEN		((44<<8)|255)
#define	EXPL_GETGREEN		((44<<16)|65535)
#define	EXP_GETBLUE			((45<<8)|255)
#define	EXPL_GETBLUE		((45<<16)|65535)
#define	EXP_LOOPINDEX		((46<<8)|255)
#define	EXPL_LOOPINDEX		((46<<16)|65535)
#define EXP_NEWLINE			((47<<8)|255)
#define EXPL_NEWLINE		((47<<16)|65535)
#define EXP_ROUND			((48<<8)|255)
#define EXPL_ROUND			((48<<16)|65535)
#define	EXP_STRINGGLO		((49<<8)|255)
#define	EXPL_STRINGGLO		((49<<16)|65535)
#define	EXP_STRINGGLONAMED	((50<<8)|255)
#define	EXPL_STRINGGLONAMED	((50<<16)|65535)
#define EXP_LOWER			((51<<8)|255)
#define EXPL_LOWER			((51<<16)|65535)
#define EXP_UPPER			((52<<8)|255)
#define EXPL_UPPER			((52<<16)|65535)
#define EXP_FIND			((53<<8)|255)
#define EXPL_FIND			((53<<16)|65535)
#define EXP_REVERSEFIND		((54<<8)|255)
#define EXPL_REVERSEFIND	((54<<16)|65535)
#define EXP_GETCLIPBOARD	((55<<8)|255)
#define	EXP_TEMPPATH		((56<<8)|255)
#define EXP_BINFILETEMPNAME	((57<<8)|255)
#define	EXP_FLOATSTR		((58<<8)|255)
#define	EXPL_FLOATSTR		((58<<16)|65535)
#define	EXP_ATAN2			((59<<8)|255)
#define	EXPL_ATAN2			((59<<16)|65535)
#define	EXP_ZERO			((60<<8)|255)
#define	EXPL_ZERO			((60<<16)|65535)
#define	EXP_EMPTY			((61<<8)|255)
#define	EXPL_EMPTY			((61<<16)|65535)

#define	EXP_PARENTH1		((-1<<8)|255)
#define	EXPL_PARENTH1		((-1<<16)|65535)
#define	EXP_PARENTH2		((-2<<8)|255)
#define	EXPL_PARENTH2		((-2<<16)|65535)
#define	EXP_VIRGULE			((-3<<8)|255)
#define	EXPL_VIRGULE		((-3<<16)|65535)

// SPEAKER Conditions / Actions 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// #define		TYPE_SPEAKER	  		-2
//(TYPE_SPEAKER&255)=254
#define CND_SPCHANNELPAUSED ((-9<<8)|254)
#define CNDL_SPCHANNELPAUSED ((-9<<16)|65534)
#define CND_NOSPCHANNELPLAYING ((-8<<8)|254)
#define CNDL_NOSPCHANNELPLAYING ((-8<<16)|65534)
#define	CND_MUSPAUSED		((-7<<8)|254)
#define	CND_SPSAMPAUSED		((-6<<8)|254)
#define	CNDL_SPSAMPAUSED	((-6<<16)|65534)
#define	CND_MUSICENDS		((-5<<8)|254)
#define	CNDL_MUSICENDS		((-5<<16)|65534)
#define	CND_NOMUSPLAYING	((-4<<8)|254)
#define	CNDL_NOMUSPLAYING	((-4<<16)|65534)
#define	CND_NOSAMPLAYING	((-3<<8)|254)
#define	CNDL_NOSAMPLAYING	((-3<<16)|65534)
#define	CND_NOSPMUSPLAYING	((-2<<8)|254)
#define	CND_NOSPSAMPLAYING	((-1<<8)|254)
#define	CNDL_NOSPSAMPLAYING	((-1<<16)|65534)
#define	ACT_PLAYSAMPLE		((0<<8)|254)
#define	ACTL_PLAYSAMPLE		((0<<16)|65534)
#define	ACT_STOPSAMPLE		((1<<8)|254)
#define	ACTL_STOPSAMPLE		((1<<16)|65534)
#define	ACT_PLAYMUSIC		((2<<8)|254)
#define	ACTL_PLAYMUSIC		((2<<16)|65534)
#define	ACT_STOPMUSIC		((3<<8)|254)
#define	ACTL_STOPMUSIC		((3<<16)|65534)
#define	ACT_PLAYLOOPSAMPLE 	((4<<8)|254)
#define	ACTL_PLAYLOOPSAMPLE ((4<<16)|65534)
#define	ACT_PLAYLOOPMUSIC 	((5<<8)|254)
#define	ACT_STOPSPESAMPLE	((6<<8)|254)
#define	ACTL_STOPSPESAMPLE	((6<<16)|65534)
#define	ACT_PAUSESAMPLE		((7<<8)|254)
#define	ACTL_PAUSESAMPLE	((7<<16)|65534)
#define	ACT_RESUMESAMPLE	((8<<8)|254)
#define	ACTL_RESUMESAMPLE	((8<<16)|65534)
#define	ACT_PAUSEMUSIC		((9<<8)|254)
#define	ACT_RESUMEMUSIC		((10<<8)|254)
#define	ACT_PLAYCHANNEL		((11<<8)|254)
#define	ACTL_PLAYCHANNEL	((11<<16)|65534)
#define	ACT_PLAYLOOPCHANNEL	((12<<8)|254)
#define	ACTL_PLAYLOOPCHANNEL	((12<<16)|65534)
#define	ACT_PAUSECHANNEL	((13<<8)|254)
#define	ACTL_PAUSECHANNEL	((13<<16)|65534)
#define	ACT_RESUMECHANNEL	((14<<8)|254)
#define	ACTL_RESUMECHANNEL	((14<<16)|65534)
#define	ACT_STOPCHANNEL		((15<<8)|254)
#define	ACTL_STOPCHANNEL		((15<<16)|65534)
#define	ACT_SETCHANNELPOS	((16<<8)|254)
#define	ACTL_SETCHANNELPOS	((16<<16)|65534)
#define	ACT_SETCHANNELVOL	((17<<8)|254)
#define	ACTL_SETCHANNELVOL	((17<<16)|65534)
#define	ACT_SETCHANNELPAN	((18<<8)|254)
#define	ACTL_SETCHANNELPAN	((18<<16)|65534)
#define	ACT_SETSAMPLEPOS	((19<<8)|254)
#define	ACTL_SETSAMPLEPOS	((19<<16)|65534)
#define	ACT_SETSAMPLEMAINVOL	((20<<8)|254)
#define	ACTL_SETSAMPLEMAINVOL	((20<<16)|65534)
#define	ACT_SETSAMPLEVOL		((21<<8)|254)
#define	ACTL_SETSAMPLEVOL		((21<<16)|65534)
#define	ACT_SETSAMPLEMALNPAN	((22<<8)|254)
#define	ACTL_SETSAMPLEMALNPAN	((22<<16)|65534)
#define	ACT_SETSAMPLEPAN		((23<<8)|254)
#define	ACTL_SETSAMPLEPAN		((23<<16)|65534)
#define ACT_PAUSEALLCHANNELS	((24<<8)|254)
#define ACTL_PAUSEALLCHANNELS	((24<<16)|65534)
#define ACT_RESUMEALLCHANNELS	((25<<8)|254)
#define ACTL_RESUMEALLCHANNELS	((25<<16)|65534)
#define ACT_PLAYMUSICFILE		((26<<8)|254)
#define ACT_PLAYLOOPMUSICFILE	((27<<8)|254)
#define ACT_PLAYFILECHANNEL		((28<<8)|254)
#define	ACTL_PLAYFILECHANNEL	((28<<16)|65534)
#define ACT_PLAYLOOPFILECHANNEL		((29<<8)|254)
#define ACTL_PLAYLOOPFILECHANNEL	((29<<16)|65534)
#define ACT_LOCKCHANNEL			((30<<8)|254)
#define ACTL_LOCKCHANNEL			((30<<16)|65534)
#define ACT_UNLOCKCHANNEL		((31<<8)|254)
#define ACTL_UNLOCKCHANNEL		((31<<16)|65534)
#define ACT_SETCHANNELFREQ		((32<<8)|254)
#define ACT_SETSAMPLEFREQ		((33<<8)|254)

#define	EXP_GETSAMPLEMAINVOL	((0<<8)|254)
#define	EXP_GETSAMPLEVOL		((1<<8)|254)
#define	EXP_GETCHANNELVOL		((2<<8)|254)
#define	EXPL_GETCHANNELVOL		((2<<16)|65534)
#define	EXP_GETSAMPLEMAINPAN	((3<<8)|254)
#define	EXP_GETSAMPLEPAN		((4<<8)|254)
#define	EXP_GETCHANNELPAN		((5<<8)|254)
#define	EXPL_GETCHANNELPAN		((5<<16)|65534)
#define	EXP_GETSAMPLEPOS		((6<<8)|254)
#define	EXP_GETCHANNELPOS		((7<<8)|254)
#define	EXPL_GETCHANNELPOS		((7<<16)|65534)
#define	EXP_GETSAMPLEDUR		((8<<8)|254)
#define	EXP_GETCHANNELDUR		((9<<8)|254)
#define	EXP_GETSAMPLEFREQ		((10<<8)|254)
#define	EXP_GETCHANNELFREQ		((11<<8)|254)


// GAME Conditions / Actions 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//#define		TYPE_GAME		  		-3
//(TYPE_GAME&255)=253

#define CND_FRAMESAVED		((-10<<8)|253)
#define CND_FRAMELOADED		((-9<<8)|253)
#define	CNDL_ENDOFPAUSE		((-8<<16)|65533)
#define CND_ENDOFPAUSE		((-8<<8)|253)
#define CND_ISVSYNCON		((-7<<8)|253)
#define	CND_ISLADDER		((-6<<8)|253)
#define	CND_ISOBSTACLE		((-5<<8)|253)
#define	CND_QUITAPPLICATION	((-4<<8)|253)
#define	CNDL_QUITAPPLICATION	((-4<<16)|65533)
#define	CND_LEVEL			((-3<<8)|253)
#define	CND_END				((-2<<8)|253)
#define	CNDL_END			((-2<<16)|65533)
#define	CND_START			((-1<<8)|253)
#define	CNDL_START			((-1<<16)|65533)

#define	ACT_NEXTLEVEL       ((0<<8)|253)
#define	ACTL_NEXTLEVEL       ((0<<16)|65533)
#define	ACT_PREVLEVEL       ((1<<8)|253)
#define	ACTL_PREVLEVEL       ((1<<16)|65533)
#define	ACT_GOLEVEL     	((2<<8)|253)
#define	ACTL_GOLEVEL     	((2<<16)|65533)
#define	ACT_PAUSE           ((3<<8)|253)
#define	ACT_ENDGAME         ((4<<8)|253)
#define	ACTL_ENDGAME         ((4<<16)|65533)
#define	ACT_RESTARTGAME     ((5<<8)|253)
#define	ACTL_RESTARTGAME     ((5<<16)|65533)
#define	ACT_RESTARTLEVEL    ((6<<8)|253)
#define	ACT_CDISPLAY	    ((7<<8)|253)
#define	ACT_CDISPLAYX	    ((8<<8)|253)
#define	ACT_CDISPLAYY	    ((9<<8)|253)
#define	ACT_LOADGAME		((10<<8)|253)
#define	ACT_SAVEGAME		((11<<8)|253)
#define ACT_CLS				((12<<8)|253)
#define	ACT_CLEARZONE		((13<<8)|253)
#define ACT_FULLSCREENMODE	((14<<8)|253)
#define ACT_WINDOWEDMODE	((15<<8)|253)
#define ACT_SETFRAMERATE	((16<<8)|253)
#define ACT_PAUSEKEY		((17<<8)|253)
#define ACT_PAUSEANYKEY		((18<<8)|253)
#define	ACT_SETVSYNCON		((19<<8)|253)
#define	ACT_SETVSYNCOFF		((20<<8)|253)
#define	ACT_SETVIRTUALWIDTH	((21<<8)|253)
#define	ACT_SETVIRTUALHEIGHT ((22<<8)|253)
#define ACT_SETFRAMEBDKCOLOR ((23<<8)|253)
#define ACT_DELCREATEDBKDAT ((24<<8)|253)
#define ACT_DELALLCREATEDBKD ((25<<8)|253)
#define ACT_SETFRAMEWIDTH	((26<<8)|253)
#define ACT_SETFRAMEHEIGHT	((27<<8)|253)
#define ACT_SAVEFRAME		((28<<8)|253)
#define ACT_LOADFRAME		((29<<8)|253)
#define ACT_LOADAPPLICATION	((30<<8)|253)
#define ACT_PLAYDEMO		((31<<8)|253)
#define ACT_SETFRAMEEFFECT	((32<<8)|253)
#define ACT_SETFRAMEEFFECTPARAM	((33<<8)|253)
#define ACT_SETFRAMEEFFECTPARAMTEXTURE	((34<<8)|253)
#define ACT_SETFRAMEALPHACOEF	((35<<8)|253)
#define ACT_SETFRAMERGBCOEF	((36<<8)|253)

#define	EXP_GAMLEVEL		((0<<8)|253)
#define	EXP_GAMNPLAYER		((1<<8)|253)
#define	EXP_PLAYXLEFT		((2<<8)|253)
#define	EXP_PLAYXRIGHT		((3<<8)|253)
#define	EXP_PLAYYTOP		((4<<8)|253)
#define	EXP_PLAYYBOTTOM		((5<<8)|253)
#define	EXP_PLAYWIDTH		((6<<8)|253)
#define	EXP_PLAYHEIGHT		((7<<8)|253)
#define	EXP_GAMLEVELNEW		((8<<8)|253)
#define	EXP_GETCOLLISIONMASK ((9<<8)|253)
#define EXP_FRAMERATE		((10<<8)|253)
#define EXP_GETVIRTUALWIDTH	((11<<8)|253)
#define EXP_GETVIRTUALHEIGHT ((12<<8)|253)
#define EXP_GETFRAMEBKDCOLOR ((13<<8)|253)
#define	EXP_GRAPHICMODE		((14<<8)|253)
#define	EXP_PIXELSHADERVERSION ((15<<8)|253)
#define EXP_FRAMEALPHACOEF	((16<<8)|253)
#define EXP_FRAMERGBCOEF	((17<<8)|253)
#define EXP_FRAMEEFFECTPARAM	((18<<8)|253)


// TIMER Conditions / Actions 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define	CND_TIMEOUT       	((-5<<8)|(OBJ_TIMER&255))
#define	CND_EVERY       	((-4<<8)|(OBJ_TIMER&255))
#define	CNDL_EVERY       	((-4<<16)|(OBJ_TIMER&0xFFFF))
#define	CND_TIMER       	((-3<<8)|(OBJ_TIMER&255))
#define	CNDL_TIMER       	((-3<<16)|(OBJ_TIMER&0xFFFF))
#define	CND_TIMERINF       	((-2<<8)|(OBJ_TIMER&255))
#define	CNDL_TIMERINF      	((-2<<16)|(OBJ_TIMER&0xFFFF))
#define	CND_TIMERSUP       	((-1<<8)|(OBJ_TIMER&255))
#define	CNDL_TIMERSUP      	((-1<<16)|(OBJ_TIMER&0xFFFF))
#define	ACT_SETTIMER        ((0<<8)|(OBJ_TIMER&255))
#define	EXP_TIMVALUE		((0<<8)|(OBJ_TIMER&255))
#define	EXP_TIMCENT			((1<<8)|(OBJ_TIMER&255))
#define	EXP_TIMSECONDS		((2<<8)|(OBJ_TIMER&255))
#define	EXP_TIMHOURS		((3<<8)|(OBJ_TIMER&255))
#define	EXP_TIMMINITS		((4<<8)|(OBJ_TIMER&255))
#define	NUM_EVERY       	-4
#define	NUM_TIMER       	-3
#define	NUM_TIMERINF       	-2
#define	NUM_TIMERSUP       	-1

// KEYBOARD Conditions / Actions
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define	CNDL_ONMOUSEWHEELDOWN  	((-12<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_ONMOUSEWHEELDOWN   	((-12<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_ONMOUSEWHEELUP  	((-11<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_ONMOUSEWHEELUP   	((-11<<8)|(OBJ_KEYBOARD&255))
#define	CND_MOUSEON		   	((-10<<8)|(OBJ_KEYBOARD&255))
#define	CND_ANYKEY			((-9<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_ANYKEY			((-9<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_MKEYDEPRESSED	((-8<<8)|(OBJ_KEYBOARD&255))
#define	CND_MCLICKONOBJECT	((-7<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_MCLICKONOBJECT	((-7<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_MCLICKINZONE 	((-6<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_MCLICKINZONE 	((-6<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_MCLICK	 		((-5<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_MCLICK	 		((-5<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_MONOBJECT		((-4<<8)|(OBJ_KEYBOARD&255))
#define	CNDL_MONOBJECT		((-4<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	CND_MINZONE			((-3<<8)|(OBJ_KEYBOARD&255))
#define	CND_KBKEYDEPRESSED 	((-2<<8)|(OBJ_KEYBOARD&255))
#define	CND_KBPRESSKEY   	((-1<<8)|(OBJ_KEYBOARD&255))
#define CNDL_KBPRESSKEY		((-1<<16)|(OBJ_KEYBOARD&0xFFFF))
#define	ACT_HIDECURSOR		((0<<8)|(OBJ_KEYBOARD&255))
#define	ACT_SHOWCURSOR		((1<<8)|(OBJ_KEYBOARD&255))
#define	EXP_XMOUSE			((0<<8)|(OBJ_KEYBOARD&255))
#define	EXP_YMOUSE			((1<<8)|(OBJ_KEYBOARD&255))
#define	EXP_MOUSEWHEELDELTA	((2<<8)|(OBJ_KEYBOARD&255))


// PLAYERS Conditions / Actions 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define	CND_JOYPUSHED		((-6<<8)|(OBJ_PLAYER&255))
#define	CND_NOMORELIVE		((-5<<8)|(OBJ_PLAYER&255))
#define	CNDL_NOMORELIVE		((-5<<16)|(OBJ_PLAYER&0xFFFF))
#define	CND_JOYPRESSED		((-4<<8)|(OBJ_PLAYER&255))
#define	CNDL_JOYPRESSED		((-4<<16)|(OBJ_PLAYER&0xFFFF))
#define	CND_LIVE	        ((-3<<8)|(OBJ_PLAYER&255))
#define	CND_SCORE		    ((-2<<8)|(OBJ_PLAYER&255))
#define	CND_PLAYERPLAYING   ((-1<<8)|(OBJ_PLAYER&255))

#define	ACT_SETSCORE	  	((0<<8)|(OBJ_PLAYER&255))
#define	ACT_SETLIVES      	((1<<8)|(OBJ_PLAYER&255))
#define	ACT_NOINPUT      	((2<<8)|(OBJ_PLAYER&255))
#define	ACT_RESTINPUT      	((3<<8)|(OBJ_PLAYER&255))
#define	ACT_ADDSCORE	  	((4<<8)|(OBJ_PLAYER&255))
#define	ACT_ADDLIVES      	((5<<8)|(OBJ_PLAYER&255))
#define	ACT_SUBSCORE	  	((6<<8)|(OBJ_PLAYER&255))
#define	ACT_SUBLIVES      	((7<<8)|(OBJ_PLAYER&255))
#define	ACT_SETINPUT	  	((8<<8)|(OBJ_PLAYER&255))
#define	ACT_SETINPUTKEY    	((9<<8)|(OBJ_PLAYER&255))
#define	ACT_SETPLAYERNAME	((10<<8)|(OBJ_PLAYER&255))

#define	EXP_PLASCORE		((0<<8)|(OBJ_PLAYER&255))
#define	EXP_PLALIVES		((1<<8)|(OBJ_PLAYER&255))
#define	EXP_GETINPUT		((2<<8)|(OBJ_PLAYER&255))
#define	EXP_GETINPUTKEY		((3<<8)|(OBJ_PLAYER&255))
#define	EXP_GETPLAYERNAME	((4<<8)|(OBJ_PLAYER&255))
#define	NUM_JOYPRESSED		-4

// CREATE Conditions / Actions 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define	CND_CHOOSEALLINLINE	((-23<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEFLAGRESET	((-22<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEFLAGSET 	((-21<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEVALUE 	((-20<<8)|(OBJ_CREATE&255))
#define	CND_PICKFROMID		((-19<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEALLINZONE ((-18<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEALL       ((-17<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEZONE      ((-16<<8)|(OBJ_CREATE&255))
#define	CND_NUMOFALLOBJECT  ((-15<<8)|(OBJ_CREATE&255))
#define	CND_NUMOFALLZONE    ((-14<<8)|(OBJ_CREATE&255))
#define	CND_NOMOREALLZONE   ((-13<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEFLAGRESET_OLD	((-12<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEFLAGSET_OLD 	((-11<<8)|(OBJ_CREATE&255))
//...
#define	CND_CHOOSEVALUE_OLD 	((-8<<8)|(OBJ_CREATE&255))
#define	CND_PICKFROMID_OLD		((-7<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEALLINZONE_OLD ((-6<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEALL_OLD       ((-5<<8)|(OBJ_CREATE&255))
#define	CND_CHOOSEZONE_OLD      ((-4<<8)|(OBJ_CREATE&255))
#define	CND_NUMOFALLOBJECT_OLD  ((-3<<8)|(OBJ_CREATE&255))
#define	CND_NUMOFALLZONE_OLD    ((-2<<8)|(OBJ_CREATE&255))
#define	CND_NOMOREALLZONE_OLD   ((-1<<8)|(OBJ_CREATE&255))
#define	ACT_CREATE				((0<<8)|(OBJ_CREATE&255))
#define	EXP_CRENUMBERALL		((0<<8)|(OBJ_CREATE&255))
#define	NUM_END				-2
#define	NUM_START			-1

#endif
           
// BALL Movements
// ~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	tagMB {
	WORD	mbSpeed;
	WORD	mbBounce;
	WORD	mbAngles;
	WORD	mbSecurity;
	WORD	mbDecelerate;
	WORD	mbFree;
	} MoveBall;
typedef	MoveBall * LPMOVEBALL;

// MOUSE movement
// ~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	tagMM {
	short		mmDx;      				
	short		mmFx;
	short		mmDy;
	short		mmFy;
	short		mmFlags;
	} MoveMouse;
typedef	MoveMouse * LPMOVEMOUSE;

#define MOUSE_XCENTER		100
#define MOUSE_YCENTER		100
#define	MMMODE_NORMAL		0
#define	MMMODE_HIDDEN		1
#define	MMMODE_REMOVED		2

// 8 Direction movement
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	tagMG {
	WORD	mgSpeed;				// Max speed
	WORD	mgAcc;					// Acceleration
	WORD	mgDec;					// Deceleration
	WORD	mgBounceMult;			// Bounce factor
	unsigned int	mgDir;					// Allowed directions
	} MoveGeneric;
typedef	MoveGeneric	* LPMOVEGENERIC;

// RACE-CAR movement
// ~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	tagMR {
	WORD	mrSpeed;				// Max speed
	WORD	mrAcc;					// Acceleration
	WORD	mrDec;					// Deceleration
	WORD	mrRot;					// Rotating speed
	WORD	mrBounceMult;			// Bounce factor
	WORD	mrAngles;				// Number of angles
	WORD	mrOkReverse;			// Allowed reverse speed?
	} MoveRace;
typedef	MoveRace	* LPMOVERACE;

// Path movement
// ~~~~~~~~~~~~~~~~~~~~~~~~~
// Structure for one move
typedef struct tagMDV1 {
	BYTE	mdSpeed;
	BYTE	mdDir;
	short	mdDx;
	short	mdDy;
	short	mdCosinus;
	short	mdSinus;
	short	mdLength;
	short	mdPause;
	} MoveDefV1;
typedef	MoveDefV1	* LPMOVEDEFV1;

typedef struct tagMD {
	BYTE	mdPrevious;
	BYTE	mdNext;
	BYTE	mdSpeed;
	BYTE	mdDir;
	short	mdDx;
	short	mdDy;
	short	mdCosinus;
	short	mdSinus;
	short	mdLength;
	short	mdPause;
	TCHAR	mdName[2];
	} MoveDef;
typedef	MoveDef	* LPMOVEDEF;

// Movement edition
typedef struct tagME {
	int		meSpeed;
	int		meDx;
	int		meDy;
	int		meFlag;
	int		meX;
	int		meY;
	int		meDelay;
	TCHAR *	meName;
	} MoveEdit;
typedef	MoveEdit * LPMOVEEDIT;

typedef struct tagMA {
	MoveEdit	me[1];
	}MoveArray;
#define	sizeof_MoveArray		(sizeof(MoveArray)-sizeof(MoveEdit))
typedef	MoveArray * LPMOVEARRAY;

typedef struct tagMT {
	WORD	mtNumber;				// Number of movement 
	WORD	mtMinSpeed; 			// maxs and min speed in the movements 
	WORD	mtMaxSpeed;
	BYTE	mtLoop;					// Loop at end
	BYTE	mtRepos;				// Reposition at end
	BYTE	mtReverse;				// Pingpong?
	BYTE	mtFree;
	BYTE	mtMoves[2];				// Start of movement definition
	} MoveTaped;
typedef	MoveTaped	* LPMOVETAPED;

// PLATFORM mouvement 
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	tagMP {
	WORD	mpSpeed;				// Max speed
	WORD	mpAcc;					// Acceleration
	WORD	mpDec;					// Deceleration
	WORD	mpJumpControl;			// Bounce factor
	WORD	mpGravity;
	WORD	mpJump;
	} MovePlatform;
typedef	MovePlatform *	LPMOVEPLATFORM;

#define	MPJC_NOJUMP		0
#define	MPJC_DIAGO		1
#define	MPJC_BUTTON1	2
#define	MPJC_BUTTON2	3

// Movement Extension structure
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct	MoveExt {
	CMvt*	meMvt;				// Object
} MoveExt;
typedef	MoveExt *	LPMOVEEXT;

// Movement Structure
// ~~~~~~~~~~~~~~~~~~
typedef struct MvtHdr {
	unsigned int	mvhModuleNameOffset;
	unsigned int	mvhID;
	unsigned int	mvhDataOffset;
	unsigned int	mvhDataSize;
} MvtHdr;

typedef struct MovementTable
{
	unsigned int	mvtNMvt;				// Number of movements
	MvtHdr	mvtHdr[1];
} MovementTable;
typedef MovementTable * LPMVTTABLE;

#define MVTOPT_8DIR_STICK	0x01	// Stick to obstacles (build 249, 8-direction mvt), allows the user to choose between behavior of b247 (avoid obstacles) and b248 (stick to obstacles)

typedef struct 	tagMV {
	WORD	mvControl;				// Who controls the object
	WORD	mvType;					// Type of movement
	BYTE	mvMove;					// Move at start?
	BYTE	mvOpt;					// Options
	BYTE	mvFree1;
	BYTE	mvFree2;
	unsigned int	mvDirAtStart;
	union	{
			MoveMouse		mm;
			MoveGeneric		mg;
			MoveBall	  	mb;
			MoveTaped		mt;
			MoveRace		mr;
			MovePlatform	mp;
			MoveExt			me;
	} mu;
} Movement;
typedef	Movement	*	LPMOVEMENT;

#ifndef IN_KPX
           
// COMMON CONDITIONS FOR NORMAL OBJECTS
//////////////////////////////////////////
#define	EVENTS_EXTBASE				80

#define	CND_EXTISSTRIKEOUT			(-40<<8)
#define CND_EXTISUNDERLINE			(-39<<8)
#define CND_EXTISITALIC				(-38<<8)
#define CND_EXTISBOLD				(-37<<8)
#define	CND_EXTCMPVARSTRING			(-36<<8)
#define	CNDL_EXTCMPVARSTRING		(-36<<16)
#define	CND_EXTPATHNODENAME			(-35<<8)
#define	CNDL_EXTPATHNODENAME		(-35<<16)
#define	CND_EXTCHOOSE				(-34<<8)
#define	CND_EXTNOMOREOBJECT			(-33<<8)
#define	CNDL_EXTNOMOREOBJECT		(-33<<16)
#define	CND_EXTNUMOFOBJECT			(-32<<8)
#define	CND_EXTNOMOREZONE			(-31<<8)
#define	CND_EXTNUMBERZONE			(-30<<8)
#define	CND_EXTSHOWN				(-29<<8)
#define	CND_EXTHIDDEN				(-28<<8)
#define	CND_EXTCMPVAR				(-27<<8)
#define	CNDL_EXTCMPVAR				(-27<<16)
#define	CND_EXTCMPVARFIXED			(-26<<8)
#define	CND_EXTFLAGSET				(-25<<8)
#define	CND_EXTFLAGRESET			(-24<<8)
#define	CND_EXTISCOLBACK	        (-23<<8)
#define	CND_EXTNEARBORDERS	        (-22<<8)
#define	CND_EXTENDPATH	  	        (-21<<8)
#define	CNDL_EXTENDPATH	  	        (-21<<16)
#define	CND_EXTPATHNODE    	        (-20<<8)
#define	CNDL_EXTPATHNODE    	    (-20<<16)
#define	CND_EXTCMPACC	            (-19<<8)
#define	CND_EXTCMPDEC	 	        (-18<<8)
#define	CND_EXTCMPX	 	  	        (-17<<8)
#define	CND_EXTCMPY   		        (-16<<8)
#define	CND_EXTCMPSPEED             (-15<<8)
#define	CND_EXTCOLLISION   	        (-14<<8)
#define	CNDL_EXTCOLLISION   	    (-14<<16)
#define	CND_EXTCOLBACK              (-13<<8)
#define	CNDL_EXTCOLBACK             (-13<<16)
#define	CND_EXTOUTPLAYFIELD         (-12<<8)
#define	CNDL_EXTOUTPLAYFIELD        (-12<<16)
#define	CND_EXTINPLAYFIELD          (-11<<8)
#define	CNDL_EXTINPLAYFIELD         (-11<<16)
#define	CND_EXTISOUT	            (-10<<8)
#define	CNDL_EXTISOUT	            (-10<<16)
#define	CND_EXTISIN                 (-9 <<8)
#define	CNDL_EXTISIN                (-9 <<16)
#define	CND_EXTFACING               (-8 <<8)
#define	CND_EXTSTOPPED              (-7 <<8)
#define	CND_EXTBOUNCING	            (-6 <<8)
#define	CND_EXTREVERSED             (-5 <<8)
#define	CND_EXTISCOLLIDING          (-4 <<8)
#define	CNDL_EXTISCOLLIDING         (-4 <<16)
#define	CND_EXTANIMPLAYING          (-3 <<8)
#define	CND_EXTANIMENDOF        	(-2 <<8)
#define	CNDL_EXTANIMENDOF        	(-2 <<16)
#define	CND_EXTCMPFRAME     		(-1 <<8)

#define	ACT_EXTSETPOS		        (1 <<8)
#define	ACT_EXTSETX			        (2 <<8)
#define	ACT_EXTSETY			        (3 <<8)
#define	ACT_EXTSTOP			        (4 <<8)
#define	ACTL_EXTSTOP		        (4 <<16)
#define	ACT_EXTSTART		        (5 <<8)
#define	ACT_EXTSPEED		        (6 <<8)
#define	ACT_EXTMAXSPEED		        (7 <<8)
#define	ACT_EXTWRAP			        (8 <<8)
#define	ACTL_EXTWRAP		        (8 <<16)
#define	ACT_EXTBOUNCE		        (9 <<8)
#define	ACTL_EXTBOUNCE		        (9 <<16)
#define	ACT_EXTREVERSE		        (10<<8)
#define	ACT_EXTNEXTMOVE		        (11<<8)
#define	ACT_EXTPREVMOVE		        (12<<8)
#define	ACT_EXTSELMOVE		        (13<<8)
#define	ACT_EXTLOOKAT		        (14<<8)
#define	ACT_EXTSTOPANIM		        (15<<8)
#define	ACT_EXTSTARTANIM	        (16<<8)
#define	ACT_EXTFORCEANIM	        (17<<8)
#define	ACT_EXTFORCEDIR		        (18<<8)
#define	ACT_EXTFORCESPEED	        (19<<8)
#define	ACTL_EXTFORCESPEED	        (19<<16)
#define	ACT_EXTRESTANIM		        (20<<8)         
#define	ACT_EXTRESTDIR		        (21<<8)
#define	ACT_EXTRESTSPEED	        (22<<8)
#define	ACT_EXTSETDIR				(23<<8)
#define	ACT_EXTDESTROY				(24<<8)
#define	ACT_EXTSHUFFLE				(25<<8)
#define	ACTL_EXTSHUFFLE				(25<<16)
#define	ACT_EXTHIDE					(26<<8)
#define	ACT_EXTSHOW					(27<<8)
#define	ACT_EXTDISPLAYDURING		(28<<8)
#define	ACT_EXTSHOOT				(29<<8)
#define	ACTL_EXTSHOOT				(29<<16)
#define	ACT_EXTSHOOTTOWARD			(30<<8)
#define	ACTL_EXTSHOOTTOWARD			(30<<16)
#define	ACT_EXTSETVAR				(31<<8)
#define	ACTL_EXTSETVAR				(31<<16)
#define	ACT_EXTADDVAR				(32<<8)
#define	ACTL_EXTADDVAR				(32<<16)
#define	ACT_EXTSUBVAR				(33<<8)
#define	ACTL_EXTSUBVAR				(33<<16)
#define	ACT_EXTDISPATCHVAR			(34<<8)
#define	ACTL_EXTDISPATCHVAR			(34<<16)
#define	ACT_EXTSETFLAG				(35<<8)
#define	ACT_EXTCLRFLAG				(36<<8)
#define	ACT_EXTCHGFLAG				(37<<8)
#define	ACT_EXTINKEFFECT			(38<<8)
#define ACT_EXTSETSEMITRANSPARENCY	(39<<8)
#define ACT_EXTFORCEFRAME			(40<<8)
#define ACT_EXTRESTFRAME			(41<<8)
#define ACT_EXTSETACCELERATION		(42<<8)
#define ACT_EXTSETDECELERATION		(43<<8)
#define ACT_EXTSETROTATINGSPEED		(44<<8)
#define ACT_EXTSETDIRECTIONS		(45<<8)
#define ACT_EXTBRANCHNODE			(46<<8)
#define ACT_EXTSETGRAVITY			(47<<8)
#define ACT_EXTGOTONODE				(48<<8)
#define	ACT_EXTSETVARSTRING			(49<<8)
#define	ACTL_EXTSETVARSTRING		(49<<16)
#define ACT_EXTSETFONTNAME			(50<<8)
#define ACT_EXTSETFONTSIZE			(51<<8)
#define ACT_EXTSETBOLD				(52<<8)
#define ACT_EXTSETITALIC			(53<<8)
#define ACT_EXTSETUNDERLINE			(54<<8)
#define	ACT_EXTSETSRIKEOUT			(55<<8)
#define	ACT_EXTSETTEXTCOLOR			(56<<8)
#define ACT_EXTSPRFRONT				(57<<8)
#define ACT_EXTSPRBACK				(58<<8)
#define	ACT_EXTMOVEBEFORE			(59<<8)
#define	ACT_EXTMOVEAFTER			(60<<8)
#define ACT_EXTMOVETOLAYER			(61<<8)
#define ACT_EXTADDTODEBUGGER		(62<<8)
#define ACT_EXTSETEFFECT			(63<<8)
#define ACT_EXTSETEFFECTPARAM		(64<<8)
#define ACT_EXTSETALPHACOEF			(65<<8)
#define ACT_EXTSETRGBCOEF			(66<<8)
#define ACT_EXTSETEFFECTPARAMTEXTURE (67<<8)

#define	EXP_EXTYSPR        		    ( 1<<8)
#define	EXP_EXTISPR        		    ( 2<<8)
#define	EXP_EXTSPEED       		    ( 3<<8)
#define	EXP_EXTACC         		    ( 4<<8)
#define	EXP_EXTDEC         		    ( 5<<8)
#define	EXP_EXTDIR					( 6<<8)
#define	EXP_EXTXLEFT				( 7<<8)
#define	EXP_EXTXRIGHT				( 8<<8)
#define	EXP_EXTYTOP					( 9<<8)
#define	EXP_EXTYBOTTOM				(10<<8)
#define	EXP_EXTXSPR					(11<<8)
#define	EXP_EXTIDENTIFIER			(12<<8)
#define	EXP_EXTFLAG					(13<<8)
#define EXP_EXTNANI					(14<<8)
#define	EXP_EXTNOBJECTS				(15<<8)
#define	EXP_EXTVAR					(16<<8)
#define	EXPL_EXTVAR					(16<<16)
#define EXP_EXTGETSEMITRANSPARENCY	(17<<8)
#define EXP_EXTNMOVE				(18<<8)
#define	EXP_EXTVARSTRING			(19<<8)
#define	EXPL_EXTVARSTRING			(19<<16)
#define EXP_EXTGETFONTNAME			(20<<8)
#define EXP_EXTGETFONTSIZE			(21<<8)
#define EXP_EXTGETFONTCOLOR			(22<<8)
#define EXP_EXTGETLAYER				(23<<8)
#define EXP_EXTGETGRAVITY			(24<<8)
#define EXP_EXTXAP					(25<<8)
#define EXP_EXTYAP					(26<<8)
#define EXP_EXTALPHACOEF			(27<<8)
#define EXP_EXTRGBCOEF				(28<<8)
#define EXP_EXTEFFECTPARAM			(29<<8)
#define EXP_EXTVARBYINDEX			(30<<8)
#define EXP_EXTVARSTRINGBYINDEX		(31<<8)

// TEXT Conditions / Actions 
////////////////////////////////////////////
#define	ACT_STRDESTROY	  	 (( (EVENTS_EXTBASE+0)<<8)|3)
#define	ACT_STRDISPLAY		 (( (EVENTS_EXTBASE+1)<<8)|3)
#define	ACT_STRDISPLAYDURING (( (EVENTS_EXTBASE+2)<<8)|3)
#define	ACT_STRSETCOLOUR     (( (EVENTS_EXTBASE+3)<<8)|3)
#define	ACT_STRSET	   		 (( (EVENTS_EXTBASE+4)<<8)|3)
#define	ACT_STRPREV	   		 (( (EVENTS_EXTBASE+5)<<8)|3)
#define	ACT_STRNEXT	   		 (( (EVENTS_EXTBASE+6)<<8)|3)
#define ACT_STRDISPLAYSTRING (( (EVENTS_EXTBASE+7)<<8)|3)
#define	ACT_STRSETSTRING	 (( (EVENTS_EXTBASE+8)<<8)|3)
#define	EXP_STRNUMBER		 (( (EVENTS_EXTBASE+0)<<8)|3)
#define	EXP_STRGETCURRENT	 (( (EVENTS_EXTBASE+1)<<8)|3)
#define	EXP_STRGETNUMBER	 (( (EVENTS_EXTBASE+2)<<8)|3)
#define	EXP_STRGETNUMERIC	 (( (EVENTS_EXTBASE+3)<<8)|3)
#define EXP_STRGETNPARA		 (( (EVENTS_EXTBASE+4)<<8)|3)

// SPRITES Conditions / Actions 
/////////////////////////////////////////////
#define	CND_SPRCLICK	   	(((-EVENTS_EXTBASE-1)<<8)|2)
#define	ACT_SPRPASTE		(((EVENTS_EXTBASE+0)<<8)|2)
#define	ACT_SPRFRONT		(((EVENTS_EXTBASE+1)<<8)|2)
#define	ACT_SPRBACK			(((EVENTS_EXTBASE+2)<<8)|2)
#define	ACT_SPRADDBKD		(((EVENTS_EXTBASE+3)<<8)|2)
#define ACT_SPRREPLACECOLOR	(((EVENTS_EXTBASE+4)<<8)|2)
#define ACT_SPRSETSCALE		(((EVENTS_EXTBASE+5)<<8)|2)
#define ACT_SPRSETSCALEX	(((EVENTS_EXTBASE+6)<<8)|2)
#define ACT_SPRSETSCALEY	(((EVENTS_EXTBASE+7)<<8)|2)
#define ACT_SPRSETANGLE		(((EVENTS_EXTBASE+8)<<8)|2)
#define ACT_SPRLOADFRAME	(((EVENTS_EXTBASE+9)<<8)|2)
#define ACTL_SPRLOADFRAME	(((EVENTS_EXTBASE+9)<<16)|2)
#define EXP_GETRGBAT		(((EVENTS_EXTBASE+0)<<8)|2)
#define EXP_GETSCALEX		(((EVENTS_EXTBASE+1)<<8)|2)
#define EXP_GETSCALEY		(((EVENTS_EXTBASE+2)<<8)|2)
#define EXP_GETANGLE		(((EVENTS_EXTBASE+3)<<8)|2)

// COUNTERS Conditions / Actions 
//////////////////////////////////////////////
#define	CND_CCOUNTER	   	(((-EVENTS_EXTBASE-1)<<8)|7)
#define	ACT_CSETVALUE		(( (EVENTS_EXTBASE+0)<<8)|7)
#define	ACT_CADDVALUE		(( (EVENTS_EXTBASE+1)<<8)|7)
#define	ACT_CSUBVALUE		(( (EVENTS_EXTBASE+2)<<8)|7)
#define	ACT_CSETMIN			(( (EVENTS_EXTBASE+3)<<8)|7)
#define	ACT_CSETMAX			(( (EVENTS_EXTBASE+4)<<8)|7)
#define	ACT_CSETCOLOR1		(( (EVENTS_EXTBASE+5)<<8)|7)
#define	ACT_CSETCOLOR2		(( (EVENTS_EXTBASE+6)<<8)|7)
#define	EXP_CVALUE			(( (EVENTS_EXTBASE+0)<<8)|7)
#define	EXP_CGETMIN			(( (EVENTS_EXTBASE+1)<<8)|7)
#define	EXP_CGETMAX			(( (EVENTS_EXTBASE+2)<<8)|7)
#define	EXP_CGETCOLOR1		(( (EVENTS_EXTBASE+3)<<8)|7)
#define	EXP_CGETCOLOR2		(( (EVENTS_EXTBASE+4)<<8)|7)

// QUESTIONS Conditions / Actions 
///////////////////////////////////////////////
#define	CND_QEQUAL			(((-EVENTS_EXTBASE-3)<<8)|4)
#define	CNDL_QEQUAL			(((-EVENTS_EXTBASE-3)<<16)|4)
#define	CND_QFALSE		    (((-EVENTS_EXTBASE-2)<<8)|4)
#define	CNDL_QFALSE		    (((-EVENTS_EXTBASE-2)<<16)|4)
#define	CND_QEXACT		    (((-EVENTS_EXTBASE-1)<<8)|4)
#define	CNDL_QEXACT		    (((-EVENTS_EXTBASE-1)<<16)|4)
#define	ACT_QASK		    (( (EVENTS_EXTBASE+0)<<8)|4)


// Formatted text Conditions / actions / expressions 
//////////////////////////////////////////////////////////////////
#define	ACT_RTFSETXPOS					(((EVENTS_EXTBASE+0)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSETYPOS					(((EVENTS_EXTBASE+1)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSETZOOM					(((EVENTS_EXTBASE+2)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_CLEAR				(((EVENTS_EXTBASE+3)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_WORDSTRONCE		(((EVENTS_EXTBASE+4)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_WORDSTRNEXT		(((EVENTS_EXTBASE+5)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_WORDSTRALL		(((EVENTS_EXTBASE+6)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_WORD				(((EVENTS_EXTBASE+7)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_LINE				(((EVENTS_EXTBASE+8)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_PARAGRAPH			(((EVENTS_EXTBASE+9)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_PAGE				(((EVENTS_EXTBASE+10)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_ALL				(((EVENTS_EXTBASE+11)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_RANGE				(((EVENTS_EXTBASE+12)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFSELECT_BOOKMARK			(((EVENTS_EXTBASE+13)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFSETFOCUSWORD				(((EVENTS_EXTBASE+14)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHT_OFF				(((EVENTS_EXTBASE+15)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTTEXT_COLOR  		(((EVENTS_EXTBASE+16)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTTEXT_BOLD	  		(((EVENTS_EXTBASE+17)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTTEXT_ITALIC 		(((EVENTS_EXTBASE+18)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTTEXT_UNDERL 		(((EVENTS_EXTBASE+19)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTTEXT_OUTL	  		(((EVENTS_EXTBASE+20)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTBACK_COLOR  		(((EVENTS_EXTBASE+21)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTBACK_RECT	  		(((EVENTS_EXTBASE+22)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTBACK_MARKER 		(((EVENTS_EXTBASE+23)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTBACK_HATCH  		(((EVENTS_EXTBASE+24)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFHLIGHTBACK_INVERSE		(((EVENTS_EXTBASE+25)<<8)|(OBJ_RTF&0x00FF))
#define	ACT_RTFDISPLAY					(((EVENTS_EXTBASE+26)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFSETFOCUSPREV				(((EVENTS_EXTBASE+27)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFSETFOCUSNEXT				(((EVENTS_EXTBASE+28)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFREMOVEFOCUS				(((EVENTS_EXTBASE+29)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFAUTOON					(((EVENTS_EXTBASE+30)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFAUTOOFF					(((EVENTS_EXTBASE+31)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFINSERTSTRING				(((EVENTS_EXTBASE+32)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFLOADTEXT					(((EVENTS_EXTBASE+33)<<8)|(OBJ_RTF&0x00FF))
#define ACT_RTFINSERTTEXT				(((EVENTS_EXTBASE+34)<<8)|(OBJ_RTF&0x00FF))


#define	EXP_RTFXPOS						(((EVENTS_EXTBASE+0)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYPOS						(((EVENTS_EXTBASE+1)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSXPAGE					(((EVENTS_EXTBASE+2)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSYPAGE					(((EVENTS_EXTBASE+3)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFZOOM						(((EVENTS_EXTBASE+4)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFWORDMOUSE				(((EVENTS_EXTBASE+5)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFWORDXY					(((EVENTS_EXTBASE+6)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFWORD						(((EVENTS_EXTBASE+7)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXWORD					(((EVENTS_EXTBASE+8)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYWORD					(((EVENTS_EXTBASE+9)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSXWORD					(((EVENTS_EXTBASE+10)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSYWORD					(((EVENTS_EXTBASE+11)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFLINEMOUSE				(((EVENTS_EXTBASE+12)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFLINEXY					(((EVENTS_EXTBASE+13)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXLINE					(((EVENTS_EXTBASE+14)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYLINE					(((EVENTS_EXTBASE+15)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSXLINE					(((EVENTS_EXTBASE+16)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSYLINE					(((EVENTS_EXTBASE+17)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFPARAMOUSE				(((EVENTS_EXTBASE+18)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFPARAXY					(((EVENTS_EXTBASE+19)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXPARA					(((EVENTS_EXTBASE+20)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYPARA					(((EVENTS_EXTBASE+21)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSXPARA					(((EVENTS_EXTBASE+22)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFSYPARA					(((EVENTS_EXTBASE+23)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXWORDTEXT				(((EVENTS_EXTBASE+24)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYWORDTEXT				(((EVENTS_EXTBASE+25)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXLINETEXT				(((EVENTS_EXTBASE+26)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYLINETEXT				(((EVENTS_EXTBASE+27)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFXPARATEXT				(((EVENTS_EXTBASE+28)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFYPARATEXT				(((EVENTS_EXTBASE+29)<<8)|(OBJ_RTF&0x00FF))
#define	EXP_RTFMEMSIZE					(((EVENTS_EXTBASE+30)<<8)|(OBJ_RTF&0x00FF))
#define EXP_RTFGETFOCUSWORD				(((EVENTS_EXTBASE+31)<<8)|(OBJ_RTF&0x00FF))
#define EXP_RTFGETHYPERLINK				(((EVENTS_EXTBASE+32)<<8)|(OBJ_RTF&0x00FF))

#define CND_CCAISPAUSED					(((-EVENTS_EXTBASE-4)<<8)|(OBJ_CCA&0x00FF))
#define CND_CCAISVISIBLE				(((-EVENTS_EXTBASE-3)<<8)|(OBJ_CCA&0x00FF))
#define CND_CCAAPPFINISHED				(((-EVENTS_EXTBASE-2)<<8)|(OBJ_CCA&0x00FF))
#define CNDL_CCAAPPFINISHED				(((-EVENTS_EXTBASE-2)<<16)|(OBJ_CCA&0xFFFF))
#define CND_CCAFRAMECHANGED				(((-EVENTS_EXTBASE-1)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCARESTARTAPP				(((EVENTS_EXTBASE+0)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCARESTARTFRAME				(((EVENTS_EXTBASE+1)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCANEXTFRAME				(((EVENTS_EXTBASE+2)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCAPREVIOUSFRAME			(((EVENTS_EXTBASE+3)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCAENDAPP					(((EVENTS_EXTBASE+4)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCANEWAPP					(((EVENTS_EXTBASE+5)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCAJUMPFRAME				(((EVENTS_EXTBASE+6)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCASETGLOBALVALUE			(((EVENTS_EXTBASE+7)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCASHOW						(((EVENTS_EXTBASE+8)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCAHIDE						(((EVENTS_EXTBASE+9)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCASETGLOBALSTRING			(((EVENTS_EXTBASE+10)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCAPAUSEAPP					(((EVENTS_EXTBASE+11)<<8)|(OBJ_CCA&0x00FF))
#define ACT_CCARESUMEAPP				(((EVENTS_EXTBASE+12)<<8)|(OBJ_CCA&0x00FF))
#define EXP_CCAGETFRAMENUMBER			(((EVENTS_EXTBASE+0)<<8)|(OBJ_CCA&0x00FF))
#define EXP_CCAGETGLOBALVALUE			(((EVENTS_EXTBASE+1)<<8)|(OBJ_CCA&0x00FF))
#define EXP_CCAGETGLOBALSTRING			(((EVENTS_EXTBASE+2)<<8)|(OBJ_CCA&0x00FF))

#endif // IN_KPX

///////////////////////////////////////////////////////////////////////
//
// DEFINITION OF THE DIFFERENT PARAMETERS
//
///////////////////////////////////////////////////////////////////////

// -------------------------------- Objects
// W-Offset list OI
// W-Number 
// W-TYPE *** Version > FVERSION_NEWOBJECTS
#define		PARAM_OBJECT			1
#define		PS_OBJ					6

// -------------------------------- Time
// L-Timer
// L-Equivalent loops
#define		PARAM_TIME				2
#define		PS_TIM					8

// -------------------------------- Border
// W-border
#define		PARAM_BORDER			3
#define		PS_BOR					2
#define		BORDER_LEFT				1
#define		BORDER_RIGHT			2
#define		BORDER_TOP				4
#define		BORDER_BOTTOM			8
#define		BORDER_ALL				15

// -------------------------------- Direction
// W-direction
#define		PARAM_DIRECTION			4
#define		PS_DIR					2

// -------------------------------- Integer
// W-shorteger (or base)
// W-nothing (or maximum)
#define		PARAM_INTEGER			5
#define		PS_INT					4

// -------------------------------- Sample
#define		MAX_SOUNDNAME				64
#define		PSOUNDFLAG_UNINTERRUPTABLE	0x0001
#define		PSOUNDFLAG_BAD				0x0002
#define		PSOUNDFLAG_IPHONE_AUDIOPLAYER	0x0004
#define		PSOUNDFLAG_IPHONE_OPENAL		0x0008

typedef struct tagSSNDA {
	short	sndHandle;
	short	sndFlags;
	char	sndName[MAX_SOUNDNAME];
	} SoundParamA;
typedef struct tagSSNDW {
	short	sndHandle;
	short	sndFlags;
	WCHAR	sndName[MAX_SOUNDNAME];
	} SoundParamW;
typedef		SoundParamA *		LPSNDA;
typedef		SoundParamW *		LPSNDW;

#define		PARAM_SAMPLE			6
#ifdef _UNICODE
	#define		PS_SAM					sizeof(SoundParamW)
	#define		LPSND LPSNDW
#else
	#define		PS_SAM					sizeof(SoundParamA)
	#define		LPSND LPSNDA
#endif

// -------------------------------- Music
#define		PARAM_MUSIC				7
#ifdef _UNICODE
	#define		PS_MUS					sizeof(SoundParamW)
#else
	#define		PS_MUS					sizeof(SoundParamA)
#endif


// POSITION PARAM Structure 
// ~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct tagPPA {
	short		posOINUMParent;			//0
	short		posFlags;
	short		posX;					//4
	short		posY;
	short		posSlope;				//8
	short		posAngle;
	long		posDir;					//12
	ITEMTYPE	posTypeParent;			//16
	short		posOiList;				//18
	short		posLayer;				//20
	} PositionParam;
typedef	PositionParam *			 	LPPOS;

// CREATE PARAM Structure 
// ~~~~~~~~~~~~~~~~~~~~~~
typedef struct tagCDP {
	PositionParam   cdpPos;			// Position structure
	HFII			cdpHFII;		// FrameItemInstance number
	OINUM			cdpOi;			// OI of the object to create
//	unsigned int  			cdpFII;			
	unsigned int			cdpFree;
	} CreateDuplicateParam;
typedef	CreateDuplicateParam * 		LPCDP;

// SHOOT PARAM Structure, should be identical to CREATE PARAM !
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct tagSHT {
	CreateDuplicateParam	shtCdp;
	short					shtSpeed;		// Speed
	} ShootParam;
typedef	ShootParam 	* 					LPSHT;

#define		CPF_DIRECTION			0x0001
#define		CPF_ACTION				0x0002
#define		CPF_INITIALDIR			0x0004
#define		CPF_DEFAULTDIR			0x0008


// -------------------------------- Create
#define		PARAM_CREATE			9
#define		PS_CRE					sizeof(CreateDuplicateParam)

// -------------------------------- Animation
// W-Number
// B-Name
#define		PARAM_ANIMATION			10
#define		PS_ANI					32

// -------------------------------- Nothing
// W-
#define		PARAM_NOP				11
#define		PS_NOP					2

// -------------------------------- Player
// W-
#define		PARAM_PLAYER			12
#define		PS_PLA					2

// -------------------------------- Every
// L-delay
// L-compteur
#define		PARAM_EVERY				13
#define		PS_EVE					8

// -------------------------------- Virtual Key
// W- VK_Code
#define		PARAM_KEY				14
#define		PS_KEY					2

// -------------------------------- Speed= integer
// Expression
#define		PARAM_SPEED				15

// -------------------------------- Position
// W- Direction
#define		PARAM_POSITION	  		16
#define		PS_POS				   	sizeof(PositionParam)

// -------------------------------- Joystick Direcion 
// W- Direction
#define		PARAM_JOYDIRECTION 		17
#define		PS_JOY				   	2

// -------------------------------- Shoot param

#define		PARAM_SHOOT				18
#define		PS_SHT				   	sizeof(ShootParam)

// -------------------------------- Playfield Zone 
#define		PARAM_ZONE				19
#define		PS_ZNE					8
                     
// -------------------------------- System object position
// W- Direction
#define		PARAM_SYSCREATE		   	21
#define		PS_SSC  			   	sizeof(CreateDuplicateParam)

// -------------------------------- Expression
// W0- Id parametre originel
// W1- 0 (au moins!)
#define		PARAM_EXPRESSION	   	22
#define		PS_EXP  			   	14

// -------------------------------- Comparaison
// W0- Id comparaison
// W1- 0 (au moins!)
#define		PARAM_COMPARAISON	   	23

// -------------------------------- Text color 
// L0- RGB
// L0- Identificateur!
#define		PARAM_COLOUR		   	24
#define		PS_COL  			   	8

// -------------------------------- Work buffer
// L0-
#define		PARAM_BUFFER4		   	25
#define		PS_BU4  			   	4

// -------------------------------- Storyboard frame number 
// W0-
#define		PARAM_FRAME			   	26
#define		PS_FRA  			   	2

// -------------------------------- Number of loops for a sample
#define		PARAM_SAMLOOP		   	27
#define		PS_SLOOP				2
// -------------------------------- Number of loops for a music 
#define		PARAM_MUSLOOP		   	28
#define		PS_MLOOP				2
// -------------------------------- Direction
#define		PARAM_NEWDIRECTION	   	29
#define		PS_NDIR					4

// -------------------------------- Text number
#define		PARAM_TEXTNUMBER	 	31
#define		PS_TXN					4

// -------------------------------- Click definition
#define		PARAM_CLICK			 	32
#define		PS_KLK					4
#define		PARAMCLICK_MASK			0x00FF
#define		PARAMCLICK_DOUBLE		0x0100

// -------------------------------- External program
#define		PARAM_PROGRAM			33
typedef struct tagPRGA {
	short	prgFlags;				// Default flags
	char	prgPath[_MAX_PATH];		// Name of the program
	char	prgCommand[108];		// Command line
	} prgParamA;
typedef		prgParamA *			LPPRGA;	
typedef struct tagPRGW {
	short	prgFlags;				// Default flags
	WCHAR	prgPath[_MAX_PATH];		// Name of the program
	WCHAR	prgCommand[108];		// Command line
	} prgParamW;
typedef		prgParamW *			LPPRGW;	
#define PS_PRGA sizeof(prgParamA)
#define PS_PRGW sizeof(prgParamW)
#ifdef _UNICODE
#define prgParam prgParamW
#define PS_PRG sizeof(prgParamW)
#define LPPRG LPPRGW
#else
#define prgParam prgParamA
#define PS_PRG sizeof(prgParamA)
#define LPPRG LPPRGA
#endif

#define		PRGFLAGS_WAIT			0x0001                                                    
#define		PRGFLAGS_HIDE			0x0002

// -------------------------------- Global variable number 
#define		OLDPARAM_VARGLO			34
//#define		PS_VGLO					4

// -------------------------------- Condition sample (no flags)
// W-Number
// W-Flags
// W-Loops
// B-Name
#define		PARAM_CNDSAMPLE			35
// -------------------------------- Condition Music (no flags)
// W-Number
// W-Flags
// W-Loops
// B-Name
#define		PARAM_CNDMUSIC			36
// -------------------------------- Event editor remark
#define		PARAM_REMARK			37
typedef struct tagREMA {
	LOGFONTV1A	remLogFont;				// Font 
	COLORREF	remColorFont;			// Text color
	COLORREF	remColorBack;			// Background color
	short		remAlign;				// Alignement flags
	WORD		remTextId;				// Text number in the buffer
	char		remStyle[40];			// Style
	} paramRemarkA;
typedef		paramRemarkA*		LPRMKA;	
typedef struct tagREMW {
	LOGFONTV1W	remLogFont;				// Font 
	COLORREF	remColorFont;			// Text color
	COLORREF	remColorBack;			// Background color
	short		remAlign;				// Alignement flags
	WORD		remTextId;				// Text number in the buffer
	WCHAR		remStyle[40];			// Style
	} paramRemarkW;
typedef		paramRemarkW*		LPRMKW;	
#ifdef _UNICODE
#define PS_REM sizeof(paramRemarkW)
#define LPRMK LPRMKW
#else
#define PS_REM sizeof(paramRemarkA)
#define LPRMK LPRMKA
#endif

// -------------------------------- Group title
#define		PARAM_GROUP				38
#define		GROUP_MAXTITLE			80
#define		GROUP_MAXPASSWORD		16
typedef struct tagGRPW {
	short		grpFlags;					// Active / Unactive?
	short		grpId;						// Group identifier
	WCHAR		grpTitle[GROUP_MAXTITLE];	// Title
	WCHAR		grpPassword[GROUP_MAXPASSWORD];		// Protection 
	unsigned int		grpChecksum;				// Checksum
	} paramGroupW;
typedef paramGroupW* LPGRPW;
typedef struct tagGRPA {
	short		grpFlags;					// Active / Unactive?
	short		grpId;						// Group identifier
	char		grpTitle[GROUP_MAXTITLE];	// Title
	char		grpPassword[GROUP_MAXPASSWORD];		// Protection 
	unsigned int		grpChecksum;				// Checksum
	} paramGroupA;
typedef paramGroupA* LPGRPA;
typedef struct tagOLDGRP {
	short		grpFlags;					
	short		grpId;					
	char		grpTitle[GROUP_MAXTITLE];
	} paramGroupV0;
#define PS_GRPA sizeof(paramGroupA)
#define PS_GRPW sizeof(paramGroupW)
#ifdef _UNICODE
#define PS_GRP sizeof(paramGroupW)
#define LPGRP LPGRPW
#define GETEVPGRP(evpPtr) (LPGRPW)&evpPtr->evpW.evpW0
#else
#define PS_GRP sizeof(paramGroupA)
#define LPGRP LPGRPA
#define GETEVPGRP(evpPtr) (LPGRPA)&evpPtr->evpW.evpW0
#endif

#define		GRPFLAGS_INACTIVE		0x0001
#define		GRPFLAGS_CLOSED			0x0002
#define		GRPFLAGS_PARENTINACTIVE	0x0004
#define		GRPFLAGS_GROUPINACTIVE	0x0008
#define		GRPFLAGS_UNICODE		0x0010
//#define		GRPFLAGS_FADEIN			0x0004
//#define		GRPFLAGS_FADEOUT		0x0008
#define		GRPFLAGS_GLOBAL			0x0010
// Pour l'assemblage
typedef struct tagGRPLIST {
	unsigned int		glEvg;
	short		glId;
	} groupList;
typedef		groupList *		LPGL;	

// -------------------------------- A pointer to a group
#define		PARAM_GROUPOINTER		39
#define		PS_GPT					6
// L - Offset dans programme
// W - Identifier

// -------------------------------- A pointner to a filename
#define		PARAM_FILENAME			40
#define		PS_FILEN				_MAX_PATH
// B nom de fichier...

// -------------------------------- String pointer
#define		PARAM_STRING			41
#define		PS_STR					2
// B string

// -------------------------------- Time
// L-Timer
// L-Loops
// W-Comparaison
#define		PARAM_CMPTIME			42
#define		PS_CTIM					10

// --------------------------------- PASTE SPRITE
// W- Flags
// W- Security
#define		PARAM_PASTE				43
#define		PS_PASTE				4

// -------------------------------- MOUSEKEY VIRTUAL
// W- VK_Code
#define		PARAM_VMKEY				44
#define		PS_VMKEY				2

// -------------------------------- String expression
// W0- Id original parameter
// W1- 0 (at least!)
#define		PARAM_EXPSTRING		   	45

// -------------------------------- String comparaison
// W0- Id comparaison
// W1- 0 (at least!)
#define		PARAM_CMPSTRING		   	46

// -------------------------------- Ink effect
// W0- Id effect
// W1- Effet parameter
// L1- Free
#define		PARAM_INKEFFECT		   	47
#define		PS_INK					8

// -------------------------------- Menu
// L0- Identifier
// L1- Security
#define		PARAM_MENU		   		48
#define		PS_MENU					8

// Access to named variables
#define		PARAM_VARGLOBAL		   	49
#define		PS_VARGLOBAL  			4
#define		PARAM_ALTVALUE		   	50
#define		PS_ALTVALUE  			4
#define		PARAM_FLAG			   	51
#define		PS_FLAG  				4

// With expressions
#define		PARAM_VARGLOBAL_EXP		52
#define		PS_VARGLOBAL_EXP  		PS_EXP
#define		PARAM_ALTVALUE_EXP		53
#define		PS_ALTVALUE_EXP	 		PS_EXP
#define		PARAM_FLAG_EXP		   	54
#define		PS_FLAG_EXP  			PS_EXP

// -------------------------------- Extensions parameters
#define		PARAM_EXTENSION			55
#define		PARAM_EXTMAXSIZE		512
typedef struct 
{
	short pextSize;
	short pextType;
	short pextCode;
	char pextData[2];
} paramExt;
#define		PARAM_EXTSIZE			12
#define		PARAM_EXTBASE			1000

// -------------------------------- Direction
#define		PARAM_8DIRECTIONS	   	56
#define		PS_8DIR					4

// -------------------------------- Movement number
#define MAX_MVTNAME					32
typedef struct tagMvtParamA {
	short	mvtNumber;
	char	mvtName[MAX_MVTNAME];
	} MvtParamA;
typedef		MvtParamA *			LPMVTPA;
typedef struct tagMvtParamW {
	short	mvtNumber;
	WCHAR	mvtName[MAX_MVTNAME];
	} MvtParamW;
typedef		MvtParamW *			LPMVTPW;

#define		PARAM_MVT			57
#ifdef _UNICODE
#define		PS_MVT				sizeof(MvtParamW)
#define		LPMVTP LPMVTPW
#else
#define		PS_MVT				sizeof(MvtParamA)
#define		LPMVTP LPMVTPA
#endif

// Access to renamed variables
#define		PARAM_STRINGGLOBAL		58
#define		PS_STRINGGLOBAL  		4
#define		PARAM_STRINGGLOBAL_EXP	59
#define		PS_STRINGGLOBAL_EXP  	PS_EXP

// -------------------------------- External program II
#define		PARAM_PROGRAM2			60
typedef struct tagPRG2 {
	short	prgFlags;				// Default flags
	} prgParam2;
typedef		prgParam2 *			LPPRG2;	
#define		PS_PRG2					sizeof(prgParam2)

// -------------------------------- Alterable strings
#define		PARAM_ALTSTRING		   	61
#define		PS_ALTSTRING  			4
#define		PARAM_ALTSTRING_EXP		62
#define		PS_ALTSTRING_EXP	 	PS_EXP

// -------------------------------- A pointer to a filename, version 2
#define		PARAM_FILENAME2			63
#define		PS_FILEN				_MAX_PATH
// B nom de fichier...

// -------------------------------- The name of an effect
#define		PARAM_EFFECT			64
#define		PS_EFFECT				2
// B name of the effect


// STRUCTURE FOR FAST LOOPS
///////////////////////////////////////////////////////////////////////
typedef struct tagFL
{
	TCHAR *	next;
	TCHAR	name[64];
	WORD	flags;
	long	index;
} FastLoop;
typedef	FastLoop *	LPFL;

#define MAX_FASTLOOPNAME	64
#define FLFLAG_STOP			0x0001

///////////////////////////////////////////////////////////////
//
// DEBUGGER
//
///////////////////////////////////////////////////////////////
#define DBCOMMAND_RUNNING		0
#define DBCOMMAND_TORUN			1
#define DBCOMMAND_PAUSE			2
#define DBCOMMAND_TOPAUSE		3
#define DBCOMMAND_STEP			4

// TREE identification
enum
{
	DBTYPE_SYSTEM,
	DBTYPE_OBJECT,
	DBTYPE_HO,
	DBTYPE_MOVEMENT,
	DBTYPE_ANIMATION,
	DBTYPE_VALUES,
	DBTYPE_COUNTER,
	DBTYPE_SCORE,
	DBTYPE_LIVES,
	DBTYPE_TEXT,
	DBTYPE_EXTENSION
};

// Genric entries in the tree
enum
{
	DB_END=0xFFFF,
	DB_PARENT=0x8000
};
#define DB_EDITABLE		0x80

// Communication buffer size
#define DB_BUFFERSIZE			256

#define DB_MAXGLOBALVALUES		1000	// Maximum number of global values displayed in the debugger
#define DB_MAXGLOBALSTRINGS		1000

// System tree entries
enum
{
	DB_SYSTEM,
	DB_TIMER,
	DB_FPS,
	DB_FRAMENUMBER,
	DB_GLOBALVALUE,
	DB_GLOBALSTRING,
	DB_GVALUE,
	DB_GSTRING,
};
// Headerobject tree entries
enum
{
	DB_XY,
	DB_SIZE
};

// Movements tree entries
enum
{
	DB_MOVEMENTS,
	DB_MVTTYPE,
	DB_SPEED,
	DB_DIRECTION,
	DB_ACCELERATION,
	DB_DECELERATION
};

// Animations tree entries
enum
{
	DB_ANIMATIONS,
	DB_ANIMNAME,
	DB_FRAME
};

// Values tree entries
enum
{
	DB_VALUE,
	DB_VALUE0,
	DB_VALUE1,
	DB_VALUE2,
	DB_VALUE3,
	DB_VALUE4,
	DB_VALUE5,
	DB_VALUE6,
	DB_VALUE7,
	DB_VALUE8,
	DB_VALUE9,
	DB_VALUE10,
	DB_VALUE11,
	DB_VALUE12,
	DB_VALUE13,
	DB_VALUE14,
	DB_VALUE15,
	DB_VALUE16,
	DB_VALUE17,
	DB_VALUE18,
	DB_VALUE19,
	DB_VALUE20,
	DB_VALUE21,
	DB_VALUE22,
	DB_VALUE23,
	DB_VALUE24,
	DB_VALUE25,
	DB_ALTSTRING,
	DB_ALTSTRING0,
	DB_ALTSTRING1,
	DB_ALTSTRING2,
	DB_ALTSTRING3,
	DB_ALTSTRING4,
	DB_ALTSTRING5,
	DB_ALTSTRING6,
	DB_ALTSTRING7,
	DB_ALTSTRING8,
	DB_ALTSTRING9,
	DB_FLAGS,
	DB_FLAG0,
	DB_FLAG1,
	DB_FLAG2,
	DB_FLAG3,
	DB_FLAG4,
	DB_FLAG5,
	DB_FLAG6,
	DB_FLAG7,
	DB_FLAG8,
	DB_FLAG9,
	DB_FLAG10,
	DB_FLAG11,
	DB_FLAG12,
	DB_FLAG13,
	DB_FLAG14,
	DB_FLAG15,
	DB_FLAG16,
	DB_FLAG17,
	DB_FLAG18,
	DB_FLAG19,
	DB_FLAG20,
	DB_FLAG21,
	DB_FLAG22,
	DB_FLAG23,
	DB_FLAG24,
	DB_FLAG25,
	DB_FLAG26,
	DB_FLAG27,
	DB_FLAG28,
	DB_FLAG29,
	DB_FLAG30,
	DB_FLAG31
};
enum 
{
	DB_COUNTERVALUE,
	DB_COUNTERMIN,
	DB_COUNTERMAX
};	
enum 
{
	DB_SCOREVALUE
};	
enum 
{
	DB_LIVESVALUE
};	
enum 
{
	DB_TEXTVALUE
};	

#define GETDBPARAMTYPE(a)		((a&0xFF000000)>>24)
#define GETDBPARAMID(a)			((a&0x00FFFF00)>>8)
#define GETDBPARAMCOMMAND(a)	(a&0x000000FF)
#define GETDBPARAM(a, b, c)		((a&0xFF)<<24)|((b&0xFFFF)<<8)|(c&0xFF)

typedef struct
{
	char * pTitle;
	int value;
	char * pText;
	int lText;
} EditDebugInfoA;

typedef struct
{
	wchar_t * pTitle;
	int value;
	wchar_t * pText;
	int lText;
} EditDebugInfoW;

#ifdef _UNICODE
#define EditDebugInfo EditDebugInfoW
#else
#define EditDebugInfo EditDebugInfoA
#endif

///////////////////////////////////////////////////////////////////////
//
// RUNTIME BUFFER
//
///////////////////////////////////////////////////////////////////////

//Modes de demo
enum
{
	DEMONOTHING,
	DEMORECORD,
	DEMOPLAY,
};

typedef void (*ACTIONENDROUTINE)();

typedef void (*OBLROUTINE)(headerObject*);
typedef struct tagOBL {
	headerObject*	oblOffset;
	OBLROUTINE		oblRoutine;
	} objectsList;
typedef	objectsList *			LPOBL;

#define		GAMEBUFFERS_SIZE	(12*1024)
#define		GAME_MAXOBJECTS		266
#define		OBJECT_MAX			128L
#define		OBJECT_SIZE			256L
#define		OBJECT_SHIFT		8
#define		MAX_INTERMEDIATERESULTS		256
#define		STEP_TEMPSTRINGS	64

typedef struct tagRH2 {
	unsigned int		rh2OldPlayer;				// Previous player entries
	unsigned int		rh2NewPlayer;				// Modified player entries
	unsigned int		rh2InputMask;				// Inhibated players entries
	unsigned int		rh2InputPlayers;			// Valid players entries (mask!)
	BYTE 		rh2MouseKeys;				// Mousekey entries
	BYTE		rh2ActionLoop;				// Actions flag
	BYTE 		rh2ActionOn;				// Flag are we in actions?
	BYTE		rh2EnablePick;  			// Are we in pick for actions?

	int		  	rh2EventCount;				// Number of the event 
	qualToOi*	rh2EventQualPos;			// ***Position in event objects
	headerObject* rh2EventPos;				// ***Position in event objects
	objInfoList* rh2EventPosOiList; 		// ***Position in oilist for TYPE exploration 
	objInfoList* rh2EventPrev;				// ***Previous object address

	pev*		rh2PushedEvents;			// ***
	LPBYTE		rh2PushedEventsTop;			// ***
	LPBYTE		rh2PushedEventsMax;			// ***
	int	  		rh2NewPushedEvents;			// 

	int		  	rh2ActionCount;				// Action counter
	int		  	rh2ActionLoopCount;	  		// Action loops counter
	ACTIONENDROUTINE rh2ActionEndRoutine;	// End of action routine
	WORD	  	rh2CreationCount;			// Number of objects created since beginning of frame
	short		rh2EventType;					
	POINT 		rh2Mouse;					// Mouse coordinate
	POINT 		rh2MouseClient;				// Mouse coordinates in the window
	short	  	rh2CurrentClick;			// For click events II
	short		rh2Free2;					
	headerObject** rh2ShuffleBuffer;		// ***
	headerObject** rh2ShufflePos;			// ***
	int		  	rh2ShuffleNumber;			

	POINT		rh2MouseSave;				// Mouse saving when pause
	int		  	rh2PauseCompteur;
	unsigned int		rh2PauseTimer;
	UINT	  	rh2PauseVbl;
	FARPROC	   	rh2LoopTraceProc;       	// Debugging routine
	FARPROC	   	rh2EventTraceProc;

	} runHeader2;


// Flags pour rh3Scrolling
#define RH3SCROLLING_SCROLL					0x0001
#define RH3SCROLLING_REDRAWLAYERS			0x0002
#define RH3SCROLLING_REDRAWALL				0x0004
#define RH3SCROLLING_REDRAWTOTALCOLMASK		0x0008

#define	GAME_XBORDER		480
#define	GAME_YBORDER		300

typedef struct tagRH3 {

	WORD		rh3Graine;					// random generator seed
	WORD		rh3Free;					// Alignment...

	int		  	rh3DisplayX;				// To scroll
	int	  		rh3DisplayY;

	long		rh3CurrentMenu;				// For menu II events

	int 		rh3WindowSx;   				// Window size
	int 		rh3WindowSy;

	short	  	rh3CollisionCount;			// Collision counter 
	char		rh3DoStop;					// Force the test of stop actions
	char		rh3Scrolling;				// Flag: we need to scroll

	int		  	rh3Panic;

	int		  	rh3PanicBase;
	int		  	rh3PanicPile;

//	short	  	rh3XBorder_;				// Authorised border
//	short	  	rh3YBorder_;
	int	 	  	rh3XMinimum;   				// Object inactivation coordinates
	int	 	  	rh3YMinimum;
	int	 	  	rh3XMaximum;
	int	 	  	rh3YMaximum;
	int	 	  	rh3XMinimumKill;			// Object destruction coordinates
	int	 	  	rh3YMinimumKill;
	int	 	  	rh3XMaximumKill;
	int	 	  	rh3YMaximumKill;

	} runHeader3;

// Extensions 
// ~~~~~~~~~~~~~~~~~~~~
#define		KPX_MAXNUMBER					96
typedef struct tagKPXMSG {
	short 	( WINAPI * routine) (unsigned int, HWND, UINT, WPARAM, LPARAM);
	} kpxMsg;
#define		KPX_MAXFUNCTIONS				32
typedef struct tagKPXLIB {
	long 	( WINAPI * routine) (headerObject*, WPARAM, LPARAM);
	} kpxLib;
#define IsRunTimeFunctionPresent(num)	(num < KPX_MAXFUNCTIONS && ((LPRH)rdPtr->rHo.hoAdRunHeader)->rh4.rh4KpxFunctions[num].routine != NULL)
#define	callRunTimeFunction(rdPtr,num,wParam,lParam)	( ((LPRH)rdPtr->rHo.hoAdRunHeader)->rh4.rh4KpxFunctions[num].routine((LPHO)rdPtr, wParam, lParam) )
#define	callRunTimeFunction2(hoPtr,num,wParam,lParam)	( ((LPRH)hoPtr->hoAdRunHeader)->rh4.rh4KpxFunctions[num].routine(hoPtr, wParam, lParam) )

#define	RFUNCTION_REHANDLE					0
#define	RFUNCTION_GENERATEEVENT				1
#define	RFUNCTION_PUSHEVENT					2
#define	RFUNCTION_GETSTRINGSPACE_EX			3
#define	RFUNCTION_GETPARAM1					4
#define	RFUNCTION_GETPARAM2					5
#define	RFUNCTION_PUSHEVENTSTOP				6
#define	RFUNCTION_PAUSE						7
#define	RFUNCTION_CONTINUE					8
#define	RFUNCTION_REDISPLAY					9
#define	RFUNCTION_GETFILEINFOS				10
#define	RFUNCTION_SUBCLASSWINDOW			11
#define	RFUNCTION_REDRAW					12
#define	RFUNCTION_DESTROY					13
#define	RFUNCTION_GETSTRINGSPACE			14
#define	RFUNCTION_EXECPROGRAM				15
#define RFUNCTION_GETOBJECTADDRESS			16
#define RFUNCTION_GETPARAM					17
#define RFUNCTION_GETEXPPARAM				18
#define RFUNCTION_GETPARAMFLOAT				19
#define RFUNCTION_EDITINT					20
#define RFUNCTION_EDITTEXT					21
#define RFUNCTION_CALLMOVEMENT				22
#define RFUNCTION_SETPOSITION				23
#define RFUNCTION_GETCALLTABLES				24

#define CNC_GetParameter(rdPtr)							callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM, 0xFFFFFFFF, 0)
#define CNC_GetIntParameter(rdPtr)						callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM, 0, 0)
#define CNC_GetStringParameter(rdPtr)					callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM, 0xFFFFFFFF, 0)
#define CNC_GetFloatParameter(rdPtr)					callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM, 2, 0)
#define CNC_GetFloatValue(rdPtr, par)					callRunTimeFunction(rdPtr, RFUNCTION_GETPARAMFLOAT, par, 0)
#define CNC_GetFirstExpressionParameter(rdPtr, lParam, wParam)	callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM1, wParam, lParam)
#define CNC_GetNextExpressionParameter(rdPtr, lParam, wParam)	callRunTimeFunction(rdPtr, RFUNCTION_GETPARAM2, wParam, lParam)

#define MAX_FRAMERATE						10

typedef void (* CALLANIMATIONS) (headerObject*, int);
#define callAnimations(hoPtr, anim) ( (hoPtr->hoAdRunHeader)->rh4.rh4Animations(hoPtr, anim) )

typedef unsigned int (* CALLDIRATSTART) (headerObject*, unsigned int);
#define callDirAtStart(hoPtr, initDir) ( (hoPtr->hoAdRunHeader)->rh4.rh4DirAtStart(hoPtr, initDir) )

typedef BOOL (* CALLMOVEIT) (headerObject*);
#define callMoveIt(hoPtr) ( (hoPtr->hoAdRunHeader)->rh4.rh4MoveIt(hoPtr) )

typedef BOOL (* CALLAPPROACHOBJECT) (headerObject*, int destX, int destY, int maxX, int maxY, int htFoot, int planCol, int& x, int &y);
#define callApproachObject(x, y, hoPtr, destX, destY, maxX, maxY, htFoot, planCol) ( (hoPtr->hoAdRunHeader)->rh4.rh4ApproachObject(hoPtr, destX, destY, maxX, maxY, htFoot, planCol, x, y) )

typedef void (* CALLCOLLISIONS) (headerObject*);
#define callCollisions(hoPtr) ( (hoPtr->hoAdRunHeader)->rh4.rh4Collisions(hoPtr) )

typedef BOOL (* CALLTESTPOSITION) (headerObject*, int x, int y, int htFoot, int planCol, BOOL flag);
#define callTestPosition(hoPtr, x, y, htFoot, planCol) ( (hoPtr->hoAdRunHeader)->rh4.rh4TestPosition(hoPtr, x, y, htFoot, planCol, 0) )

typedef BYTE (* CALLGETJOYSTICK) (headerObject*, int);
#define callGetJoystick(hoPtr, player) ( (hoPtr->hoAdRunHeader)->rh4.rh4Joystick(hoPtr, player) )

typedef BOOL (* CALLCOLMASKTESTRECT) (headerObject*, int x, int y , int sx, int sy, int nLayer, int plan);
#define callColMaskTestRect(hoPtr, x, y, sx, sy, nLayer, plan) ( (hoPtr->hoAdRunHeader)->rh4.rh4ColMaskTestRect(hoPtr, x, y, sx, sy, nLayer, plan) )

typedef BOOL (* CALLCOLMASKTESTPOINT) (headerObject*, int x, int y, int nLayer, int plan);
#define callColMaskTestPoint(hoPtr, x, y, nLayer, plan) ( (hoPtr->hoAdRunHeader)->rh4.rh4ColMaskTestPoint(hoPtr, x, y, nLayer, plan) )


typedef struct tagRH4 {

	kpj*		rh4KpxJumps;							// Jump table offset
	short		rh4KpxNumOfWindowProcs;					// Number of routines to call
	short		rh4Free;
	kpxMsg		rh4KpxWindowProc[KPX_MAXNUMBER];		// Message handle routines
	kpxLib		rh4KpxFunctions[KPX_MAXFUNCTIONS];		// Available internal routines
	CALLANIMATIONS	rh4Animations;						
	CALLDIRATSTART	rh4DirAtStart;						
	CALLMOVEIT		rh4MoveIt;
	CALLAPPROACHOBJECT rh4ApproachObject;
	CALLCOLLISIONS rh4Collisions;
	CALLTESTPOSITION rh4TestPosition;
	CALLGETJOYSTICK rh4GetJoystick;
	CALLCOLMASKTESTRECT rh4ColMaskTestRect;
	CALLCOLMASKTESTPOINT rh4ColMaskTestPoint;

	unsigned int		rh4SaveVersion;
	event*		rh4ActionStart;							// Sauvergarde action courante
	int			rh4PauseKey;
	TCHAR *		rh4CurrentFastLoop;
	int			rh4EndOfPause;
	int		  	rh4EventCountOR;						// Number of the event for OR conditions
	short		rh4ConditionsFalse;
	short		rh4MouseWheelDelta;
	int			rh4OnMouseWheel;
	TCHAR *		rh4PSaveFilename;
	UINT		rh4MusicHandle;
	unsigned int		rh4MusicFlags;
	unsigned int		rh4MusicLoops;
	int			rh4LoadCount;
	short		rh4DemoMode;
	short		rh4SaveFrame;
	CDemoRecord* rh4Demo;
	int			rh4SaveFrameCount;
	double		rh4MvtTimerCoef;
	CIPhoneJoystick* rh4IPhoneJoystick;
	CIPhoneAd*	rh4IPhoneAd;
	char		rh4QuitString[32];						// FREE!!!! GREAT!


	unsigned int		rh4PickFlags0;							// 00-31
	unsigned int		rh4PickFlags1;							// 31-63
	unsigned int		rh4PickFlags2;							// 64-95
	unsigned int		rh4PickFlags3;							// 96-127
	LPDWORD		rh4TimerEventsBase;						// Timer events base

	short		rh4DroppedFlag;
	short		rh4NDroppedFiles;
	TCHAR *		rh4DroppedFiles;
	LPFL		rh4FastLoops;
	TCHAR *		rh4CreationErrorMessages;
	CValue		rh4ExpValue1;							// New V2
	CValue		rh4ExpValue2;

	long		rh4KpxReturn;				// WindowProc return 
	LPOBL		rh4ObjectCurCreate;
	short		rh4ObjectAddCreate;
	WORD		rh4Free10;					// For step through : fake key pressed
	HINSTANCE	rh4Instance;				// Application instance
	HWND		rh4HStopWindow;				// STOP window handle
	char		rh4DoUpdate;				// Flag for screen update on first loop
	char		rh4MenuEaten;				// Menu handled in an event?
	short		rh4Free2;
	int			rh4OnCloseCount;			// For OnClose event
	short		rh4CursorCount;				// Mouse counter
	short		rh4ScrMode;					// Current screen mode
	HPALETTE	rh4HPalette;				// Handle current palette
	int 		rh4VBLDelta;				// Number of VBL
	unsigned int		rh4LoopTheoric;				// Theorical VBL counter
	unsigned int		rh4EventCount;
	drawRoutine* rh4FirstBackDrawRoutine;	// Backrgound draw routines list
	drawRoutine* rh4LastBackDrawRoutine;		// Last routine used

	unsigned int		rh4ObjectList;				// Object list offset
	short		rh4LastQuickDisplay;		// Quick - display list
	BYTE		rh4CheckDoneInstart;		// Build92 to correct start of frame with fade in
	BYTE		rh4Free0;
	mv *		rh4Mv;						// Yves's data
	HCURSOR		rh4OldCursor;				// Old cursor for Show / HideMouse in Vitalize! mode
	headerObject*	rh4_2ndObject;	 		// Collision object address
	short 		rh4_2ndObjectNumber;        // Number for collisions
	short		rh4FirstQuickDisplay;		// Quick-display object list
	int			rh4WindowDeltaX;			// For scrolling
	int			rh4WindowDeltaY;               
	UINT		rh4TimeOut;					// For time-out!
	int			rh4MouseXCenter;			// To correct CROSOFT bugs!
	int			rh4MouseYCenter;			// To correct CROSOFT bugs!
	int			rh4TabCounter;				// Objects with tabulation
	
	unsigned int		rh4AtomNum;					// For child window handling
	unsigned int		rh4AtomRd;
	unsigned int		rh4AtomProc;
	short		rh4SubProcCounter;			// To accelerate the windows
	short		rh4Free3;
	
	int			rh4PosPile;								// Expression evaluation pile position
	expression*	rh4ExpToken;							// Current position in expressions
	CValue*		rh4Results[MAX_INTERMEDIATERESULTS];	// Result pile
	long		rh4Operators[MAX_INTERMEDIATERESULTS];	// Operators pile
	
	TCHAR **		rh4PTempStrings;						// Debut zone 256 long
	int			rh4MaxTempStrings;
	long		rh4Free4[256-2];						// Free buffer

	int			rh4NCurTempString;						// Pointer on the current string
	unsigned int		rh4FrameRateArray[MAX_FRAMERATE];		// Framerate calculation buffer
	int			rh4FrameRatePos;						// Position in buffer
	unsigned int		rh4FrameRatePrevious;					// Previous time 

	} runHeader4;

#define		GAMEFLAGS_VBLINDEP				0x0002
#define		GAMEFLAGS_LIMITEDSCROLL			0x0004
#define		GAMEFLAGS_FIRSTLOOPFADEIN		0x0010
#define		GAMEFLAGS_LOADONCALL			0x0020
#define		GAMEFLAGS_REALGAME				0x0040
#define		GAMEFLAGS_PLAY					0x0080
//#define	GAMEFLAGS_FADEIN				0x0080
//#define	GAMEFLAGS_FADEOUT				0x0100
#define		GAMEFLAGS_INITIALISING			0x0200

struct RunHeader {
	npWin		rhIdEditWin;
	npWin		rhIdMainWin;
	npAppli		rhIdAppli;

	HWND		rhHEditWin;
	HWND		rhHMainWin;
	HWND		rhHTopLevelWnd;

	CRunApp*	rhApp;						// Application info
	CRunFrame*	rhFrame;					// Frame info

	unsigned int		rhJoystickPatch;			// To reroute the joystick

	BYTE		rhFree10;					// Current movement needs to be stopped
	BYTE		rhFree12; 					// Event evaluation flag
	BYTE		rhNPlayers;					// Number of players
	BYTE		rhMouseUsed;				// Players using the mouse

	WORD		rhGameFlags;				// Game flags
	WORD		rhFree;						// Alignment
	unsigned int		rhPlayer;					// Current players entry

	short 		rhQuit;
	short		rhQuitBis; 					// Secondary quit (scrollings)
	unsigned int		rhFree11;					// Value to return to the editor
	unsigned int		rhQuitParam;

// Buffers
	int			rhNObjects;
	int			rhMaxObjects;
	
	unsigned int		rhFree0;			    
	unsigned int		rhFree1;				
	unsigned int		rhFree2;					
	unsigned int		rhFree3;

	int 		rhNumberOi;					// Number of OI in the list
	objInfoList*	rhOiList;					// ObjectInfo list

	LPDWORD		rhEvents[NUMBEROF_SYSTEMTYPES+1];	// Events pointers
	LPDWORD		rhEventLists;		 		// Pointers on pointers list
	LPDWORD		rhFree8;					// Timer pointers
	LPDWORD		rhEventAlways;				// Pointers on events to see at each loop
	LPEVG		rhPrograms;					// Program pointers
	OINUM*		rhLimitLists;				// Movement limitation list
	qualToOi*	rhQualToOiList;				// Conversion qualifier->oilist

	unsigned int		rhSBuffers;					// Buffer size /1024	
	LPBYTE		rhBuffer;					// Position in current buffer
	LPBYTE		rhFBuffer;					// End of current buffer
	LPBYTE		rhBuffer1;					// First buffer
	LPBYTE		rhBuffer2;					// Second buffer

	int 		rhLevelSx;					// Window size
	int 		rhLevelSy;
	int 		rhWindowX;   				// Start of window in X/Y
	int 		rhWindowY;

	UINT		rhVBLDeltaOld;				// Number of VBL
	UINT		rhVBLObjet;					// For the objects
	UINT		rhVBLOld;					// For the counter

	int			rhEventsSize;						
	WORD		rhMT_VBLStep;   			// Path movement variables
	WORD 		rhMT_VBLCount;
	unsigned int		rhMT_MoveStep;

	int			rhLoopCount;				// Number of loops since start of level
	UINT		rhTimer;					// Timer in 1/50 since start of level
	UINT		rhTimerOld;					// For delta calculation
	UINT		rhTimerDelta;				// For delta calculation

	LPEVG		rhEventGroup;				// Current group
	long 		rhCurCode;					// Current event
	short		rhCurOi;
	short		rhFree4;					// Alignment
	long		rhCurParam[2];
	short 		rhCurObjectNumber;	 		// Object number
	short 		rh1stObjectNumber;          // Number, for collisions

	long		rhOiListPtr;				// OI list enumeration
	short 		rhObListNext;				// Branch label

	short		rhDestroyPos;
	long		rhFree5;				
	long		rhFree6;

	runHeader2	rh2;						// Sub-structure #1
	runHeader3	rh3;						// Sub-structure #2
	runHeader4	rh4;						// Sub-structure #3

	LPDWORD		rhDestroyList;				// Destroy list address

	int			rhDebuggerCommand;			// Current debugger command
	char		rhFree13[DB_BUFFERSIZE];		// Buffer libre!
	LPVOID		rhDbOldHO;
	WORD		rhDbOldId;
	WORD		rhFree7;					

	objectsList*	rhObjectList;			// Object list address

};
typedef	RunHeader 	* fprh;
typedef	RunHeader 	* LPRH;
typedef	RunHeader 	* LPRUNHEADER;


///////////////////////////////////////////////////////////////
//
// RUNTIME OBJECT DEFINITION
//
///////////////////////////////////////////////////////////////

#define HOX_INT

typedef short (WINAPI *HOROUTINE)(headerObject*);

class headerObject {
public:
	short  	hoNumber;					// Number of the object
	short 	hoNextSelected;				// Selected object list!!! DO NOT CHANGE POSITION!!!

	int		hoSize;						// Structure size
    LPRH	hoAdRunHeader;				// Run-header address
	headerObject* hoAddress;			
	HFII	hoHFII;						// Number of LevObj
	OINUM  	hoOi;						// Number of OI
	short  	hoNumPrev;					// Same OI previous object
	short  	hoNumNext;					// ... next
	short 	hoType;						// Type of the object
	WORD  	hoCreationId;				// Number of creation
	objInfoList* hoOiList;				// Pointer to OILIST information
	LPDWORD hoEvents;					// Pointer to specific events
	UINT	hoFree0;					// Free
	LPBYTE	hoPrevNoRepeat;	   			// One-shot event handling
	LPBYTE	hoBaseNoRepeat;

	int 	hoMark1;					// #of loop marker for the events
	int 	hoMark2;
	TCHAR *	hoMT_NodeName;				// Name fo the current node for path movements

	int		hoEventNumber;				// Number of the event called (for extensions)
	int		hoFree2;
	LPOC	hoCommon;					// Common structure address

	union
	{
	struct
		{
			int  	hoCalculX;					// Low weight value
			int  	hoX;          	      		// X coordinate
			int  	hoCalculY;					// Low weight value
			int  	hoY;						// Y coordinate
		};
	struct	
		{
			__int64 hoCalculXLong;
			__int64 hoCalculYLong;
		};
	};
	int		hoImgXSpot;					// Hot spot of the current image
	int		hoImgYSpot;
	int		hoImgWidth;					// Width of the current picture
	int		hoImgHeight;
	RECT	hoRect;						// Display rectangle
	
	unsigned int	hoOEFlags;					// Objects flags
	short	hoFlags;					// Flags
	BYTE	hoSelectedInOR;				// Selection lors d'un evenement OR
	BYTE	hoFree;						// Alignement 
	int		hoOffsetValue;				// Values structure offset
	UINT	hoLayer;					// Layer

	HOROUTINE hoHandleRoutine;			// General handle routine
	HOROUTINE hoModifRoutine;  			// Modification routine when coordinates have been modified
	HOROUTINE hoDisplayRoutine;			// Display routine

	short	hoLimitFlags;				// Collision limitation flags
	short	hoNextQuickDisplay;			// Quickdraw list
	saveRect hoBackSave;				// Background
	
	LPEVP	hoCurrentParam;				// Address of the current parameter

	int		hoOffsetToWindows;			// Offset to windows
	unsigned int	hoIdentifier;				// ASCII identifier of the object

};
typedef	headerObject*	LPHO;

#define	HOF_DESTROYED		0x0001
#define	HOF_TRUEEVENT		0x0002
#define	HOF_REALSPRITE		0x0004
#define	HOF_FADEIN			0x0008
#define	HOF_FADEOUT			0x0010
#define	HOF_OWNERDRAW		0x0020
#define	HOF_NOCOLLISION		0x2000
#define	HOF_FLOAT			0x4000
#define	HOF_STRING			0x8000


// --------------------------------------
// Object's movement structure
// --------------------------------------
typedef struct tagRM {

	int  	rmAcc;						// Current acceleration
	int  	rmDec;						// Current Decelaration 
	int		rmCollisionCount;			// Collision counter
	int		rmFree2;
	int  	rmStopSpeed;				// If stopped: speed to take again
	int  	rmFree0;					
	int  	rmFree1;					
	int  	rmAccValue;					// Acceleration calculation
	int  	rmDecValue;					// Deceleration calculation
	short	rmEventFlags;				// To accelerate events
	int  	rmFree3;	
	int  	rmFree4;
	BOOL	rmFree5;
	BOOL	rmFree6;

 	BOOL	rmFree7;
	BOOL	rmMoveFlag;					// Messages/movements

	BOOL	rmWrapping;					// For CHECK POSITION
	BOOL 	rmReverse;					// Ahaid or reverse?

	BOOL  	rmBouncing;					// Bouncing?
	int		rmMvtNum;					// Number of the current movement

	union	
	{
	struct
		{
		BYTE 	rmMvData[80];			// Space for data
		};
	struct	
		{
		int		MT_Speed;
		int	 	MT_Sinus;
		int	 	MT_Cosinus;
		unsigned int 	MT_Longueur;
		int	 	MT_XOrigin;
		int	 	MT_YOrigin;
		int	 	MT_XDest;
		int	 	MT_YDest;
		int	 	MT_MoveNumber;
		LPMOVEDEF MT_MoveAddress;
		BOOL	MT_Direction;
		LPMOVETAPED	MT_Movement;
		int		MT_Calculs;
		int		MT_XStart;
		int		MT_YStart;
		int		MT_Pause;
		TCHAR *	MT_GotoNode;
		};
	struct
		{
		int	 	MM_DXMouse;
		int	 	MM_DYMouse;
		int	 	MM_FXMouse;
		int	 	MM_FYMouse;
		int	 	MM_Stopped;
		int	 	MM_OldSpeed;
		BYTE	MM_MvOpt;
		};	
	struct
		{
		int	 	MG_Bounce;
		long	MG_OkDirs;
		int	 	MG_BounceMu;
		int	 	MG_Speed;
		int 	MG_LastBounce;
		int	 	MG_DirMask;
		BYTE	MG_MvOpt;
		};
	struct
		{
		int	 	MR_Bounce;
		int	 	MR_BounceMu;
		int	 	MR_Speed;
		int	 	MR_RotSpeed;
		int	 	MR_RotCpt;
		int	 	MR_RotPos;
		int	 	MR_RotMask;
		int	 	MR_OkReverse;
		int	 	MR_OldJoy;
		int 	MR_LastBounce;
		BYTE	MR_MvOpt;
		};
	struct
		{
		long	MB_StartDir;
		int	 	MB_Angles;
		int	 	MB_Securite;
		int	 	MB_SecuCpt;
		int	 	MB_Bounce;
		int	 	MB_Speed;
		int	 	MB_MaskBounce;
		int	 	MB_LastBounce;
		int	 	MB_Blocked;
		};
	struct
		{
		int	 	MBul_Wait;
		LPHO	MBul_ShootObject;
		};
	struct
		{
		int		MP_Type;
		int	 	MP_Bounce;
		int	 	MP_BounceMu;
		int	 	MP_XSpeed;
		int	 	MP_Gravity;
		int	 	MP_Jump;
		int	 	MP_YSpeed;
		int	 	MP_XMB;
		int	 	MP_YMB;
		int	 	MP_HTFOOT;
		int	 	MP_JumpControl;
		int	 	MP_JumpStopped;
		int	 	MP_PreviousDir;
		LPHO	MP_ObjectUnder;
		int		MP_XObjectUnder;
		int		MP_YObjectUnder;
		BOOL	MP_NoJump;
		};
	};
	} rMvt;
typedef rMvt*	LPRMV;
enum
{
	MPTYPE_WALK,
	MPTYPE_CLIMB,
	MPTYPE_JUMP,
	MPTYPE_FALL,
	MPTYPE_CROUCH,
	MPTYPE_UNCROUCH
};

// ----------------------------------------
// Object's animation structure
// ----------------------------------------
typedef struct tagRA {
	int	 		raAnimForced;				// Flags if forced
	int	 		raAnimDirForced;
	int	 		raAnimSpeedForced;
	BOOL		raAnimStopped;
	int	 		raAnimOn;					// Current animation
	LPAN		raAnimOffset;
	int	 		raAnimDir;				// Direction of current animation
	int	 		raAnimPreviousDir;		// Previous OK direction
	LPAD		raAnimDirOffset;
	int	 	 	raAnimSpeed;
	int	 		raAnimMinSpeed;			// Minimum speed of movement
	int	 		raAnimMaxSpeed;			// Maximum speed of movement
	int	 		raAnimDeltaSpeed;
	int	 		raAnimCounter;			// Animation speed counter
	int	 		raAnimDelta;				// Speed counter
	int	 		raAnimRepeat;				// Number of repeats
	int	 		raAnimRepeatLoop;			// Looping picture
	int	 		raAnimFrame;				// Current frame
	int	 		raAnimNumberOfFrame;   	// Number of frames

	int	 		raAnimFrameForced;

	} rAni;
typedef rAni*	LPRA;

// ----------------------------------------
// Sprite display structure
// ----------------------------------------
typedef struct tagRSPR {

	int	 		rsFlash;				// Flash objets
	int	 		rsFlashCpt;
	int	   		rsLayer;				// Layer
	int			rsZOrder;				// Z-order value
	int	 		rsCreaFlags;			// Creation flags
	COLORREF	rsBackColor;			// background saving color
	unsigned int		rsEffect;				// Sprite effects
	LPARAM		rsEffectParam;
	WORD	 	rsFlags;				// Handling flags
	WORD		rsFadeCreaFlags;		// Saved during a fadein
	} rSpr;
typedef rSpr *	LPRSP;

#define			RSFLAG_HIDDEN			0x0001
#define			RSFLAG_INACTIVE			0x0002
#define			RSFLAG_SLEEPING			0x0004
#define			RSFLAG_SCALE_RESAMPLE	0x0008	
#define			RSFLAG_ROTATE_ANTIA		0x0010
#define			RSFLAG_VISIBLE			0x0020
#define			RSFLAG_CREATEDEFFECT	0x0040


// ----------------------------------------
// Objects's internal variables (build # >= 243)
// ----------------------------------------
typedef struct tagRV {
	CValue*	rvpValues;
	long	rvFree1[VALUES_NUMBEROF_ALTERABLE-1];
	long	rvValueFlags;
	BYTE	rvFree2[VALUES_NUMBEROF_ALTERABLE];
	TCHAR *	rvStrings[STRINGS_NUMBEROF_ALTERABLE];
	} rVal;
typedef rVal *	LPRVAL;
	
/*
	Obsolete (build 242 or below) - Note: don't remove this (for the SDK)
  
typedef struct tagRV {
	long	rvValues[VALUES_NUMBEROF_ALTERABLE];
	long	rvValueFlags;
	BYTE	rvValuesType[VALUES_NUMBEROF_ALTERABLE];
	char *	rvStrings[STRINGS_NUMBEROF_ALTERABLE];
	} rVal;
typedef rVal *	LPRVAL;
*/


// -----------------------------------------------
// Objects animation and movement structure
// -----------------------------------------------
#if !defined(ANGLETYPE)
#if defined(HWABETA)
#define ANGLETYPE float
#else
#define ANGLETYPE int
#endif
#endif
typedef void (* RCROUTINE)(LPHO);
typedef struct tagRCOM {

	int		rcOffsetAnimation; 			// Offset to anims structures
	int		rcOffsetSprite;				// Offset to sprites structures
	RCROUTINE	rcRoutineMove;			// Offset to movement routine
	RCROUTINE	rcRoutineAnimation;		// Offset to animation routine

	int	   	rcPlayer;					// Player who controls

	int	   	rcNMovement;				// Number of the current movement
	CRunMvt*	rcRunMvt;				// Pointer to extension movement
	fpSpr  	rcSprite;					// Sprite ID if defined
	int	 	rcAnim;						// Wanted animation
	int	   	rcImage;					// Current frame
	float	rcScaleX;					
	float	rcScaleY;
	ANGLETYPE	rcAngle;
	int	   	rcDir;						// Current direction
	int	   	rcSpeed;					// Current speed
	int	   	rcMinSpeed;					// Minimum speed
	int	   	rcMaxSpeed;					// Maximum speed
	BOOL	rcChanged;					// Flag: modified object
	BOOL	rcCheckCollides;			// For static objects

	int	 	rcOldX;            			// Previous coordinates
	int	 	rcOldY;
	int	 	rcOldImage;
	ANGLETYPE		rcOldAngle;
	int	 	rcOldDir;
	int	 	rcOldX1;					// For zone detections
	int	 	rcOldY1;
	int	 	rcOldX2;
	int	 	rcOldY2;

	long	rcFadeIn;
	long	rcFadeOut;

	} rCom;
	
	
// ------------------------------------------------------------
// ACTIVE OBJECTS DATAZONE
// ------------------------------------------------------------
typedef struct tagRO {

	headerObject 	roHo;		  		// Common structure 

	rCom			roc;				// Anim/movement structure
	rMvt			rom;				// Movement structure 
	rAni			roa;				// Animation structure 
	rSpr			ros;				// Sprite handling structure
	rVal			rov;				// Values structure

	} RunObject;
typedef	RunObject *				LPRO;
typedef RunObject *				LPRUNOBJECT;

#define	EF_GOESINPLAYFIELD			0x0001
#define	EF_GOESOUTPLAYFIELD			0x0002
#define	EF_WRAP						0x0004



// ------------------------------------------------------
// EXTENSION EDITION HEADER STRUCTURE
// ------------------------------------------------------
typedef struct tagEditExtension_v1
{
	short			extSize;
	short			extMaxSize;
	short			extOldFlags;		// For conversion purpose
	short			extVersion;			// Version number
} extHeader_v1;
typedef extHeader_v1*	LPEXTV1;

typedef struct extHeader
{
	unsigned int			extSize;
	unsigned int			extMaxSize;
	unsigned int			extVersion;			// Version number
	LPVOID			extID;				// object's identifier
	LPVOID			extPrivateData;		// private data
} extHeader;
typedef extHeader *		LPEXT;

// ------------------------------------------------------
// System objects (text, question, score, lives, counter)
// ------------------------------------------------------
typedef	struct	tagRs {

	headerObject	rsHo;				// For all the objects
	rCom			rsc;				// Anims / movements / sprites structures
	rMvt			rom;				// Mouvement structure
	rSpr			rss;				// Sprite handling
	
	short			rsPlayer;			// Number of the player if score or lives
	short			rsFlags;			// Type + flags

	union {
		LPBYTE		rsSubAppli;			// Application (CCA object)
	};
	union
	{
		long			rsMini;
		long			rsOldLevel;
	};
	union
	{
		long			rsMaxi;				// 
		long			rsLevel;
	};
	CValue			rsValue;
	LONG			rsBoxCx;			// Dimensions box (for lives, counters, texts)
	LONG			rsBoxCy;			
	double			rsMiniDouble;		
	double			rsMaxiDouble;
	short			rsOldFrame;			// Counter only 
	BYTE			rsHidden;
	BYTE			rsFree;
	TCHAR *			rsTextBuffer;		// Text buffer
	int				rsLBuffer;			// Length of the buffer in BYTES
	unsigned int			rsFont;				// Temporary font for texts
	union {
		COLORREF	rsTextColor;		// Text color
		COLORREF	rsColor1;			// Bar color
	};
	COLORREF		rsColor2;			// Gradient bar color
} rs;
typedef	rs *	LPRS;


// OILIST Structure : Data concerning the objects in the game
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define MAX_QUALIFIERS					8	// Maximum number of qualifiers per object
typedef LPHO (*OILROUTINE)(objInfoList*, BOOL*);

class objInfoList {
public:
	OINUM		oilOi;  				 // THE oi
	short		oilListSelected;		 // First selection !!! DO NOT CHANGE POSITION !!!
	short		oilType;				 // Type of the object
	short		oilObject;				 // First objects in the game
	unsigned int		oilEvents;				 // Events
	char		oilWrap;				 // WRAP flags
	char		oilNextFlag;
	WORD		oilFree;				 // Not used
	int			oilNObjects;			 // Current number
	int			oilActionCount;			 // Action loop counter
	int			oilActionLoopCount;	  	 // Action loop counter
	OILROUTINE	oilCurrentRoutine;		 // Current routine for the actions
	int			oilCurrentOi;			 // Current object
	int			oilNext;				 // Pointer on the next
	int			oilEventCount;			 // When the event list is done
	int			oilNumOfSelected;		 // Number of selected objects
	unsigned int		oilOEFlags;				 // Object's flags
	short		oilLimitFlags;			 // Movement limitation flags
	short		oilLimitList;         	 // Pointer to limitation list
	short		oilOIFlags;				 // Objects preferences
	short		oilOCFlags2;			 // Objects preferences II
	long		oilInkEffect;			 // Ink effect
	long		oilEffectParam;			 // Ink effect param
	HFII		oilHFII;				 // First available frameitem
	COLORREF 	oilBackColor;			 // Background erasing color
	short		oilQualifiers[MAX_QUALIFIERS];		// Qualifiers for this object
	TCHAR		oilName[24];	 		 // Name	
	int			oilEventCountOR;		 // Selection in a list of events with OR
#ifdef HWABETA
	OINUM*		oilColList;				// Liste de collisions sprites
#endif
};
typedef	objInfoList	*	LPOIL;

#define	OILIMITFLAGS_BORDERS		0x000F
#define	OILIMITFLAGS_BACKDROPS		0x0010
#define	OILIMITFLAGS_ONCOLLIDE		0x0080	// used by HWA
#define	OILIMITFLAGS_QUICKCOL		0x0100
#define	OILIMITFLAGS_QUICKBACK		0x0200
#define	OILIMITFLAGS_QUICKBORDER	0x0400
#define	OILIMITFLAGS_QUICKSPR		0x0800
#define	OILIMITFLAGS_QUICKEXT		0x1000
#define	OILIMITFLAGS_ALL			0xFFFF

// Object creation structure
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef struct tagCOB {
	LO*		cobLevObj;				// Leave first!
	WORD	cobLevObjSeg;
	WORD	cobFlags;
	int		cobX;
	int		cobY;
	int		cobDir;
	int		cobLayer;
	int		cobZOrder;
	} createObjectInfo;
typedef	createObjectInfo *	LPCOB;
typedef	createObjectInfo *	fpcob;

// Flags for Create Objects
// -------------------------
#define	COF_NOMOVEMENT		0x0001
#define	COF_HIDDEN			0x0002
#define	COF_FIRSTTEXT		0x0004

// Qualifier to oilist for machine langage
// ---------------------------------------
typedef LPHO (*QOIROUTINE)(qualToOi*, BOOL* pRepeatFlag);

class qualToOi {
public:
	short		qoiCurrentOi;
	short		qoiNext;
	int			qoiActionPos;
	QOIROUTINE	qoiCurrentRoutine;
	int			qoiActionCount;
	int			qoiActionLoopCount;
	char		qoiNextFlag;
	char		qoiSelectedFlag;
	OINUM		qoiOi;						// Array OINUM / OFFSET
	short		qoiOiList;
};
typedef	qualToOi * LPQOI;


// ------------------------------------------------------------------
// ------------------------------------------------------------------
// EXTENSION HANDLING
// ------------------------------------------------------------------
// ------------------------------------------------------------------

#ifdef STAND_ALONE
typedef BOOL (WINAPI *EXTCONDROUTINE)(headerObject*, long, long);
typedef short (WINAPI *EXTACTROUTINE)(headerObject*, long, long);
typedef long (WINAPI *EXTEXPROUTINE)(headerObject*, long);
#else
#define EXTCONDROUTINE	VOID
#define EXTACTROUTINE	VOID
#define EXTEXPROUTINE	VOID
#endif

// Information structure about the extension
class kpxRunInfos {
public:
	EXTCONDROUTINE* conditions;			// 00 Offset to condition jump list
	EXTACTROUTINE* actions;				// 04 Offset to action jump list
	EXTEXPROUTINE* expressions;			// 08 Offset to expression jump list
	short	numOfConditions;			// 0C Number of conditions
	short	numOfActions;				// 0E Number of actions
	short	numOfExpressions;			// 10 Number of expressions
	WORD	editDataSize;				// 12 Size of the data zone when exploded
	unsigned int	editFlags;					// 14 Object flags
	char	windowProcPriority;			// 16 Priority of the routine 0-255
	char	free;						
	short	editPrefs;					// 18 Preferences d'edition
	long	identifier;					// 1A Chaine d'identification
	short	version;					// 1E Version courante
										// 20
};
typedef kpxRunInfos *		LPKPXRUNINFOS;
typedef kpxRunInfos *		fpKpxRunInfos;

// Extension jump table
// --------------------
typedef short (WINAPI * CREATERUNOBJECT_PROC) (LPHO hoPtr, LPEXT extPtr, LPCOB);
typedef unsigned short (WINAPI * GETRUNDATASIZE_PROC)(LPRH, LPEXT);
typedef short (WINAPI * DESTROYRUNOBJECT_PROC)(LPHO, long fast);
typedef short (WINAPI * HANDLERUNOBJECT_PROC)(LPHO);
typedef short (WINAPI * DISPLAYRUNOBJECT_PROC)(LPHO);
typedef cSurface* (WINAPI * GETRUNOBJECTSURFACE_PROC)(LPHO);
typedef short (WINAPI * REINITRUNOBJECT_PROC)(LPHO);
typedef short (WINAPI * PAUSERUNOBJECT_PROC)(LPHO);
typedef short (WINAPI * CONTINUERUNOBJECT_PROC)(LPHO);
typedef short (WINAPI * PREPARETOSAVE_PROC)(LPHO);
typedef short (WINAPI * SAVEBACKGROUND_PROC)(LPHO);
typedef short (WINAPI * RESTOREBACKGROUND_PROC)(LPHO);
typedef short (WINAPI * CHANGERUNDATA_PROC)(LPHO, LPHO);
typedef short (WINAPI * KILLBACKGROUND_PROC) (LPHO);
typedef short (WINAPI * GETZONEINFO_PROC)(LPHO);
typedef LPWORD (WINAPI * GETDEBUGTREE_PROC)(LPHO);
typedef void (WINAPI * GETDEBUGITEM_PROC)(TCHAR *, LPHO, int);
typedef void (WINAPI* EDITDEBUGITEM_PROC)(LPHO, int);
typedef void (WINAPI* GETRUNOBJECTFONT_PROC)(LPHO, LOGFONT*);
typedef void (WINAPI* SETRUNOBJECTFONT_PROC)(LPHO, LOGFONT*, RECT*);
typedef COLORREF (WINAPI* GETRUNOBJECTTEXTCOLOR_PROC)(LPHO);
typedef void (WINAPI* SETRUNOBJECTTEXTCOLOR_PROC)(LPHO, COLORREF);
typedef short (WINAPI * GETRUNOBJECTWINDOW_PROC)(LPHO);
typedef sMask* (WINAPI * GETRUNOBJECTCOLLISIONMASK_PROC)(LPHO, LPARAM);
typedef BOOL (WINAPI * SAVERUNOBJECT_PROC)(LPHO, HANDLE);
typedef BOOL (WINAPI * LOADRUNOBJECT_PROC)(LPHO, HANDLE);
typedef void (WINAPI * GETRUNOBJECTMEMORYUSAGE_PROC)(LPHO, int*, int*, int*);

class kpj {
public:
	CREATERUNOBJECT_PROC			CreateRunObject;	
	DESTROYRUNOBJECT_PROC			DestroyRunObject;   
	HANDLERUNOBJECT_PROC			HandleRunObject;    
	DISPLAYRUNOBJECT_PROC			DisplayRunObject;   
	GETRUNOBJECTSURFACE_PROC		GetRunObjectSurface;   
	REINITRUNOBJECT_PROC			ReInitRunObject;    
	PAUSERUNOBJECT_PROC				PauseRunObject;     
	CONTINUERUNOBJECT_PROC			ContinueRunObject;  
	PREPARETOSAVE_PROC				PrepareToSave;      
	PREPARETOSAVE_PROC				PrepareToSave2; 	
	GETRUNDATASIZE_PROC				GetRunObjectDataSize;
	SAVEBACKGROUND_PROC				SaveBackground;		
	RESTOREBACKGROUND_PROC			RestoreBackground;	
	CHANGERUNDATA_PROC				ChangeRunData;		
	KILLBACKGROUND_PROC				KillBackground;		
	GETZONEINFO_PROC				GetZoneInfo;		
	GETDEBUGTREE_PROC				GetDebugTree;		
	GETDEBUGITEM_PROC				GetDebugItem;		
	EDITDEBUGITEM_PROC				EditDebugItem;
	GETRUNOBJECTFONT_PROC			GetRunObjectFont;
	SETRUNOBJECTFONT_PROC			SetRunObjectFont;
	GETRUNOBJECTTEXTCOLOR_PROC		GetRunObjectTextColor;
	SETRUNOBJECTTEXTCOLOR_PROC		SetRunObjectTextColor;
	GETRUNOBJECTWINDOW_PROC			GetRunObjectWindow;
	GETRUNOBJECTCOLLISIONMASK_PROC	GetRunObjectCollisionMask;
	SAVERUNOBJECT_PROC				SaveRunObject;
	LOADRUNOBJECT_PROC				LoadRunObject;
	GETRUNOBJECTMEMORYUSAGE_PROC	GetRunObjectMemoryUsage;

	kpxRunInfos	infos;   
	
};
typedef	kpj	 *      LPKPJ;

#define	KPJ_SHIFT			7
#define	KPJ_SIZE			0x80
#define KPJ_MAXNUMBER		128
#define	KPJ_STEP			8
#define	kpjJCreate				0x00
#define	kpjJDestroy				0x04
#define	kpjJRoutine				0x08
#define	kpjJDisplay				0x0C
#define	kpjJReInit				0x10
#define	kpjJPause				0x14
#define	kpjJEndPause			0x18
#define	kpjJPrepareToSave		0x1C
#define	kpjJRestart				0x20
#define	kpjJGetRunDataSize		0x24
#define	kpjJSaveBackground		0x28
#define	kpjJRestoreBackground	0x2C
#define	kpjJKillBackground		0x30

// Possible states of the application, see LApplication::SetRunningState()
#define	GAMEON_EMPTY					0
#define GAMEON_UNLOADED					1
#define	GAMEON_TIME0					2
#define	GAMEON_PAUSED					3
#define	GAMEON_RUNNING					4
#define	GAMEON_STEPPING					5


//////////////////////////////////////////////////////////////////////////////
// Condition/action jumps
typedef BOOL (*CALLCOND1_ROUTINE)(event* pe, LPHO pHo);
typedef BOOL (*CALLCOND2_ROUTINE)(event* pe);
typedef void (*CALLACTION_ROUTINE)(event* pe);
typedef void (*CALLEXP_ROUTINE)();
typedef BOOL (*CONDROUTINE)(event* pe, LPHO pHo);
typedef void (*ACTROUTINE)(event* pe);
typedef void (*EXPROUTINE)();
typedef void (*CALLOPERATOR_ROUTINE)();

typedef struct tagCallTables
{
	CALLCOND1_ROUTINE* pConditions1;
	CALLCOND2_ROUTINE* pConditions2;
	CALLACTION_ROUTINE* pActions;
	CALLEXP_ROUTINE* pExpressions;
}CallTables;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
//
//	Run-time Definitions
//

#define	COMPARE_EQ				0
#define COMPARE_NE				1
#define	COMPARE_LE				2
#define	COMPARE_LT				3
#define	COMPARE_GE				4
#define	COMPARE_GT				5

#ifdef	RUN_TIME

	#define OINUM_ERROR				-1
	#define B2L(a,b,c,d)    ((unsigned int)(((unsigned int)((unsigned char)(d))<<24)|((unsigned int)((unsigned char)(c))<<16)|((unsigned int)((unsigned char)(b))<<8)|(unsigned int)((unsigned char)(a))))
	
	// Pour la routine GetFileInfos
	#define	FILEINFO_DRIVE			1
	#define	FILEINFO_DIR			2
	#define	FILEINFO_PATH			3
	#define	FILEINFO_APPNAME		4
	#define	FILEINFO_TEMPPATH		5

	// MACRO: next event
	#define		EVTNEXT(p)		   		((LPEVT)((LPBYTE)p+p->evtSize))
	// MACRO: returns first param
	#define		EVTPARAMS(p) 			((LPEVP)(p->evtCode<0 ? (LPBYTE)p+CND_SIZE : (LPBYTE)p+ACT_SIZE ))
	// MACRO: returns the extension condition code
	#define		EXTCONDITIONNUM(i)		(-((short)(i>>16))-1)           
	#define		EXTACTIONNUM(i)			((short)(i>>16))

	#define			KPXNAME_SIZE				60
	#define			BADNAME_SIZE			    (OINAME_SIZE+KPXNAME_SIZE+8)

	// Extensions
	// ----------
	typedef struct TABKPT {
		kpj			kpx[2];
		} kpxData;
	typedef	kpxData	*	fpkpdt;

	// Main loop exit codes
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~
	#define		LOOPEXIT_NEXTLEVEL		1
	#define		LOOPEXIT_PREVLEVEL		2
	#define		LOOPEXIT_GOTOLEVEL		3
	#define		LOOPEXIT_NEWGAME		4
	#define		LOOPEXIT_PAUSEGAME		5
	#define		LOOPEXIT_SAVEAPPLICATION 6
	#define		LOOPEXIT_LOADAPPLICATION 7
	#define		LOOPEXIT_SAVEFRAME		8
	#define		LOOPEXIT_LOADFRAME		9
	#define		LOOPEXIT_ENDGAME		-2

	#define		LOOPEXIT_QUIT			100
	#define		LOOPEXIT_RESTART		101
	#define		LOOPEXIT_TIMER			102
	#define		LOOPEXIT_STEP			103
	#define		LOOPEXIT_MONITOR		104
	#define		LOOPEXIT_EVENTEDITOR	105
	#define		LOOPEXIT_ESC			106
	#define		LOOPEXIT_MENU			107
	#define		LOOPEXIT_JUMPTO			108
	#define		LOOPEXIT_RESET			109
	#define		LOOPEXIT_PAUSE			110
	#define		LOOPEXIT_PLAY			111

	// Backdrop draw routines
	// ----------------------------------------
	typedef void (* DRAWROUTINE_PROC)(drawRoutine*);

	class drawRoutine {
	public:
		drawRoutine* next;
		DRAWROUTINE_PROC routine;
		long	param1;
		long	param2;
		long	param3;
		long	param4;
		long	param5;
		long	param6;
	};

	// To push an event
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	#define		MAX_PUSHEDEVENTS	32
	typedef void (*PEV_ROUTINE)(LPHO, long);

	class pev {
	public:
		long	pevCode;
		PEV_ROUTINE	pevRoutine;
		long	pevParam;
		LPHO	pevObject;
		short	pevOi;
	};
	#define	PIXEL_SPEED					5

	// QUALIFIERS
	typedef struct
	{
		OINUM		qOi;
		ITEMTYPE	qType;
		WORD		qList;
	} qualifierLoad;
	typedef qualifierLoad *	LPQLOAD;

#endif	// RUN_TIME

// Restores structure alignment...
#ifndef      _H2INC 
#pragma pack( pop, _pack_cncf_ )
#endif

#ifndef      _H2INC

// Object instance parent types
enum {
	PARENT_NONE,
	PARENT_FRAME,
	PARENT_FRAMEITEM,
	PARENT_QUALIFIER
};

// Proc definition
typedef void (WINAPI * UPDATEFILENAMEPROCA)(const char *, char *);
typedef void (WINAPI * UPDATEFILENAMEPROCW)(const wchar_t *, wchar_t *);
typedef void (WINAPI * UPDATEFILENAMEPROC)(const TCHAR *, TCHAR *);

// Old object name size, still used in events
#ifndef OINAME_SIZE
#define	OINAME_SIZE			24
#endif	// OINAME_SIZE

// Obsolete
enum	{
	MODIF_SIZE,
	MODIF_PLANE,
	MODIF_FLAGS,
	MODIF_PICTURE,
	MODIF_HFRAN,
	MODIF_BOX,
	MODIF_TEXT,
	MODIF_PREFS
};
#define	KPX_MODIF_BASE	1024

#endif	// _H2INC

// Standard objects
#define	KPX_BASE	32		// Extensions
enum	{
	OBJ_BOX,
	OBJ_BKD,
	OBJ_SPR,
	OBJ_TEXT,
	OBJ_QUEST,
	OBJ_SCORE,
	OBJ_LIVES,
	OBJ_COUNTER,
	OBJ_RTF,
	OBJ_CCA,
	NB_SYSOBJ
};

// Menu header (v2)
struct MenuHdr {

	unsigned int	mhHdrSize;		// == sizeof(MenuHdr)
	unsigned int	mhMenuOffset;	// From start of MenuHdr
	unsigned int	mhMenuSize;
	unsigned int	mhAccelOffset;	// From start of MenuHdr
	unsigned int	mhAccelSize;
							// Total data size = mhHdrSize + mhMenuSize + mhAccelSize 
};

//////////////////////////////////////////////////////////////////////////////
// Application mini Header
//
struct AppMiniHeader {

	union {
		char			gaType[4];		// "PAME"
		unsigned long	gaDWType;
	};
	WORD		gaVersion;		// Version number
	WORD		gaSubVersion;	// Sub-version number
	unsigned int		gaPrdVersion;	// MMF version
	unsigned int		gaPrdBuild;		// MMF build number

};

#define	RUNTIME_DWTYPEA				'EMAP'
#define	RUNTIME_DWTYPEW				'UMAP'
#define RUNTIME_DWTYPE_VTZA			' ZTV'
#define RUNTIME_DWTYPE_VTZW			'UZTV'

#ifdef _UNICODE
	#define	RUNTIME_DWTYPE				RUNTIME_DWTYPEW
	#define RUNTIME_DWTYPE_VTZ			RUNTIME_DWTYPE_VTZW
#else
	#define	RUNTIME_DWTYPE				RUNTIME_DWTYPEA
	#define RUNTIME_DWTYPE_VTZ			RUNTIME_DWTYPE_VTZA
#endif
#define	RUNTIME_VERSION_MMF1		0x0300
#define	RUNTIME_VERSION_MMF15		0x0301
#define	RUNTIME_VERSION_MMF2		0x0302
#define	RUNTIME_VERSION				RUNTIME_VERSION_MMF2

//////////////////////////////////////////////////////////////////////////////
// Application full Header
//

enum {
	CTRLTYPE_MOUSE,		// not used
	CTRLTYPE_JOY1,
	CTRLTYPE_JOY2,
	CTRLTYPE_JOY3,
	CTRLTYPE_JOY4,
	CTRLTYPE_KEYBOARD,
	MAX_CTRLTYPE
};

#define MAX_PLAYER			4
#define MAX_KEY				8
#define PLAYERNAME_SIZE		100

struct PlayerCtrls {

	WORD		pcCtrlType[MAX_PLAYER];				// Control type per player (0=mouse,1=joy1, 2=joy2, 3=keyb)
	WORD		pcCtrlKeys[MAX_PLAYER][MAX_KEY];	// Control keys per player

};
typedef PlayerCtrls* fpPlayerCtrls;

struct AppHeader {

	unsigned int		gaSize;								// Structure size
	WORD		gaFlags;							// Flags
	WORD		gaNewFlags;							// New flags
	WORD		gaMode;								// graphic mode
	WORD		gaOtherFlags;						// Other Flags
	short		gaCxWin;							// Window x-size
	short		gaCyWin;							// Window y-size
	unsigned int		gaScoreInit;						// Initial score
	unsigned int		gaLivesInit;						// Initial number of lives
	PlayerCtrls	gaPlayerCtrls;
	unsigned int		gaBorderColour;						// Border colour
	unsigned int		gaNbFrames;							// Number of frames
	unsigned int		gaFrameRate;						// Number of frames per second
	BYTE		gaMDIWindowMenu;					// Index of Window menu for MDI applications
	BYTE		gaFree[3];

};

// gaFlags
#define		GA_BORDERMAX		0x0001
#define		GA_NOHEADING		0x0002
#define		GA_PANIC			0x0004
#define		GA_SPEEDINDEPENDANT	0x0008
#define		GA_STRETCH			0x0010
#define		GA_LOADALLIMAGESATSTART	0x0020
#define		GA_LOADALLSOUNDSATSTART	0x0040
#define		GA_MENUHIDDEN		0x0080
#define		GA_MENUBAR			0x0100
#define		GA_MAXIMISE			0x0200
#define		GA_MIX				0x0400
#define		GA_FULLSCREENATSTART	0x0800
#define		GA_FULLSCREENSWITCH	0x1000
#define		GA_PROTECTED		0x2000
#define		GA_COPYRIGHT		0x4000
#define		GA_ONEFILE			0x8000

// gaNewFlags
#define		GANF_SAMPLESOVERFRAMES		0x0001
#define		GANF_RELOCFILES				0x0002
#define		GANF_RUNFRAME				0x0004
#define		GANF_SAMPLESEVENIFNOTFOCUS	0x0008

// New in build 92
#define		GANF_NOMINIMIZEBOX			0x0010
#define		GANF_NOMAXIMIZEBOX			0x0020
#define		GANF_NOTHICKFRAME			0x0040
#define		GANF_DONOTCENTERFRAME		0x0080

// New in build 101 (MMF 1.5)
#define		GANF_SCREENSAVER_NOAUTOSTOP	0x0100
#define		GANF_DISABLE_CLOSE			0x0200

// New in build 105
#define		GANF_HIDDENATSTART			0x0400

// New in build 110
#define		GANF_XPVISUALTHEMESUPPORT	0x0800

// New in MMF2
#define		GANF_VSYNC					0x1000
#define		GANF_RUNWHENMINIMIZED		0x2000
#define		GANF_MDI					0x4000
#define		GANF_RUNWHILERESIZING		0x8000

// Other flags
#define		GAOF_DEBUGGERSHORTCUTS		0x0001
#define		GAOF_DDRAW					0x0002
#define		GAOF_DDRAWVRAM				0x0004
#define		GAOF_OBSOLETE				0x0008
#define		GAOF_AUTOIMGFLT				0x0010
#define		GAOF_AUTOSNDFLT				0x0020
#define		GAOF_ALLINONE				0x0040
#define		GAOF_SHOWDEBUGGER			0x0080
#define		GAOF_RESERVED_1				0x0100
#define		GAOF_RESERVED_2				0x0200
#define		GAOF_RESERVED_3				0x0400
#define		GAOF_RESERVED_4				0x0800
#define		GAOF_JAVASWING				0x1000
#define		GAOF_JAVAAPPLET				0x2000
#define		GAOF_D3D9					0x4000
#define		GAOF_D3D8					0x8000

// Optional header
struct AppHeader2 {

	unsigned int	dwOptions;
	unsigned int	dwBuildType;
	unsigned int	dwBuildFlags;
	WORD	wScreenRatioTolerance;
	WORD	wScreenAngle;			// 0 (no rotation/portrait), 1 (90 clockwise/landscape left), 2 (90 anticlockwise/landscape right), 3 (automatic portrait), 4 (automatic landscape), 5 (fully automatic)
	unsigned int	dwUnused2;

};

#define	AH2OPT_KEEPSCREENRATIO			0x0001
#define	AH2OPT_FRAMETRANSITION			0x0002		// (HWA only) a frame has a transition 
#define	AH2OPT_RESAMPLESTRETCH			0x0004		// (HWA only) "resample when resizing" (works with "resize to fill window" option)
#define	AH2OPT_GLOBALREFRESH			0x0008		// (Mobile) force global refresh
#define AH2OPT_MULTITASK				0x0010		// (iPhone) Multitask
#define AH2OPT_RTL						0x0020		// (Unicode) Right-to-left reading
#define AH2OPT_STATUSLINE				0x0040		// (iPhone/Android) Display status line
#define AH2OPT_RTLLAYOUT				0x0080		// (Unicode) Right-to-left layout
#define AH2OPT_ENABLEIAD				0x0100		// (iPhone) Enable iAd
#define AH2OPT_IADBOTTOM				0x0200		// (iPhone) Display ad at bottom
#define AH2OPT_AUTOEND					0x0400		// (Android)
#define AH2OPT_DISABLEBACKBUTTON		0x0800		// (Android) Disable Back button behavior
#define AH2OPT_ANTIALIASED				0x1000		// (iPhone) Smooth resizing on bigger screens
#define AH2OPT_CRASHREPORTING			0x2000		// (Android) Enable online crash reporting

enum {
	SCREENORIENTATION_PORTRAIT,
	SCREENORIENTATION_LANDSCAPE_LEFT,
	SCREENORIENTATION_LANDSCAPE_RIGHT,
	SCREENORIENTATION_AUTO,
	SCREENORIENTATION_LANDSCAPE_AUTO,
	SCREENORIENTATION_PORTRAIT_AUTO,
};

#ifndef      _H2INC

// Build type values
enum {
	BUILDTYPE_STANDALONE,
	BUILDTYPE_SCREENSAVER,
	BUILDTYPE_INTERNETAPP,
	BUILDTYPE_JAVA,
	BUILDTYPE_JAVASTANDALONE,
	BUILDTYPE_JAVAAPPLET,
	BUILDTYPE_JAVAWEBSTART,
	BUILDTYPE_JAVAMOBILE,
	BUILDTYPE_JAVABLURAY,
	BUILDTYPE_JAVAMAC,
	BUILDTYPE_FLASH,
	BUILDTYPE_JAVABLACKBERRY,
	BUILDTYPE_ANDROID,
	BUILDTYPE_IPHONE,
	BUILDTYPE_IPHONEDEVEL,
	BUILDTYPE_IPHONEFINAL,
	BUILDTYPE_XNA_WINDOWS_APP,
	BUILDTYPE_MAC,
	BUILDTYPE_XNA_WINDOWS,
	BUILDTYPE_XNA_XBOX,
	BUILDTYPE_XNA_PHONE,
	BUILDTYPE_XNA_XBOX_APP,
	BUILDTYPE_XNA_PHONE_APP,
	BUILDTYPE_STDMAX,			// end of standard build types
};

// Build flag values
#define	BUILDFLAG_MAXCOMP			0x0001
#define BUILDFLAG_COMPSND			0x0002
#define BUILDFLAG_INCLUDEEXTFILES	0x0004
#define BUILDFLAG_MANUALIMGFILTERS	0x0008
#define BUILDFLAG_MANUALSNDFILTERS	0x0010
#define	BUILDFLAG_NOAUTOEXTRACT		0x0020
#define	BUILDFLAG_NOAPPLETCHECK		0x0040
#define	BUILDFLAG_TEST				0x0080
#define	BUILDFLAG_NOWARNINGS		0x0100

#endif // _H2INC

//////////////////////////////////////////////////////////////////////////////
// Element of chunk Extensions
//
#ifndef      _H2INC
typedef struct ExtDesc {
	WORD		extSize;
	WORD		extIndex;
	unsigned int		extMagicNumber;
} ExtDesc;
typedef ExtDesc *LPEXTDESC;

typedef struct ExtDesc2 {
	WORD		extSize;
	WORD		extIndex;
	unsigned int		extMagicNumber;
	unsigned int		extVersionLS;
	unsigned int		extVersionMS;
} ExtDesc2;
typedef ExtDesc2 *LPEXTDESC2;
#endif // _H2INC

//////////////////////////////////////////////////////////////////////////////
// Movement Extensions Chunk
//
struct MvtExtDesc {
	WORD		extTotalSize;
	WORD		extHdrSize;
	unsigned int		extBuild;
};
typedef MvtExtDesc *LPMVTEXTDESC;

//////////////////////////////////////////////////////////////////////////////
// Frame Header
//
struct FrameHeader
{
	// Playfield
	LONG		leWidth;			// Playfield width in pixels
	LONG		leHeight;			// Playfield height in pixels
	COLORREF	leBackground;

	// Options
	unsigned int		leFlags;


};

// leFlags
#define		LEF_DISPLAYNAME			0x0001
#define		LEF_GRABDESKTOP			0x0002
#define		LEF_KEEPDISPLAY			0x0004
//#define		LEF_FADEIN				0x0008
//#define		LEF_FADEOUT				0x0010
#define		LEF_TOTALCOLMASK		0x0020
#define		LEF_PASSWORD			0x0040
#define		LEF_RESIZEATSTART		0x0100
#define		LEF_DONOTCENTER			0x0200
#define		LEF_FORCE_LOADONCALL	0x0400
#define		LEF_NOSURFACE			0x0800
#define		LEF_RESERVED_1			0x1000
#define		LEF_RESERVED_2			0x2000
#define		LEF_RECORDDEMO			0x4000
#define		LEF_TIMEDMVTS			0x8000

//////////////////////////////////////////////////////////////////////////////
// Layers
//

#define FLOPT_XCOEF				0x0001
#define FLOPT_YCOEF				0x0002
#define FLOPT_NOSAVEBKD			0x0004
#define FLOPT_WRAP_OBSOLETE		0x0008
#define FLOPT_VISIBLE			0x0010
#define FLOPT_WRAP_HORZ			0x0020
#define FLOPT_WRAP_VERT			0x0040
#define FLOPT_PREVIOUSEFFECT	0x0080
#define FLOPT_REDRAW		0x000010000
#define FLOPT_TOHIDE		0x000020000
#define FLOPT_TOSHOW		0x000040000

struct EditFrameLayer
{
	unsigned int		dwOptions;		// Options
	float		xCoef;
	float		yCoef;
	unsigned int		nBkdLOs;
	unsigned int		nFirstLOIndex;

};

struct EditFrameLayerEffect {

	unsigned int	dwInkFx;
	unsigned int	dwRGBA;
	unsigned int	dwExtInkFxIdx;
	unsigned int	nParams;
	LPARAM	paramData;		// offset

};

// Effects
#ifdef HWABETA

typedef struct EffectHdr {
	unsigned int	dwEffectNameOffset;
	unsigned int	dwEffectDataOffset;
	unsigned int	dwEffectParamsOffset;
	unsigned int	dwOptions;
} EffectHdr;

#define EFFECTOPT_BKDTEXTUREMASK	0x000F

typedef struct EffectParamsHdr {
	unsigned int	dwNParams;
	unsigned int	dwParamTypesOffset;
	unsigned int	dwParamNamesOffset;
} EffectParamsHdr;

typedef struct EffectRunData {

	unsigned int erdEffectIndex;
	unsigned int erdNParams;
} EffectRunData;

typedef struct FrameEffect {

	unsigned int	ffxInkEffect;
	unsigned int	ffxInkEffectParam;
} FrameEffect;

#endif // HWABETA

//////////////////////////////////////////////////////////////////////////////
// ObjInfo/FrameItem Header
//
struct ObjInfoHeader
{
	WORD	oiHandle;
	WORD	oiType;
	WORD	oiFlags;			// Memory flags
	WORD	oiReserved;			// No longer used
	unsigned int	oiInkEffect;		// Ink effect
	unsigned int	oiInkEffectParam;	// Ink effect param

};

// oiFlags
#define	OIF_LOADONCALL	0x0001
#define	OIF_DISCARDABLE	0x0002
#define	OIF_GLOBAL		0x0004
#define OIF_RESERVED_1	0x0008
#define OIF_GLOBAL_EDITOR_NOSYNC	0x0010
#define OIF_GLOBAL_EDITOR_FORCESYNC	0x0020

//////////////////////////////////////////////////////////////////////////////
// LevObj/FrameItemInstance
//

#ifndef      _H2INC
class diskLO {
public:
	WORD	loHandle;			// HLO
	WORD	loOiHandle;			// HOI
	LONG	loX;				// Coords
	LONG	loY;
	WORD	loParentType;		// Parent type
	WORD	loOiParentHandle;	// HOI Parent
	WORD	loLayer;			// Layer
	WORD	loFree;				// Not used
};
typedef diskLO * fpDiskLO;
#endif  // _H2INC

//////////////////////////////////////////////////////////////////////////////
//
// ObjInfo/FrameItem ObjectsCommon
//

// Obstacle types
enum {
	OBSTACLE_NONE,
	OBSTACLE_SOLID,
	OBSTACLE_PLATFORM,
	OBSTACLE_LADDER,
	OBSTACLE_TRANSPARENT		// for Add Backdrop
};

////////////////////////////////
// Static object - ObjectsCommon
//
#ifndef      _H2INC
typedef struct Static_OC {

	// Size
	unsigned int	ocDWSize;

	// Obstacle type & collision mode
	WORD	ocObstacleType;
	WORD	ocColMode;			// Collision mode (0 = fine, 1 = box)

	LONG	ocCx;				// Size
	LONG	ocCy;

} Static_OC;
typedef Static_OC * LPStatic_OC;
#endif  // _H2INC

///////////////////////////////////////////////////////////////
// Fill Type & shapes - Definitions
//

#ifndef      _H2INC
// Gradient
typedef struct GradientData {
	COLORREF		color1;
	COLORREF		color2;
	unsigned int			vertical;
} GradientData;

// Shapes
enum {
	SHAPE_NONE=0,			// Error
	SHAPE_LINE,
	SHAPE_RECTANGLE,
	SHAPE_ELLIPSE
};

// Fill types
enum {
	FILLTYPE_NONE,
	FILLTYPE_SOLID,
	FILLTYPE_GRADIENT,
	FILLTYPE_MOTIF
};

// Line flags
#define	LINEF_INVX	0x0001
#define	LINEF_INVY	0x0002

#endif // _H2INC

///////////////////////////////////////////////////////////////
// Fill Type - Part of FilledShape
//
#ifndef      _H2INC

class FillType_Data {
public:
	WORD				ocFillType;
	union {
		struct {
			unsigned int		ocLineFlags;		// Only for lines in non filled mode
		};
		struct {
			COLORREF	ocColor;			// Solid
		};
		struct {
			COLORREF	ocColor1;			// Gradient
			COLORREF	ocColor2;
			unsigned int		ocGradientFlags;
		};
		struct {
			WORD		ocImage;			// Image
		};
	};
};

#endif // _H2INC

///////////////////////////////////////////////////////////////
// Filled Shape - Part of QuickBackdrop / Counter ObjectsCommon
//
#ifndef      _H2INC

class FilledShape_Data {
public:
	WORD			ocBorderSize;			// Border
	COLORREF		ocBorderColor;
	WORD			ocShape;				// Shape
	FillType_Data	ocFillData;				// Fill Type infos
};
typedef FilledShape_Data * LPFilledShape_Data;

#endif // _H2INC

/////////////////////////////////
// Quick backdrop - ObjectsCommon
//
#ifndef      _H2INC

typedef struct QuickBackdrop_OC {

	unsigned int	ocDWSize;

	WORD	ocObstacleType;		// Obstacle type
	WORD	ocColMode;			// Collision mode (0 = fine, 1 = box)

	LONG	ocCx;				// Size
	LONG	ocCy;

	FilledShape_Data	ocFilledShape;		// Filled shape infos

} QuickBackdrop_OC;
typedef QuickBackdrop_OC * LPQuickBackdrop_OC;

#endif // _H2INC

/////////////////////////////////
// Backdrop - ObjectsCommon
//
#ifndef      _H2INC

struct Backdrop_OC {

	unsigned int	ocDWSize;

	WORD	ocObstacleType;		// Obstacle type
	WORD	ocColMode;			// Collision mode (0 = fine, 1 = box)

	LONG	ocCx;				// Size
	LONG	ocCy;

	WORD	ocImage;			// Image

};
typedef Backdrop_OC * LPBackdrop_OC;

#endif // _H2INC

//////////////////////////////////////////////////////////////////////////////
//
// ObjInfo/FrameItem ObjectsCommon Data
//

//////////////////////////////////////////////////////////////////////////////
// ImageSet
//

class ImageSet_Data {
public:
	WORD		nbFrames;		// Number of frames
								// Followed by list of image handles (WORD[])
};
typedef ImageSet_Data * LPImageSet_Data;

////////////////////////////////////////
// Text - ocData
//
struct otText {

	unsigned int	otDWSize;
	LONG	otCx;
	LONG	otCy;
	unsigned int	otNumberOfText;			// Paragraph number (> 1 if question object)
	unsigned int	otStringOffset[1];		// String offsets

};
typedef otText	*	fpot;
#define sizeof_ot	(sizeof(otText)-sizeof(unsigned int))

typedef	struct	txString {
	WORD		tsFont;					// Font
	WORD		tsFlags;				// Flags
	COLORREF	tsColor;				// Color
	TCHAR		tsChar[1];
} txString;
typedef	txString	*	fpts;
#define	sizeof_ts	8					// (sizeof(txString)-1)

#define	TSF_LEFT		0x0000			// DT_LEFT
#define	TSF_HCENTER		0x0001			// DT_CENTER
#define	TSF_RIGHT		0x0002			// DT_RIGHT
#define	TSF_VCENTER		0x0004			// DT_VCENTER
#define	TSF_HALIGN		0x000F			// DT_LEFT | DT_RIGHT | DT_CENTER | DT_VCENTER | DT_BOTTOM

#define	TSF_CORRECT		0x0100
#define	TSF_RELIEF		0x0200
#define TSF_RTL			0x0400

////////////////////////////////////////
// Scores, lives, counters
//
struct CtAnim_Data {

	unsigned int		odDWSize;
	LONG		odCx;					// Size: only lives & counters
	LONG		odCy;
	WORD		odPlayer;				// Player: only score & lives
	WORD		odDisplayType;			// CTA_xxx
	WORD		odDisplayFlags;			// BARFLAG_INVERSE
	WORD		odFont;					// Font

	// Followed by display data:
//	union {
//		ImageSet_Data		odImages;
//		FilledShape_Data	odShape;
//	};

};
typedef CtAnim_Data * LPCtAnim_Data;

// Display types
enum	{
	CTA_HIDDEN,
	CTA_DIGITS,
	CTA_VBAR,
	CTA_HBAR,
	CTA_ANIM,
	CTA_TEXT,
};

// Display flags
#define	CPTDISPFLAG_INTNDIGITS				0x000F		// 0 = normal display, other value = pad with zeros or truncate
#define	CPTDISPFLAG_FLOATNDIGITS			0x00F0		// add 1 to get the number of significant digits to display
#define	CPTDISPFLAG_FLOATNDIGITS_SHIFT		4
#define	CPTDISPFLAG_FLOATNDECIMALS			0xF000		// number of digits to display after the decimal point
#define	CPTDISPFLAG_FLOATNDECIMALS_SHIFT	12
#define	BARFLAG_INVERSE						0x0100
#define	CPTDISPFLAG_FLOAT_FORMAT			0x0200		// 1 to use the specified numbers of digits, 0 to use standard display (%g)
#define	CPTDISPFLAG_FLOAT_USENDECIMALS		0x0400		// 1 to use the specified numbers of digits after the decimal point
#define	CPTDISPFLAG_FLOAT_PADD				0x0800		// 1 to left padd with zeros

// Counters images
enum {
	COUNTER_IMAGE_0,
	COUNTER_IMAGE_1,
	COUNTER_IMAGE_2,
	COUNTER_IMAGE_3,
	COUNTER_IMAGE_4,
	COUNTER_IMAGE_5,
	COUNTER_IMAGE_6,
	COUNTER_IMAGE_7,
	COUNTER_IMAGE_8,
	COUNTER_IMAGE_9,
	COUNTER_IMAGE_SIGN_NEG,
	COUNTER_IMAGE_SIGN_PLUS,
	COUNTER_IMAGE_POINT,
	COUNTER_IMAGE_EXP,
	COUNTER_IMAGE_MAX
};
#define	V1_COUNTER_IMAGE_MAX	(COUNTER_IMAGE_SIGN_NEG+1)

////////////////////////////////////////
//
// Objet RTF - ocData
//
#ifndef      _H2INC

typedef struct ocRTF {

	unsigned int		odDWSize;
	unsigned int		odVersion;				// 0
	unsigned int		odOptions;				// Options
	COLORREF	odBackColor;			// Background color	
	LONG		odCx;					// Size
	LONG		odCy;

} ocRTF;
typedef ocRTF * LPOCRTF;

//#define	RTFOPT_TRANSPARENT	0x0001		// Transparent
//#define	RTFOPT_VSLIDER		0x0002		// Display vertical slider if necessary
//#define	RTFOPT_HSLIDER		0x0004		// Display horizontal slider if necessary

#endif // _H2INC

////////////////////////////////////////
//
// Objet CCA - ocData
//
#ifndef      _H2INC

typedef struct ocCCA {

	unsigned int	odDWSize;
	LONG	odCx;						// Size (ignored)
	LONG	odCy;
	WORD	odVersion;					// 0
	WORD	odNStartFrame;
	unsigned int	odOptions;					// Options
	unsigned int	odIconOffset;				// Icon offset
	unsigned int	odFree;						// Free

} ocCCA;
typedef ocCCA * LPOCCCA;

// Options
#define	CCAF_SHARE_GLOBALVALUES		0x00000001
#define	CCAF_SHARE_LIVES			0x00000002
#define	CCAF_SHARE_SCORES			0x00000004
#define	CCAF_SHARE_WINATTRIB		0x00000008
#define	CCAF_STRETCH				0x00000010
#define	CCAF_POPUP					0x00000020
#define CCAF_CAPTION				0x00000040
#define CCAF_TOOLCAPTION			0x00000080
#define CCAF_BORDER					0x00000100
#define CCAF_WINRESIZE				0x00000200
#define CCAF_SYSMENU				0x00000400
#define CCAF_DISABLECLOSE			0x00000800
#define CCAF_MODAL					0x00001000
#define CCAF_DIALOGFRAME			0x00002000
#define	CCAF_INTERNAL				0x00004000
#define	CCAF_HIDEONCLOSE			0x00008000
#define	CCAF_CUSTOMSIZE				0x00010000
#define	CCAF_INTERNALABOUTBOX		0x00020000
#define	CCAF_CLIPSIBLINGS			0x00040000
#define	CCAF_SHARE_PLAYERCTRLS		0x00080000
#define CCAF_MDICHILD				0x00100000
#define CCAF_DOCKED					0x00200000
#define	CCAF_DOCKING_AREA			0x00C00000
#define	CCAF_DOCKED_LEFT			0x00000000
#define	CCAF_DOCKED_TOP				0x00400000
#define	CCAF_DOCKED_RIGHT			0x00800000
#define	CCAF_DOCKED_BOTTOM			0x00C00000
#define	CCAF_REOPEN					0x01000000
#define CCAF_MDIRUNEVENIFNOTACTIVE	0x02000000
#define CCAF_DISPLAYASSPRITE		0x04000000

#endif // _H2INC

////////////////////////////////////////
//
// Transition
//

#ifndef      _H2INC

// Transition header
typedef struct TransitionHdr {
	unsigned int		trDllID;				// DLL id
	unsigned int		trID;					// Transition ID
	unsigned int		trDuration;				// Duration
	unsigned int		trFlags;				// From / to color / background
	unsigned int		trColor;				// Color
} TransitionHdr;

// Transition run-time data
class Transition_Data {
public:
	TransitionHdr	trHdr;
	unsigned int			trDllNameOffset;
	unsigned int			trParamsOffset;
	unsigned int			trParamsSize;
									// Followed by DLL name & transition parameters
};
typedef Transition_Data * LPTRANSITIONDATA;

#define	TRFLAG_COLOR	0x0001
#define TRFLAG_UNICODE	0x0002

#endif // _H2INC

// Text alignment flags
#define	TEXT_ALIGN_LEFT		0x00000001
#define	TEXT_ALIGN_HCENTER	0x00000002
#define	TEXT_ALIGN_RIGHT	0x00000004
#define	TEXT_ALIGN_TOP		0x00000008
#define	TEXT_ALIGN_VCENTER	0x00000010
#define	TEXT_ALIGN_BOTTOM	0x00000020

// Right-to-left ordering
#define	TEXT_RTL			0x00000100

// Text caps
#define	TEXT_FONT			0x00010000
#define	TEXT_COLOR			0x00020000
#define	TEXT_COLOR16		0x00040000

//////////////////////////////////////////////////////////////////////////////
//
//	Run-time Definitions
//

#ifdef	RUN_TIME

#ifndef _H2INC
	typedef short *				LPSHORT;
	typedef LPVOID *			LPLPVOID;
#endif

// Versions
#define	KNPV1_VERSION			0x126		// First K&P version
#define	CNCV1_VERSION			0x207		// Click & Create / The Games Factory
#define	KNP_VERSION				0x300

// Internet Versions
#define	FIRST_NETVERSION		0x001		// First vitalize version
#define	CCN_NETVERSION			0x002		// CCN applications
#define	MORECOMP_NETVERSION		0x003		// Short OIs, compression of levObjs, adpcm sounds, 
#define	CNC_NETVERSION			0x003		// Current Internet Version

// Collision mask margins
#define		COLMASK_XMARGIN			64
#define		COLMASK_YMARGIN			16

// Messages
#define		UM_KNP_GETAPPID		(WM_APP+7)	// No longer used
#define		UM_HVSCROLL			(WM_APP+8)	// No longer used

// App IDs
#define		APPID_KNC		0x3952			// No longer used
#define		APPID_KNCSA		0x9172			// No longer used

// Control IDs
#define		ID_EDIT_WIN		300				// ID of edit window

#endif	// RUN_TIME

// No longer used
#ifndef		HFRAN
	#define		HFRAN	LPBYTE
#endif

// HLO
#define	HLO			WORD
#define	HLO_ERROR	((HLO)-1)
typedef	HLO *		LPHLO;

// Frame password size
#define	PASSWORD_SIZE			9

// Cross-ref tables
enum	{
	IMG_TAB,
	FONT_TAB,
	SOUND_TAB,
	MUSIC_TAB,
	MAX_TABREF
};

#ifdef RUN_TIME

// Preferences
#define	PREF_MUSICON		0x4000
#define	PREF_SOUNDON		0x8000

// Frame handles
#define	HCELL			WORD
#define	HCELL_ERROR		((WORD)-1)

// Jump flags
#define	MPJC_NOJUMP		0
#define	MPJC_DIAGO		1
#define	MPJC_BUTTON1	2
#define	MPJC_BUTTON2	3

// How to play (no longer used)
enum	{
	HTP_NO=0,
	HTP_TXT,
	HTP_WRI,
	HTP_HLP
};
#define	NB_HTPTYPE	4

#endif	// RUN_TIME

// Versions
#define MMFVERSION_MASK		0xFFFF0000
#define MMFBUILD_MASK		0x00000FFF		// MMF build
#define MMFVERFLAG_MASK		0x0000F000
#define MMFVERFLAG_HOME		0x00008000		// TGF
#define MMFVERFLAG_PRO		0x00004000		// MMF Pro
#define MMFVERFLAG_DEMO		0x00002000		// Demo
#define MMFVERFLAG_PLUGIN	0x00001000		// Plugin
#define MMFVERSION_15		0x01050000		// MMF 1.5
#define MMFVERSION_20		0x02000000		// MMF 2.0
#define	MMF_CURRENTVERSION	MMFVERSION_20

// Build numbers
enum MMF_BUILD {
	NONAME = 203,
	MMF_BUILD_MENUIMAGES,
	MMF_BUILD_SUBAPPICON,
	MMF_BUILD_WINMENUIDX,
	MMF_BUILD_NOTUSED,
	MMF_BUILD_ABOUTTEXT,
	FRAMEDPOS,
	TRSPCOLOR,
	BLD211,
	DEMO,
	PREBETA_2,
	PREBETA_3,
	PREBETA_4,	// First update of Jason's book
	ALTVALUES,
	EDTCHUNKS,
	COUNTERTEXT,
	BLD_SDK,		// Pre-SDK version,
	BLD_SDK2,		// Second SDK version,
	MVTSDK2,		// Second Mvt SDK version
	FIXCOLLISANDBEH,
	PROPFILTERS,
	MFXEXTS,
	LASTFRAMEOFFSET,
	EDUDEMOFEB06,
	GLBOBJBUG,
	IDTC,
	BLD229,
	BLD230,
	BLD231,
	FIXQUALIF,
	BLD233,
	BLD234_TGFPR,
	BLD235,
	BLD236,
	BLD237,
	BLD238,
	BLD239_CD,
	BLD240_DEMO,
	BLD241_SP1,
	BLD242_SP2,
	BLD243_SP3,
	BLD244_SP4,
	BLD245_SP5,
	BLD246_SP6,
	BLD247_SP7,
	BLD248_JAVA,
	BLD249_MOBILE_FLASH,
	BLD250,
	BLD251,
	BLD252,
	BLD253,
	BLD254,
};
#define MMF_CURRENTBUILD 254

// MFA file format versions
#define MFA_BUILD_ALTSTR			1						// Alterable strings
#define MFA_BUILD_COUNTERTEXT		2						// Text mode in counters
#define MFA_BUILD_LASTFRAMEOFFSET	3						// Additional frame offset
#define MFA_BUILD_FIXQUALIF			4						// Fix in qualifiers + prd version
#ifdef _UNICODE
	#define MFA_BUILD_LANGID		5						// Language ID
	#define MFA_CURRENTBUILD		MFA_BUILD_LANGID
#else
	#define MFA_CURRENTBUILD		MFA_BUILD_FIXQUALIF
#endif

// Structures for picture editor
struct EditSurfaceParamsA {

	unsigned int		m_dwSize;		// sizeof(EditSurfaceParams)
	char *		m_pWindowTitle;	// Picture Editor title (NULL = default title)
	cSurface*	m_pSf;			// Surface to edit
	unsigned int		m_dwOptions;	// Options, see PictEdDefs.h
	unsigned int		m_dwFixedWidth;	// Default width or fixed width (if PICTEDOPT_FIXEDIMGSIZE is used)
	unsigned int		m_dwFixedHeight;// Default height or fixed height (if PICTEDOPT_FIXEDIMGSIZE is used)
	POINT		m_hotSpot;		// Hot spot coordinates
	POINT		m_actionPoint;	// Action point coordinates

};
typedef EditSurfaceParamsA* LPEDITSURFACEPARAMSA;

struct EditSurfaceParamsW {

	unsigned int		m_dwSize;		// sizeof(EditSurfaceParams)
	wchar_t *		m_pWindowTitle;	// Picture Editor title (NULL = default title)
	cSurface*	m_pSf;			// Surface to edit
	unsigned int		m_dwOptions;	// Options, see PictEdDefs.h
	unsigned int		m_dwFixedWidth;	// Default width or fixed width (if PICTEDOPT_FIXEDIMGSIZE is used)
	unsigned int		m_dwFixedHeight;// Default height or fixed height (if PICTEDOPT_FIXEDIMGSIZE is used)
	POINT		m_hotSpot;		// Hot spot coordinates
	POINT		m_actionPoint;	// Action point coordinates

};
typedef EditSurfaceParamsW* LPEDITSURFACEPARAMSW;

#ifdef _UNICODE
	#define EditSurfaceParams	EditSurfaceParamsW
	typedef EditSurfaceParamsW* LPEDITSURFACEPARAMS;
#else
	#define EditSurfaceParams	EditSurfaceParamsA
	typedef EditSurfaceParamsA* LPEDITSURFACEPARAMS;
#endif

typedef struct EditImageParamsA {

	unsigned int	m_dwSize;			// sizeof(EditImageParams)
	char *	m_pWindowTitle;		// Picture Editor title (NULL = default title)
	unsigned int	m_dwImage;			// Image to edit - note: only the LOWORD is used in this version
	unsigned int	m_dwOptions;		// Options, see PictEdDefs.h
	unsigned int	m_dwFixedWidth;		// Default width or fixed width (if PICTEDOPT_FIXEDIMGSIZE is used)
	unsigned int	m_dwFixedHeight;	// Default height or fixed height (if PICTEDOPT_FIXEDIMGSIZE is used)

} EditImageParamsA;
typedef EditImageParamsA* LPEDITIMAGEPARAMSA;

typedef struct EditImageParamsW {

	unsigned int	m_dwSize;			// sizeof(EditImageParams)
	wchar_t *		m_pWindowTitle;		// Picture Editor title (NULL = default title)
	unsigned int	m_dwImage;			// Image to edit - note: only the LOWORD is used in this version
	unsigned int	m_dwOptions;		// Options, see PictEdDefs.h
	unsigned int	m_dwFixedWidth;		// Default width or fixed width (if PICTEDOPT_FIXEDIMGSIZE is used)
	unsigned int	m_dwFixedHeight;	// Default height or fixed height (if PICTEDOPT_FIXEDIMGSIZE is used)

} EditImageParamsW;
typedef EditImageParamsW* LPEDITIMAGEPARAMSW;

#ifdef _UNICODE
	#define EditImageParams	EditImageParamsW
	typedef EditImageParamsW* LPEDITIMAGEPARAMS;
#else
	#define EditImageParams	EditImageParamsA
	typedef EditImageParamsA* LPEDITIMAGEPARAMS;
#endif

// Structure for image list editor
struct EditAnimationParams {

	unsigned int	m_dwSize;			// sizeof(EditAnimationParams)
	TCHAR *			m_pWindowTitle;		// Picture Editor title (NULL = default title)
	int				m_nImages,			// Number of images in the list
					m_nMaxImages,		// Maximum number of images in the list
					m_nStartIndex;		// Index of first image to edit in the editor
	LPWORD			m_pImages;			// Image list (one WORD per image)
	TCHAR **		m_pImageTitles;		// Image titles (can be NULL)
	unsigned int	m_dwOptions;		// Options, see PictEdDefs.h
	unsigned int	m_dwFixedWidth;		// Default width or fixed width (if PICTEDOPT_FIXEDIMGSIZE is used)
	unsigned int	m_dwFixedHeight;	// Default height or fixed height (if PICTEDOPT_FIXEDIMGSIZE is used)

};


// Global variables structure
class mv {
public:

	// Common to editor and runtime
	HINSTANCE			mvHInst;				// Application HINSTANCE
	npAppli				mvIdAppli;				// Application object in DLL
	npWin				mvIdMainWin;			// Main window object in DLL
	npWin				mvIdEditWin;			// Child window object in DLL
	HWND				mvHMainWin;				// Main window handle
	HWND				mvHEditWin;				// Child window handle
	HPALETTE			mvHPal256;				// 256 color palette
	WORD				mvAppMode;				// Screen mode with flags
	WORD				mvScrMode;				// Screen mode
	unsigned int				mvEditDXDocToClient;	// Edit time only: top-left coordinates
	unsigned int				mvEditDYDocToClient;
	CImageFilterMgr*	mvImgFilterMgr;			// Image filter manager
	CSoundFilterMgr*	mvSndFilterMgr;			// Sound filter manager
	CSoundManager*		mvSndMgr;				// Sound manager

	union {
		CEditApp*		mvEditApp;				// Current application, edit time (not used)
		CRunApp*		mvRunApp;				// Current application, runtime
	};
	union {
		CEditFrame*		mvEditFrame;
		CRunFrame*		mvRunFrame;
	};

	// Runtime
	RunHeader*			mvRunHdr;				// Current RunHeader
	unsigned int				mvPrefs;				// Preferences (sound on/off)
	TCHAR *				subType;
	BOOL				mvFullScreen;			// Full screen mode
	TCHAR *				mvMainAppFileName;		// App filename
	int					mvAppListCount;
	int					mvAppListSize;
	CRunApp**			mvAppList;
	int					mvExtListCount;
	int					mvExtListSize;
	TCHAR * *			mvExtList;
	int					mvNbDllTrans;
	dllTrans*			mvDllTransList;
	unsigned int				mvJoyCaps[32];
	HHOOK				mvHMsgHook;
	int					mvModalLoop;
	int					mvModalSubAppCount;
	LPVOID				mvFree[5];

	// Functions
	////////////

	// Editor: Open Help file
	void				(CALLBACK * mvHelpA) (const char * pHelpFile, UINT nID, LPARAM lParam);

	// Editor: Get default font for object creation
	BOOL				(CALLBACK * mvGetDefaultFontA) (LPLOGFONTA plf, char * pStyle, int cbSize);

	// Editor: Edit images and animations
	BOOL				(CALLBACK * mvEditSurfaceA) (LPVOID edPtr, LPEDITSURFACEPARAMSA pParams, HWND hParent);
	BOOL				(CALLBACK * mvEditImageA) (LPVOID edPtr, LPEDITIMAGEPARAMSA pParams, HWND hParent);
	BOOL				(CALLBACK * mvEditAnimationA) (LPVOID edPtr, EditAnimationParams * pParams, HWND hParent);

	// Runtime: Extension User data
	LPVOID				(CALLBACK * mvGetExtUserData) (CRunApp* pApp, HINSTANCE hInst);
	LPVOID				(CALLBACK * mvSetExtUserData) (CRunApp* pApp, HINSTANCE hInst, LPVOID pData);

	// Runtime: Register dialog box
	void				(CALLBACK * mvRegisterDialogBox) (HWND hDlg);
	void				(CALLBACK * mvUnregisterDialogBox) (HWND hDlg);

	// Runtime: Add surface as backdrop object
	void				(CALLBACK * mvAddBackdrop) (cSurface * pSf, int x, int y, unsigned int dwInkEffect, unsigned int dwInkEffectParam, int nObstacleType, int nLayer);

	// Runtime: Binary files
	BOOL				(CALLBACK * mvGetFileA)(const char * pPath, char * pFilePath, unsigned int dwFlags);
	void				(CALLBACK * mvReleaseFileA)(const char * pPath);
	HANDLE				(CALLBACK * mvOpenHFileA)(const char * pPath, unsigned int * pDwSize, unsigned int dwFlags);
	void				(CALLBACK * mvCloseHFile)(HANDLE hf);

	// Plugin: download file
	int					(CALLBACK * mvLoadNetFileA) (char * pFilename);

	// Plugin: send command to Vitalize
	int					(CALLBACK * mvNetCommandA) (int, void *, unsigned int, void *, unsigned int);

	// Editor & Runtime: Returns the version of MMF or of the runtime
	unsigned int				(CALLBACK * mvGetVersion) ();

	// Editor & Runtime: callback function for properties or other functions
	LRESULT				(CALLBACK * mvCallFunction) (EDITDATA * edPtr, int nFnc, LPARAM lParam1, LPARAM lParam2, LPARAM lParam3);

	// Editor: Open Help file (UNICODE)
	void				(CALLBACK * mvHelpW) (const wchar_t * pHelpFile, UINT nID, LPARAM lParam);

	// Editor: Get default font for object creation (UNICODE)
	BOOL				(CALLBACK * mvGetDefaultFontW) (LPLOGFONTW plf, wchar_t * pStyle, int cbSize);

	// Editor: Edit images and animations (UNICODE)
	BOOL				(CALLBACK * mvEditSurfaceW) (EDITDATA * edPtr, LPEDITSURFACEPARAMSW pParams, HWND hParent);
	BOOL				(CALLBACK * mvEditImageW) (EDITDATA * edPtr, LPEDITIMAGEPARAMSW pParams, HWND hParent);
	BOOL				(CALLBACK * mvEditAnimationW) (EDITDATA * edPtr, EditAnimationParams * pParams, HWND hParent);

	// Runtime: Binary files (UNICODE
	BOOL				(CALLBACK * mvGetFileW)(const wchar_t * pPath, wchar_t * pFilePath, unsigned int dwFlags);
	void				(CALLBACK * mvReleaseFileW)(const wchar_t * pPath);
	HANDLE				(CALLBACK * mvOpenHFileW)(const wchar_t * pPath, unsigned int * pDwSize, unsigned int dwFlags);

	// Plugin: download file
	int					(CALLBACK * mvLoadNetFileW) (wchar_t * pFilename);

	// Plugin: send command to Vitalize
	int					(CALLBACK * mvNetCommandW) (int, void *, unsigned int, void *, unsigned int);

	// Place-holder for next versions
	LPVOID				mvAdditionalFncs[6];

};
typedef mv *LPMV;

#ifdef _UNICODE
	#define mvHelp	mvHelpW
	#define mvGetDefaultFont	mvGetDefaultFontW
	#define mvEditSurface	mvEditSurfaceW
	#define mvEditImage	mvEditImageW
	#define mvEditAnimation	mvEditAnimationW
	#define mvGetFile	mvGetFileW
	#define mvReleaseFile	mvReleaseFileW
	#define mvLoadNetFile	mvLoadNetFileW
	#define mvNetCommand	mvNetCommandW
	#define	mvGetFile		mvGetFileW
	#define	mvReleaseFile	mvReleaseFileW
	#define mvOpenHFile		mvOpenHFileW
#else
	#define mvHelp	mvHelpA
	#define mvGetDefaultFont	mvGetDefaultFontA
	#define mvEditSurface	mvEditSurfaceA
	#define mvEditImage	mvEditImageA
	#define mvEditAnimation	mvEditAnimationA
	#define mvGetFile	mvGetFileA
	#define mvReleaseFile	mvReleaseFileA
	#define mvLoadNetFile	mvLoadNetFileA
	#define mvNetCommand	mvNetCommandA
	#define	mvGetFile		mvGetFileA
	#define	mvReleaseFile	mvReleaseFileA
	#define mvOpenHFile		mvOpenHFileA
#endif

// Callback function identifiers for mvCallFunction
enum {
	// Editor only
	EF_INSERTPROPS=1,		// Insert properties into Property window
	EF_REMOVEPROP,			// Remove property
	EF_REMOVEPROPS,			// Remove properties
	EF_REFRESHPROP,			// Refresh propery
	EF_REALLOCEDITDATA,		// Reallocate edPtr
	EF_GETPROPVALUE,		// Get object's property value
	EF_GETAPPPROPVALUE,		// Get application's property value
	EF_GETFRAMEPROPVALUE,	// Get frame's property value
	EF_SETPROPVALUE,		// Set object's property value
	EF_SETAPPPROPVALUE,		// Set application's property value
	EF_SETFRAMEPROPVALUE,	// Set frame's property value
	EF_GETPROPCHECK,		// Get object's property check state
	EF_GETAPPPROPCHECK,		// Get application's property check state
	EF_GETFRAMEPROPCHECK,	// Get frame's property check state
	EF_SETPROPCHECK,		// Set object's property check state
	EF_SETAPPPROPCHECK,		// Set application's property check state
	EF_SETFRAMEPROPCHECK,	// Set frame's property check state
	EF_INVALIDATEOBJECT,	// Refresh object in frame editor
	EF_RECALCLAYOUT,		// Recalc runtime layout (docking)
	EF_GETNITEMS,			// Get number of items - not yet implemented
	EF_GETNEXTITEM,			// Get next item - not yet implemented
	EF_GETNINSTANCES,		// Get number of item instances - not yet implemented
	EF_GETNEXTINSTANCE,		// Get next item instance - not yet implemented

	// Editor & runtime
	EF_MALLOC=100,			// Allocate memory
	EF_CALLOC,				// Allocate memory & set it to 0
	EF_REALLOC,				// Re-allocate memory
	EF_FREE,				// Free memory
	EF_GETSOUNDMGR,			// Get sound manager
	EF_CLOSESOUNDMGR,		// Close sound manager
	EF_ENTERMODALLOOP,		// Reserved
	EF_EXITMODALLOOP,		// Reserved
	EF_CREATEEFFECT,		// Create effect (runtime only)
	EF_DELETEEFFECT,		// Delete effect (runtime only)
	EF_CREATEIMAGEFROMFILEA,// Create image from file (runtime only)
	EF_NEEDBACKGROUNDACCESS,// HWA : tell the frame the frame surface can be read (runtime only)
	EF_ISHWA,				// Returns TRUE if HWA version (editor and runtime)
	EF_ISUNICODE,			// Returns TRUE if the editor or runtime is in Unicode mode
	EF_ISUNICODEAPP,		// Returns TRUE if the application being loaded is a Unicode application
	EF_GETAPPCODEPAGE,		// Returns the code page of the application
	EF_CREATEIMAGEFROMFILEW,// Create image from file (runtime only)
};

// 3rd parameter of EF_CREATEIMAGEFROMFILE
struct CreateImageFromFileInfo {
	int			nSize;
	int			xHS;
	int			yHS;
	int			xAP;
	int			yAP;
	COLORREF	trspColor;
};


// Callback function macros for mvCallFunction
__inline void mvInsertProps(LPMV mV, EDITDATA * edPtr, PropData* pProperties, UINT nInsertPropID, BOOL bAfter) \
	{ mV->mvCallFunction(edPtr, EF_INSERTPROPS, (LPARAM)pProperties, (LPARAM)nInsertPropID, (LPARAM)bAfter); }

__inline void mvRemoveProp(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ mV->mvCallFunction(edPtr, EF_REMOVEPROP, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline void mvRemoveProps(LPMV mV, EDITDATA * edPtr, PropData* pProperties) \
	{ mV->mvCallFunction(edPtr, EF_REMOVEPROPS, (LPARAM)pProperties, (LPARAM)0, (LPARAM)0); }

__inline void mvRefreshProp(LPMV mV, EDITDATA * edPtr, UINT nPropID, BOOL bReInit) \
	{ mV->mvCallFunction(edPtr, EF_REFRESHPROP, (LPARAM)nPropID, (LPARAM)bReInit, (LPARAM)0); }

__inline LPVOID mvReAllocEditData(LPMV mV, EDITDATA * edPtr, unsigned int dwNewSize) \
	{ return (LPVOID)mV->mvCallFunction(edPtr, EF_REALLOCEDITDATA, (LPARAM)edPtr, dwNewSize, 0); }

__inline EditProp * mvGetPropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (EditProp *)mV->mvCallFunction(edPtr, EF_GETPROPVALUE, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline EditProp * mvGetAppPropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (EditProp *)mV->mvCallFunction(edPtr, EF_GETAPPPROPVALUE, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline EditProp * mvGetFramePropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (EditProp *)mV->mvCallFunction(edPtr, EF_GETFRAMEPROPVALUE, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline void mvSetPropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID, EditProp * pValue) \
	{ mV->mvCallFunction(edPtr, EF_SETPROPVALUE, (LPARAM)nPropID, (LPARAM)pValue, (LPARAM)0); }

__inline void mvSetAppPropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID, EditProp * pValue) \
	{ mV->mvCallFunction(edPtr, EF_SETAPPPROPVALUE, (LPARAM)nPropID, (LPARAM)pValue, (LPARAM)0); }

__inline void mvSetFramePropValue(LPMV mV, EDITDATA * edPtr, UINT nPropID, EditProp * pValue) \
	{ mV->mvCallFunction(edPtr, EF_SETFRAMEPROPVALUE, (LPARAM)nPropID, (LPARAM)pValue, (LPARAM)0); }

__inline UINT mvGetPropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (UINT)mV->mvCallFunction(edPtr, EF_GETPROPCHECK, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline UINT mvGetAppPropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (UINT)mV->mvCallFunction(edPtr, EF_GETAPPPROPCHECK, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline UINT mvGetFramePropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID) \
	{ return (UINT)mV->mvCallFunction(edPtr, EF_GETFRAMEPROPCHECK, (LPARAM)nPropID, (LPARAM)0, (LPARAM)0); }

__inline void mvSetPropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID, UINT nCheck) \
	{ mV->mvCallFunction(edPtr, EF_SETPROPCHECK, (LPARAM)nPropID, (LPARAM)nCheck, (LPARAM)0); }

__inline void mvSetAppPropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID, UINT nCheck) \
	{ mV->mvCallFunction(edPtr, EF_SETAPPPROPCHECK, (LPARAM)nPropID, (LPARAM)nCheck, (LPARAM)0); }

__inline void mvSetFramePropCheck(LPMV mV, EDITDATA * edPtr, UINT nPropID, UINT nCheck) \
	{ mV->mvCallFunction(edPtr, EF_SETFRAMEPROPCHECK, (LPARAM)nPropID, (LPARAM)nCheck, (LPARAM)0); }

__inline void mvInvalidateObject(LPMV mV, EDITDATA * edPtr) \
	{ mV->mvCallFunction(edPtr, EF_INVALIDATEOBJECT, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline LPVOID mvMalloc(LPMV mV, int nSize) \
	{ return (LPVOID)mV->mvCallFunction(NULL, EF_MALLOC, (LPARAM)nSize, (LPARAM)0, (LPARAM)0); }

__inline LPVOID mvCalloc(LPMV mV, int nSize) \
	{ return (LPVOID)mV->mvCallFunction(NULL, EF_CALLOC, (LPARAM)nSize, (LPARAM)0, (LPARAM)0); }

__inline LPVOID mvReAlloc(LPMV mV, void * ptr, int nNewSize) \
	{ return (LPVOID)mV->mvCallFunction(NULL, EF_REALLOC, (LPARAM)ptr, (LPARAM)nNewSize, (LPARAM)0); }

__inline void mvFree(LPMV mV, void * ptr) \
	{ mV->mvCallFunction(NULL, EF_FREE, (LPARAM)ptr, (LPARAM)0, (LPARAM)0); }

__inline void mvRecalcLayout(LPMV mV) \
	{ mV->mvCallFunction(NULL, EF_RECALCLAYOUT, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline CSoundManager* mvGetSoundMgr(LPMV mV) \
	{ mV->mvCallFunction(NULL, EF_GETSOUNDMGR, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline void mvCloseSoundMgr(LPMV mV) \
	{ mV->mvCallFunction(NULL, EF_CLOSESOUNDMGR, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline int mvGetNItems(LPMV mV, EDITDATA * edPtr, const char * extName) \
	{ return mV->mvCallFunction(edPtr, EF_GETNITEMS, (LPARAM)extName, (LPARAM)0, (LPARAM)0); }

__inline LPVOID mvGetFirstItem(LPMV mV, EDITDATA * edPtr, const char * extName) \
	{ return (LPVOID)mV->mvCallFunction(edPtr, EF_GETNEXTITEM, (LPARAM)extName, (LPARAM)0, (LPARAM)0); }

__inline LPVOID mvGetNextItem(LPMV mV, EDITDATA * edPtr, LPVOID edPtr1, const char * extName) \
	{ return (LPVOID)mV->mvCallFunction(edPtr, EF_GETNEXTITEM, (LPARAM)edPtr1, (LPARAM)extName, (LPARAM)0); }

#ifdef HWABETA

__inline BOOL mvCreateEffect(LPMV mV, const char * pEffectName, LPINT pEffect, LPARAM* pEffectParam) \
	{ return (BOOL)mV->mvCallFunction(NULL, EF_CREATEEFFECT, (LPARAM)pEffectName, (LPARAM)pEffect, (LPARAM)pEffectParam); }

__inline void mvDeleteEffect(LPMV mV, int nEffect, LPARAM lEffectParam) \
	{ mV->mvCallFunction(NULL, EF_DELETEEFFECT, (LPARAM)nEffect, (LPARAM)lEffectParam, (LPARAM)0); }

#endif // HWABETA

__inline BOOL mvCreateImageFromFileA(LPMV mV, LPWORD pwImg, const char * pFilename, CreateImageFromFileInfo* pInfo) \
	{ return (BOOL)mV->mvCallFunction(NULL, EF_CREATEIMAGEFROMFILEA, (LPARAM)pwImg, (LPARAM)pFilename, (LPARAM)pInfo); }

__inline BOOL mvCreateImageFromFileW(LPMV mV, LPWORD pwImg, const wchar_t * pFilename, CreateImageFromFileInfo* pInfo) \
	{ return (BOOL)mV->mvCallFunction(NULL, EF_CREATEIMAGEFROMFILEW, (LPARAM)pwImg, (LPARAM)pFilename, (LPARAM)pInfo); }

__inline LPVOID mvNeebBackgroundAccess(LPMV mV, CRunFrame* pFrame, BOOL bNeedAccess) \
	{ return (LPVOID)mV->mvCallFunction(NULL, EF_NEEDBACKGROUNDACCESS, (LPARAM)pFrame, (LPARAM)bNeedAccess, (LPARAM)0); }

__inline BOOL mvIsHWAVersion(LPMV mV) \
	{ return mV->mvCallFunction(NULL, EF_ISHWA, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline BOOL mvIsUnicodeVersion(LPMV mV) \
	{ return mV->mvCallFunction(NULL, EF_ISUNICODE, (LPARAM)0, (LPARAM)0, (LPARAM)0); }

__inline BOOL mvIsUnicodeApp(LPMV mV, LPVOID pApp) \
	{ return mV->mvCallFunction(NULL, EF_ISUNICODEAPP, (LPARAM)pApp, (LPARAM)0, (LPARAM)0); }

__inline int mvGetAppCodePage(LPMV mV, LPVOID pApp) \
	{ return mV->mvCallFunction(NULL, EF_GETAPPCODEPAGE, (LPARAM)pApp, (LPARAM)0, (LPARAM)0); }

#ifdef _UNICODE
	#define mvCreateImageFromFile	mvCreateImageFromFileW
#else
	#define mvCreateImageFromFile	mvCreateImageFromFileA
#endif

// Options for OpenHFile
#define	OHFF_LOCALFILE		0x0001		// Vitalize mode only: don't try to download file from server

#ifdef RUN_TIME

	// EnumEltProc definition
	typedef	int (CALLBACK* ENUMELTPROC)(LPWORD, int, LPARAM, LPARAM);

	// Extension function table
	typedef	struct	tagKpxFunc {
		HINSTANCE			kpxHInst;
		TCHAR *				kpxName;
		TCHAR *				kpxSubType;
		LPVOID				kpxUserData;
		unsigned int ( WINAPI		* kpxGetInfos) (int);
		int  ( WINAPI		* kpxLoadObject) (mv *, OI*, LPBYTE, int);
		void ( WINAPI		* kpxUnloadObject) (mv *, LPBYTE, int);
		void ( WINAPI		* kpxUpdateFileNames) (mv *, TCHAR *, LPBYTE, void (WINAPI * )(LPCTSTR, TCHAR *));
		short( WINAPI		* kpxGetRunObjectInfos) (mv *, LPBYTE);
		short( WINAPI		* kpxWindowProc) (LPBYTE, HWND, UINT, WPARAM, LPARAM);
		int	 ( WINAPI		* kpxEnumElts) (mv *, LPBYTE, ENUMELTPROC, ENUMELTPROC, LPARAM, LPARAM);
		int  ( WINAPI		* kpxLoadData) (mv *, OI*, LPBYTE, HFILE, unsigned int);		// Not used
		int  ( WINAPI		* kpxUnloadData) (mv *, OI*, LPBYTE);					// Not used
		void ( WINAPI		* kpxStartApp) (mv *, CRunApp*);
		void ( WINAPI		* kpxEndApp) (mv *, CRunApp*);
		void ( WINAPI		* kpxStartFrame) (mv *, CRunApp*, int);
		void ( WINAPI		* kpxEndFrame) (mv *, CRunApp*, int);
		HGLOBAL ( WINAPI	* kpxUpdateEditStructure) (mv *, LPVOID);
	#ifdef VITALIZE
		BOOL				bValidated;
	#endif
		BOOL				bUnicode;
	} kpxFunc;
	typedef kpxFunc * fpKpxFunc;

	// Movement Extension
	typedef	struct	MvxFnc {
		HINSTANCE			mvxHInst;
		TCHAR *				mvxFileTitle;

		CMvt* ( CALLBACK	* mvxCreateMvt) (unsigned int);

		#ifdef VITALIZE
			BOOL				bValidated;
		#endif
	} MvxFnc;

	// Old 16/32 bit macros
	#define	ADDPTR32(p,l)	p+=l;
	#define	SUBPTR32(p,l)	p-=l;
	#define	INCPTR32(p)		p++;

#endif	// RUN_TIME

// Restore structure alignement
#ifndef      _H2INC 
	#pragma pack( pop, _pack_cncy_ )
#endif


//////////////////////////////////////////////////////////////////////////////
//
// LO (frame object instance)
//
//
// Note: mainly used at runtime

class LO {
public:

	WORD	loHandle;			// HLO
	WORD	loOiHandle;			// HOI
	int		loX;				// Coords
	int		loY;
	WORD	loParentType;		// Parent type
	WORD	loOiParentHandle;	// HOI Parent
	WORD	loLayer;			// Layer
	WORD	loType;
	npSpr	loSpr[4];			// Sprite handles for backdrop objects from layers > 1

};
typedef LO *LPLO;
typedef	LO *fpLevObj;


//////////////////////////////////////////////////////////////////////////////
//
// OI (frame object)
//

#define	OILF_OCLOADED			0x0001	//
#define	OILF_ELTLOADED			0x0002	//
#define	OILF_TOLOAD				0x0004	//
#define	OILF_TODELETE			0x0008	//
#define	OILF_CURFRAME			0x0010	//
#define	OILF_TORELOAD			0x0020	// Reload images when frame change
#define	OILF_IGNORELOADONCALL	0x0040	// Ignore load on call option

////////////////////
// ObjInfo structure
////////////////////
//
// Note: mainly used at runtime
// only some members of the oiHdr member are valid at editing time
//
#ifdef OI
	#undef OI
#endif

class OI {
public:
	ObjInfoHeader	oiHdr;			// Header
	TCHAR *			oiName;			// Name
	class OC *		oiOC;			// ObjectsCommon

	unsigned int	oiFileOffset,
					oiLoadFlags;
	unsigned short	oiLoadCount,
					oiCount;

#ifdef HWABETA
	unsigned char *	oiExtEffect;
	CEffectEx*		oiExtEffectEx;	// Pour backdrops, faut trouver un systme plus efficace (banque d'effets pour les backdrops)
#endif // HWABETA

};

// Runtime only
#ifdef RUN_TIME

///////////////////////////////////////////////
//
// Added backdrop objects
//
typedef struct bkd2 {

	WORD	loHnd;			// 0 
	WORD	oiHnd;			// 0 
	int		x;
	int		y;
	WORD	img;
	WORD	colMode;
	WORD	nLayer;
	WORD	obstacleType;
	npSpr	pSpr[4];
	unsigned int	inkEffect;
	unsigned int	inkEffectParam;

} bkd2;
typedef bkd2 *LPBKD2;

#define MAX_BKD2	(curFrame.m_maxObjects)

///////////////////////////////////////////////
//
// Layer at runtime
//
typedef struct RunFrameLayer
{
	// Name
	TCHAR *		pName;			// Name

	// Offset
	int			x, y,			// Current offset
				dx, dy,			// Offset to apply to the next refresh

	// Added backdrops
				m_nBkd2Count;
	LPBKD2		m_pBkd2;

	// Ladders
	int			m_nLadderMax,
				m_nLadders;
	LPRECT		m_pLadders;

	// Z-order max index for dynamic objects
	int			m_nZOrderMax;

	// Permanent data (EditFrameLayer)
	unsigned int	dwOptions;		// Options
	float			xCoef;
	float			yCoef;
	unsigned int	nBkdLOs,		// Number of backdrop objects
					nFirstLOIndex;	// Index of first backdrop object in LO table

	// EditFrameLayerEffect
#ifdef HWABETA
	unsigned int	dwEffect;
	LPARAM			dwEffectParam;	// CEffectEx si extended
#endif // HWABETA

	// Backup for restart
	unsigned int	backUp_dwOptions;
	float			backUp_xCoef,
					backUp_yCoef;
	unsigned int	backUp_nBkdLOs,
					backUp_nFirstLOIndex;

#ifdef HWABETA
//	unsigned int		backUp_dwEffect;		// A voir
//	LPARAM		backUp_dwEffectParam;
#endif // HWABETA

} RunFrameLayer;

// Object transition data
struct objTransInfo {

	CTransition *	m_pTrans;				// Transition object
	cSurface *		m_SfSave,				// Background surface
			 *		m_SfDisplay,			// Working surface
			 *		m_Sf1,					// Source surface
			 *		m_Sf2;					// Destination surface
	BOOL			m_fadeOut,				// fade type
					m_fill1withbackground,	// source = background (opaque mode)
					m_fill2withbackground,	// dest = background (opaque mode)
					m_saved;				// m_SfSave has been updated
	int				m_xsave,
					m_ysave,
					m_cxsave,
					m_cysave;
#ifdef HWABETA
	BOOL			m_bStepDrawBlit;		// Use StepDrawBlit instead of StepDraw
#endif

};
typedef objTransInfo * LPOBJTRANSINFO;

//////////////////////////////////////////////////////////////////////////////
//
// Frame at runtime
//

#define	MAX_TEMPSTRING	16
#define IPHONEOPT_JOYSTICK_FIRE1 0x0001
#define IPHONEOPT_JOYSTICK_FIRE2 0x0002
#define IPHONEOPT_JOYSTICK_LEFTHAND 0x0004
#define	IPHONEFOPT_MULTITOUCH			0x0008
#define	IPHONEFOPT_SCREENLOCKING		0x0010
#define	IPHONEFOPT_IPHONEFRAMEIAD		0x0020
#define JOYSTICK_NONE 0x0000
#define JOYSTICK_TOUCH 0x0001
#define JOYSTICK_ACCELEROMETER 0x0002
#define JOYSTICK_EXT 0x0003


class CRunFrame {
public:

	// Header
	FrameHeader		m_hdr;

	// Name
	TCHAR *			m_name;

	// Palette
	LPLOGPALETTE	m_palette;

	// Background surface
	cSurface *		m_pSurface;

	// Coordinates of top-level pixel in edit window
	int				m_leX,
					m_leY,
					m_leLastScrlX,
					m_leLastScrlY,

	// Layers
					m_nLayers;
	RunFrameLayer *	m_pLayers;

	// Virtual rectangle
	RECT			m_leVirtualRect;

	// Instances of frame objects
	int				m_loMaxIndex,
					m_loMaxHandle;
	unsigned short *m_lo_handle_to_index;
	LO *			m_los;

	// Variables for enumeration functions
	int				m_loFranIndex,
					m_oiFranIndex;

	// Remap table or palette handle for sub-application
	unsigned char * m_remapTable,

	// Transitions
				  * m_fadeIn,
				  *	m_fadeOut;
	cSurface *		m_pFadeInSurface1,
			 *		m_pFadeInSurface2;
	CTransition*	m_pTrans;

	// Exit code
	unsigned long	m_levelQuit;

	// Events
	int				m_rhOK;				// TRUE when the events are initialized
	RunHeader *		m_rhPtr;
	eventGroup *	m_eventPrograms;
	unsigned long	m_free[MAX_EVENTPROGRAMS-1];
	objInfoList *	m_oiList;
	void *			m_free0;
	unsigned short * m_qualToOiList,
				   * m_qualOilPtr,		// Ne pas liberer!
				   * m_qualOilPtr2;		// Ne pas liberer!
	short *			m_limitBuffer;
	unsigned long * m_listPointers,
				  *	m_eventPointers;
	qualifierLoad * m_qualifiers;
	short			m_nQualifiers;

	short			m_nConditions[NUMBEROF_SYSTEMTYPES+OBJ_LAST];
	unsigned long	m_free2[MAX_EVENTPROGRAMS];
	unsigned short	m_wJoystick,
					m_wIPhoneOptions;
	unsigned char * m_swapBuffers;
	unsigned long	m_objectList;
	unsigned char * m_destroyList;
	int				m_free3,
					m_nPlayers,
					m_nPlayersReal,
					m_level_loop_state,
					m_startLeX,
					m_startLeY;
	short			m_maxObjects,
					m_maxOI;
	objectsList *	m_oblEnum;
	int				m_oblEnumCpt;
	BOOL			m_eventsBranched,
					m_fade;
	unsigned long	m_fadeTimerDelta,
					m_fadeVblDelta,
					m_pasteMask;

	int				m_nCurTempString;
	TCHAR *			m_pTempString[MAX_TEMPSTRING];	// not used

	// Other
	cSurface *		m_pSaveSurface;
	int				m_leEditWinWidth,
					m_leEditWinHeight;
	unsigned long	m_dwColMaskBits;
	TCHAR *			m_demoFilePath;
	unsigned short	m_wRandomSeed,
					m_wFree;
	unsigned long	m_dwMvtTimerBase;

#ifdef HWABETA
	LPBYTE			m_pLayerEffects;

	// Frame effect
	FrameEffect*	m_pEffect;						// Frame effect (chunk data, contains effect index & param used in blit)
	CEffectEx*		m_pEffectEx;					// Current effect
	bool			m_bFrameEffectChanged;			// Frame effect has been modified
	bool			m_bAlwaysUseSecondarySurface;	// This frame always use a secondary surface

	// Secondary surface (render target used if background or frame effects)
	cSurface*		m_pSecondarySurface;

	// List of sub-app surfaces to refresh at the end in D3D full screen mode
	CPList*			m_pSurfacedSubApps;
#endif

};
typedef CRunFrame *fpRunFrame;

////////////////////////
//
// Binary files
//
class CBinaryFile {
public:
	TCHAR			m_path[MAX_PATH];	// path stored in ccn file
	TCHAR *			m_pTempPath;		// path in temporary folder, if any
	unsigned long	m_fileSize,	// file size
					m_fileOffset;	// file offset in EXE/CCN file
	long			m_tempCount;		// usage count

	CBinaryFile() : m_pTempPath(NULL), m_fileSize(0), m_fileOffset(0), m_tempCount(0) { memset(m_path, 0, MAX_PATH);}
	~CBinaryFile()
	{
		if ( m_pTempPath )
		{
			_tremove(m_pTempPath);
			free(m_pTempPath);
			m_pTempPath = NULL;
			m_tempCount = 0;
		}
	}
};

//////////////////////////////////////////////////////////////////////////////
//
// Application
//

#define	ARF_MENUINIT				0x0001
#define	ARF_MENUIMAGESLOADED		0x0002		// menu images have been loaded into memory
#define	ARF_INGAMELOOP				0x0004
#define ARF_PAUSEDBEFOREMODALLOOP	0x0008

class CRunApp {
public:

	// Application info
	AppMiniHeader	m_miniHdr;			// Version
	AppHeader		m_hdr;				// General info
	TCHAR *			m_name,				// Name of the application
		  *			m_appFileName,		// filename (temporary file in editor mode)
		  *			m_editorFileName,	// filename of original .mfa file
		  *			m_copyright,		// copyright
		  *			m_aboutText;		// text to display in the About box

	// File infos
	TCHAR *			m_targetFileName;	// filename of original CCN/EXE file
	TCHAR *			m_tempPath;			// Temporary directory for external files
	HFILE			m_file;				// File handle
	unsigned long	m_startOffset;

	// Help file
	TCHAR *			m_doc;				// Help file pathname

	// Icon
	LPBYTE			m_icon16x16x8;		// = LPBITMAPINFOHEADER
	HICON			m_hIcon16x16x8;		// Small icon for the main window

	// Menu
	HMENU			m_hRunMenu;			// Menu
	unsigned char * m_accels;			// Accelerators
	TCHAR *			m_pMenuTexts;		// Menu texts (for ownerdraw menu)
	unsigned char * m_pMenuImages;		// Images index used in the menu
	MenuHdr*		m_pMenu;

	// Frame offsets
	int				m_frameMaxIndex;			// Max. number of frames
	int				m_frameMaxHandle;			// Max. frame handle
	unsigned short *m_frame_handle_to_index;	// Handle -> index table
	unsigned long * m_frameOffset;				// Frame offsets in the file

	// Frame passwords
	TCHAR **		m_framePasswords;			// Table of frame passwords

	// Extensions
	int				m_nbKpx;					// Number of extensions
	kpxFunc *		m_kpxTab;					// Function table 1
	fpkpdt          m_kpxDataTable;				// Function table 2

	// Movement Extensions
	int				m_nbMvx;					// Number of extensions
	MvxFnc *		m_mvxTable;					// DLL info

	// Elements
	TCHAR *			m_eltFileName[MAX_TABREF];	// Element banks
	HFILE			m_hfElt[MAX_TABREF];

	unsigned long	m_eltBaseOff;
	unsigned short	m_nbEltOff[MAX_TABREF];			// Sizes of file offset tables
	unsigned long * m_adTabEltOff[MAX_TABREF];		// File offsets of bank elements

	unsigned short	m_nbEltMemToDisk[MAX_TABREF],	// Size of elt cross-ref tables
					m_EltMemToDisk[MAX_TABREF],		// Element memory index -> element disk index
					m_EltDiskToMem[MAX_TABREF],		// Element disk index -> memory index

					m_tabNbCpt[MAX_TABREF];			// Sizes of usage count tables
	long *			m_tabAdCpt[MAX_TABREF];			// Usage count tables of bank elements

	// Binary files
	#ifdef STAND_ALONE
		CTypedPList<CBinaryFile>	m_binaryFiles;	// Embeded files
	#else
		unsigned int m_binaryFiles[8];
	#endif

	// Temporary images
	unsigned int	m_nImagesTemp;			// List of temporary images (used by Replace Color action)
	LPBYTE			m_pImagesTemp;

	// Frame objects
	int				m_oiMaxIndex;
	int				m_oiMaxHandle;
	unsigned short * m_oi_handle_to_index;
	OI **			m_ois;
	int				m_oiFranIndex;			// for enumerating
	int				m_oiExtFranIndex;		// for enumerating

	// Sub-application
	CRunApp *		m_pParentApp;			// Parent application
	void *			m_pSubAppObject;		// LPRS
	unsigned long	m_dwSubAppOptions;		// Sub-app options
	BOOL			m_bSubAppIsVisible;		// Sub-app visibility
	HICON			m_hSubAppIcon;			// Sub-app icon
	int				m_cx;					// Subapp: valid if stretch
	int				m_cy;

	// DLL infos
	Appli *			m_idAppli;				// App object in DLL
	int				m_nDepth;				// Screen depth
	cSurface*		m_protoLogScreen;		// Surface prototype

	// Edit window
	HWND			m_hEditWin;				// Edit Window handle
	npWin			m_idEditWin;			// Edit Window identifier

	// Current frame
	CRunFrame*		m_Frame;				// Pointer to current frame

	// Run-time status
	int				m_bResizeTimer,
					m_refTime,
					m_appRunningState,
					m_startFrame,
					m_nextFrame,
					m_nCurrentFrame;
	BOOL			m_bWakeUp;
	unsigned short	m_oldFlags,
					m_appRunFlags;
	BOOL			m_bPlayFromMsgProc;

	// Debugger
	CDebugger*		m_pDebugger;

	// Full Screen
	int				m_depthFullScreen;
	WINDOWPLACEMENT m_sWndPlacement;		// Window position backup
	int				m_oldCxMax,				// Window size backup
					m_oldCyMax;
	cSurface *		m_pFullScreenSurface;

	// Global data
	BOOL			m_bSharePlayerCtrls,	// Sub-app: TRUE if shares player controls
					m_bShareLives,			// Sub-app: TRUE if shares lives
					m_bShareScores,			// Sub-app: TRUE if shares scores
					m_bShareGlobalValues,	// Sub-app: TRUE if shares global values
					m_bShareGlobalStrings;	// Sub-app: TRUE if shares global strings

	// Players
	fpPlayerCtrls	m_pPlayerCtrls;
	long *			m_pLives,
		 *			m_pScores;

	// Global values (warning: not valid if sub-app and global values are shared)
	LPBYTE			m_pGlobalValuesInit;
	int				m_nGlobalValues;		// Number of global values
	CValue *		m_pGlobalValues;		// Global values
	unsigned char *	m_pFree,				// No longer used
				  *	m_pGlobalValueNames,

	// Global strings (warning: not valid if sub-app and global values are shared)
				  *	m_pGlobalStringInit;	// Default global string values
	int				m_nGlobalStrings;		// Number of global strings
	TCHAR **		m_pGlobalString;		// Pointers to global strings
	LPBYTE			m_pGlobalStringNames;

	// Global objects
	LPBYTE			m_AdGO;					// Global objects data

	// FRANCOIS
	short			m_NConditions[NUMBEROF_SYSTEMTYPES+KPX_BASE-1];

	// External sound files
	TCHAR *			m_pExtMusicFile;
	TCHAR *			m_pExtSampleFile[32];		// External sample file per channel

	// New Build 243
	int				m_nInModalLoopCount;
	TCHAR *			m_pPlayerNames;
	unsigned int			m_dwColorCache;

	// New Build 245
	LPBYTE			m_pVtz4Opt;			// not used
	unsigned int			m_dwFree;			// not used

	// Application load
	TCHAR *			m_pLoadFilename;
	unsigned int			m_saveVersion;
	BOOL			m_bLoading;

	// Bluray
	LPVOID			m_pBROpt;

	// Build info
	AppHeader2*		m_pHdr2;

	// Code page
#ifdef _UNICODE
	unsigned int			m_dwCodePage;
	bool			m_bUnicodeAppFile;
#endif

	// Effects
#ifdef HWABETA
	LPBYTE			m_pEffects;							// effects used in the application
	cSurface*		m_pOldSecondarySurface;				// secondary surface of the last frame, used in transitions
	bool			m_bAlwaysUseSecondarySurface;		// at least one frame has a transition => always use a secondary surface in all the frames
	bool			m_bShowWindowedMenu;				// to show menu after switch from full screen to windowed mode
	int				m_nSubAppShowCount;					// to show the child window otherwise it's not displayed...
#endif // HWABETA

};
typedef CRunApp*	fpRunApp;

#endif // RUN_TIME

#endif // _cncinc_h
